!function(){"use strict";function e(e,t){var n=hub();return put(brick(16711680,e,t,t)).on(n),put(brick(65280,t,e,t)).on(n),put(brick(255,t,t,e)).on(n),n}pliny.function({name:"axis",description:"Creates a set of reference axes, with X as red, Y as green, and Z as blue.",parameters:[{name:"length",type:"Number",description:"The length each axis should be in its own axis."},{name:"width",type:"Number",description:"The size each axis should be in the other axes."}],returns:"THREE.Object3D",examples:[{name:"Basic usage",description:'To create a fixed point of reference in the scene, use the `axis()` function.:\n\n    grammar("JavaScript");\n    var scene = new THREE.Scene()\n    // This set of axis bars will each be 1 meter long and 5cm wide.\n    // They\'ll be centered on each other, so the individual halves\n    // of the bars will only extend half a meter.\n    scene.add(axis(1, 0.05));\n\nThe result should appear as:\n\n![screenshot](images/axis.png)'}]}),"undefined"!=typeof window&&(window.axis=e)}(),function(){"use strict";function e(e,t,n){return void 0===t&&(t=e),void 0===n&&(n=e),cache("BoxGeometry("+e+", "+t+", "+n+")",function(){return new THREE.BoxGeometry(e,t,n)})}pliny.function({name:"box",description:'A shortcut function for the THREE.BoxGeometry class. Creates a "rectilinear prism", i.e. the general class of rectangular objects that includes cubes.',parameters:[{name:"width",type:"Number",description:"The size of the box in the X dimension."},{name:"height",type:"Number",optional:!0,description:"The size of the box in the Y dimension. If height is not provided, it will be set to the width parameter."},{name:"length",type:"Number",optional:!0,description:"The size of the box in the Z dimension. If length is not provided, it will be set to the width parameter."}],returns:"THREE.BoxGeometry",examples:[{name:"Basic usage",description:'Three.js separates geometry from materials, so you can create shared materials and geometry that recombine in different ways. To create a simple box geometry object that you can then add a material to create a mesh:\n  \n    grammar("JavaScript");\n    var geom = box(1, 2, 3),\n      mesh = textured(geom, 0xff0000);\n    put(mesh)\n      .on(scene)\n      .at(-2, 1, -5);\n\nIt should look something like this:\n<img src="images/box.jpg">'}]}),"undefined"!=typeof window&&(window.box=e)}(),function(){"use strict";function e(e,t,n,r){return textured(box(t||1,n||1,r||1),e,{txtRepeatS:t,txtRepeatT:r})}pliny.function({name:"brick",description:"Creates a textured box. See [`box()`](#box) and [`textured()`](#textured). The texture will be repeated across the box.",parameters:[{name:"txt",type:"Texture description",description:"The texture to apply to the box."},{name:"width",type:"Number",optional:!0,description:"The size of the box in the X dimension.",default:1},{name:"height",type:"Number",optional:!0,description:"The size of the box in the Y dimension.",default:1},{name:"length",type:"Number",optional:!0,description:"The size of the box in the Z dimension.",default:1}],returns:"THREE.Mesh",examples:[{name:"Basic usage",description:'To create a textured brick with the `brick()` function.:\n\n    grammar("JavaScript");\n    var mesh = brick(DECK, 1, 2, 3);\n    put(mesh)\n      .on(scene)\n      .at(-2, 1, -5);\n\nThe result should appear as:\n\n![screenshot](images/brick.jpg)'}]}),"undefined"!=typeof window&&(window.brick=e)}(),function(){"use strict";pliny.function({name:"cache",description:"Looks for the hashed name of the object in the object cache, and if it exists, returns it. If it doesn't exist, calls the makeObject function, using the return results to set the object in the cache, and returning it. In other words, a simple sort of memoization.",parameters:[{name:"hash",type:"String",description:"The hash key for the object to cache or retrieve."},{name:"makeObject",type:"Function",description:"A function that creates the object we want, if it doesn't already exist in the cache."}],returns:"Object",examples:[{name:"Basic usage",description:'Using the `cache()` function lets you create an object once and retrieve it back again with the same function call.\n\n    grammar("JavaScript");\n    function makeCube(i){\n      return cache("cubeGeom" + i, function(){\n        return new THREE.BoxGeometry(i, i, i);\n      });\n    }\n    \n    var a = makeCube(1),\n        b = makeCube(2),\n        c = makeCube(1);\n    \n    console.assert(a !== b);\n    console.assert(a === c);'}]});var e=function(){var e={};return function(t,n){return e[t]||(e[t]=n()),e[t]}}();"undefined"!=typeof window&&(window.cache=e)}(),function(){"use strict";function e(e){return JSON.parse(JSON.stringify(e))}pliny.function({name:"clone",parameters:[{name:"obj",type:"Object",description:"The object-literal to clone"}],description:"Creates a copy of a JavaScript object literal.",examples:[{name:"Create a copy of an object.",description:'To create a copy of an object that can be modified without modifying the original object, use the `clone()` function:\n\n    grammar("JavaScript");\n    var objA = { x: 1, y: 2 },\n        objB = clone(objA);\n    console.assert(objA !== objB);\n    console.assert(objA.x === objB.x);\n    console.assert(objA.y === objB.y);\n    objB.x = 3;\n    console.assert(objA.x !== objB.x);'}]}),"undefined"!=typeof window&&(window.clone=e)}(),function(){"use strict";function e(e,t,n){for(var r=new THREE.Geometry,i=0;i<e.length;++i)r.vertices.push(e[i]);var o=cache("PointsMaterial("+t+", "+n+")",function(){return new THREE.PointsMaterial({color:t,size:n})});return new THREE.Points(r,o)}pliny.function({name:"cloud",description:"Creates a point cloud with points of a fixed color and size out of an array of vertices.",parameters:[{name:"verts",type:"Array",description:"An array of `THREE.Vector3`s to turn into a `THREE.Points` object."},{name:"c",type:"Number",description:"A hexadecimal color value to use when creating the `THREE.PointsMaterial` to go with the point cloud."},{name:"s",type:"Number",description:"A numeric size value to use when creating the `THREE.PointsMaterial` to go with the point cloud."}],returns:"THREE.Points",examples:[{name:'Create randomized "dust".',description:'Creating a cloud is pretty simple.\n\n    grammar("JavaScript");\n    var verts = [],\n        R = Primrose.Random.number,\n        WIDTH = 10,\n        HEIGHT = 10,\n        DEPTH = 10;\n    \n    for (var i = 0; i< 5000; ++i) {\n      verts.push(v3(R(-0.5 * WIDTH, 0.5 * WIDTH),\n                    R(-0.5 * HEIGHT, 0.5 * HEIGHT),\n                    R(-0.5 * DEPTH, 0.5 * DEPTH)));\n    }\n    put(cloud(verts, 0x7f7f7f 0.05))\n      .on(scene)\n      .at(WIDTH / 2 , HEIGHT / 2, DEPTH / 2);\n\nThe results should look like this:\n\n<img src="images/cloud.jpg">'}]}),"undefined"!=typeof window&&(window.cloud=e)}(),function(){"use strict";function e(e,n,r){for(var i=[{dest:e,source:n}];i.length>0;){var o=i.pop();n=o.source,e=o.dest;for(var s in n)r||"object"!==t(n[s])||n[s]instanceof String?e[s]=n[s]:(e[s]||(e[s]={}),i.push({dest:e[s],source:n[s]}))}return e}var t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};pliny.function({name:"copyObject",description:"Copies properties from one object to another, essentially cloning the source object into the destination object. Uses a local stack to perform recursive copying. Overwrites any fields that already exist in the destination. For convenience, also returns the destination object.",parameters:[{name:"dest",type:"Object",description:"The object to which to copy fields."},{name:"source",type:"Object",description:"The object from which to copy fields."},{name:"shallow",type:"Boolean",optional:!0,default:"false",description:"Pass true to avoid recursing through object and only perform a shallow clone."}],returns:"Object",examples:[{name:"Copy an object.",description:'Blah blah blah\n\n    grammar("JavaScript");\n    var dest = {\n        a: 1,\n        b: 2,\n        c: {\n          d: 3\n        }\n      },\n      src = {\n        b: 5,\n        c: {\n          e: 6\n        },\n        f: 7\n      };\n    \n    copyObject(dest, src);\n    console.assert(dest.a === 1);\n    console.assert(dest.b === 5);\n    console.assert(dest.c.d === 3);\n    console.assert(dest.c.e === 6);\n    console.assert(dest.f === 7);'}]}),"undefined"!=typeof window&&(window.copyObject=e)}(),function(){"use strict";function e(e,t,n,r,i,o,s,a){return void 0===e&&(e=.5),void 0===t&&(t=.5),void 0===n&&(n=1),cache("CylinderGeometry("+e+", "+t+", "+n+", "+r+", "+i+", "+o+", "+s+", "+a+")",function(){return new THREE.CylinderGeometry(e,t,n,r,i,o,s,a)})}pliny.function({name:"cylinder",description:"Shorthand functino for creating a new THREE.CylinderGeometry object.",parameters:[{name:"rT",type:"Number",optional:!0,description:"The radius at the top of the cylinder.",default:.5},{name:"rB",type:"Number",optional:!0,description:"The radius at the bottom of the cylinder.",default:.5},{name:"height",type:"Number",optional:!0,description:"The height of the cylinder.",default:1},{name:"rS",type:"Number",optional:!0,description:"The number of sides on the cylinder.",default:8},{name:"hS",type:"Number",optional:!0,description:"The number of slices along the height of the cylinder.",default:1},{name:"openEnded",type:"Boolean",optional:!0,description:"Whether or not to leave the end of the cylinder open, thereby making a pipe.",default:!1},{name:"thetaStart",type:"Number",optional:!0,description:"The angle at which to start sweeping the cylinder.",default:0},{name:"thetaEnd",type:"Number",optional:!0,description:"The angle at which to end sweeping the cylinder.",default:2*Math.PI}],returns:"THREE.CylinderGeometry",examples:[{name:"Basic usage",description:'Three.js separates geometry from materials, so you can create shared materials and geometry that recombine in different ways. To create a simple cylinder geometry object that you can then add a material to create a mesh: \n  \n    grammar("JavaScript");\n    var geom = cylinder(),\n      mesh = textured(geom, 0xff0000);\n    put(mesh)\n      .on(scene)\n      .at(-2, 1, -5);\n\nIt should look something like this:\n<img src="images/cylinder.jpg">'}]}),"undefined"!=typeof window&&(window.cylinder=e)}(),function(){"use strict";function e(e){window.localStorage&&window.localStorage.removeItem(e)}pliny.function({name:"deleteSetting",parameters:[{name:" name",type:"string",description:"The name of the setting to delete."}],description:"Removes an object from localStorage",examples:[{name:"Basic usage",description:'\n    grammar("JavaScript");\n    console.assert(getSetting("A", "default-A") === "default-A");\n    setSetting("A", "modified-A");\n    console.assert(getSetting("A", "default-A") === "modified-A");\n    deleteSetting("A");\n    console.assert(getSetting("A", "default-A") === "default-A");'}]}),"undefined"!=typeof window&&(window.deleteSetting=e)}(),function(){"use strict";function e(e,t){for(var n=this.listeners&&this.listeners[e]||this._listeners&&this._listeners[e],r=0;n&&r<n.length;++r)n[r](t)}pliny.function({name:"emit",description:"A shorthand function for triggering events. Can be `.call()`ed on objects that have a `listeners` property.",parameters:[{name:"evt",type:"String",description:"The name of the event to trigger."},{name:"args",type:"Array",optional:!0,description:"Arguments to pass to the event."}],examples:[{name:"Basic usage",description:'    grammar("JavaScript");\n    function MyClass(){\n      this.listeners = {\n        myevent: []\n      };\n    }\n    \n    MyClass.prototype.addEventListener = function(evt, thunk){\n      this.listeners[evt].push(thunk);\n    };\n    \n    MyClass.prototype.execute = function(){\n      emit.call(this, "myevent", { a: 1, b: 2});\n    };\n    \n    var obj = new MyClass();\n    obj.addEventListener("myevent", function(evt){\n      console.assert(evt.a === 1);\n      console.assert(evt.b === 2);\n    });\n    obj.execute();'}]}),"undefined"!=typeof window&&(window.emit=e)}(),function(){"use strict";function e(e,t){for(var n=0;n<t.length;++n)if(void 0!==e[t[n]])return t[n]}pliny.function({name:"findProperty",description:"Searches an object for a property that might go by different names in different browsers.",parameters:[{name:"elem",type:"Object",description:"The object to search."},{name:"arr",type:"Array",description:"An array of strings that lists the possible values for the property name."}],returns:"String",examples:[{name:"Find the right name of the fullScree element.",description:'    grammar("JavaScript");\n    var elementName = findProperty(document, ["fullscreenElement", "mozFullScreenElement", "webkitFullscreenElement", "msFullscreenElement"]);\n    console.assert(!isFirefox || elementName === "mozFullScreenElement");\n    console.assert(!isChrome || elementName === "webkitFullscreenElement");\n    console.assert(!isIE || elementName === "msFullscreenElement");'}]}),"undefined"!=typeof window&&(window.findProperty=e)}(),function(){"use strict";function e(e,n){if(window.localStorage){var r=window.localStorage.getItem(e);if(r)try{return JSON.parse(r)}catch(n){console.error("getSetting",e,r,"undefined"==typeof r?"undefined":t(r),n),console.error(n),console.error("getSetting",e,r,"undefined"==typeof r?"undefined":t(r))}}return n}var t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};pliny.function({name:"getSetting",parameters:[{name:" name",type:"string",description:"The name of the setting to read."},{name:"defValue",type:"Object",description:"The default value to return, if the setting is not present in `localStorage`."}],returns:"The Object stored in `localStorage` for the given name, or the default value provided if the setting doesn't exist in `localStorage`.",description:"Retrieves named values out of `localStorage`. The values should\nbe valid for passing to `JSON.parse()`. A default value can be specified in the\nfunction call that should be returned if the value does not exist, or causes an\nerror in parsing. Typically, you'd call this function at page-load time after having\ncalled the [`setSetting()`](#setSetting) function during a previous page session.",examples:[{name:"Basic usage",description:'Assuming a text input element with the id `text1`, the following\ncode should persist between reloads whatever the user writes in the text area:\n\n    grammar("JavaScript");\n    var text1 = document.getElementById("text1");\n    document.addEventListener("unload", function(){\n      setSetting("text1-value", text1.value);\n    }, false);\n    document.addEventListener("load", function(){\n      text1.value = getSetting("text1-value", "My default value!");\n    }, false);'}]}),"undefined"!=typeof window&&(window.getSetting=e)}(),function(){"use strict";function e(){return new THREE.Object3D}pliny.function({name:"hub",description:"Calling `hub()` is a short-hand for creating a new `THREE.Object3D`. This is useful in live-coding examples to keep code terse and easy to write. It also polyfills in a method for being able to add the object to a `Primrose.BrowserEnvironment` using `appendChild()` and to add other elements to the hub using `appendChild()` such that they may be pickable in the scene.",examples:[{name:"Basic usage",description:"\n    //these two lines of code perform the same task.\n    var base1 = new THREE.Object3D();\n    var base2 = hub();"}]}),"undefined"!=typeof window&&(window.hub=e)}(),function(){"use strict";function e(e){return e}"undefined"!=typeof window&&(window.identity=e)}(),function(){"use strict";function e(e,t,n,r,i,o,s){THREE.Geometry.call(this),this.type="InsideSphereGeometry",this.parameters={radius:e,widthSegments:t,heightSegments:n,phiStart:r,phiLength:i,thetaStart:o,thetaLength:s},e=e||50,t=Math.max(3,Math.floor(t)||8),n=Math.max(2,Math.floor(n)||6),r=void 0!==r?r:0,i=void 0!==i?i:2*Math.PI,o=void 0!==o?o:0,s=void 0!==s?s:Math.PI;var a,c,u=[],l=[];for(c=0;c<=n;c++){var h=[],d=[];for(a=t;a>=0;a--){var p=a/t,m=c/n,f=new THREE.Vector3;f.x=-e*Math.cos(r+p*i)*Math.sin(o+m*s),f.y=e*Math.cos(o+m*s),f.z=e*Math.sin(r+p*i)*Math.sin(o+m*s),this.vertices.push(f),h.push(this.vertices.length-1),d.push(new THREE.Vector2(1-p,1-m))}u.push(h),l.push(d)}for(c=0;c<n;c++)for(a=0;a<t;a++){var y=u[c][a+1],g=u[c][a],v=u[c+1][a],w=u[c+1][a+1],b=this.vertices[y].clone().normalize(),x=this.vertices[g].clone().normalize(),P=this.vertices[v].clone().normalize(),T=this.vertices[w].clone().normalize(),E=l[c][a+1].clone(),k=l[c][a].clone(),_=l[c+1][a].clone(),S=l[c+1][a+1].clone();Math.abs(this.vertices[y].y)===e?(E.x=(E.x+k.x)/2,this.faces.push(new THREE.Face3(y,v,w,[b,P,T])),this.faceVertexUvs[0].push([E,_,S])):Math.abs(this.vertices[v].y)===e?(_.x=(_.x+S.x)/2,this.faces.push(new THREE.Face3(y,g,v,[b,x,P])),this.faceVertexUvs[0].push([E,k,_])):(this.faces.push(new THREE.Face3(y,g,w,[b,x,T])),this.faceVertexUvs[0].push([E,k,S]),this.faces.push(new THREE.Face3(g,v,w,[x.clone(),P,T.clone()])),this.faceVertexUvs[0].push([k.clone(),_,S.clone()]))}this.computeFaceNormals();for(var C=0;C<this.faces.length;++C){var R=this.faces[C];R.normal.multiplyScalar(-1);for(var O=0;O<R.vertexNormals.length;++O)R.vertexNormals[O].multiplyScalar(-1)}this.boundingSphere=new THREE.Sphere(new THREE.Vector3,e)}pliny.class({name:"InsideSphereGeometry",parameters:[{name:"radius",type:"Number",description:"How far the sphere should extend away from a center point."},{name:"widthSegments",type:"Number",description:"The number of faces wide in which to slice the geometry."},{name:"heightSegments",type:"Number",description:"The number of faces tall in which to slice the geometry."},{name:"phiStart",type:"Number",description:"The angle in radians around the Y-axis at which the sphere starts."},{name:"phiLength",type:"Number",description:"The change of angle in radians around the Y-axis to which the sphere ends."},{name:"thetaStart",type:"Number",description:"The angle in radians around the Z-axis at which the sphere starts."},{name:"thetaLength",type:"Number",description:"The change of angle in radians around the Z-axis to which the sphere ends."}],description:"The InsideSphereGeometry is basically an inside-out Sphere. Or\nmore accurately, it's a Sphere where the face winding order is reversed, so that\ntextures appear on the inside of the sphere, rather than the outside. I know, that's\nnote exactly helpful.\n\nSay you want a to model the sky as a sphere, or the inside of a helmet. You don't\ncare anything about the outside of this sphere, only the inside. You would use\nInsideSphereGeometry in this case. Or its alias, [`shell()`](#shell)."}),"undefined"!=typeof window.THREE&&(e.prototype=Object.create(THREE.Geometry.prototype),e.prototype.constructor=e),"undefined"!=typeof window&&(window.InsideSphereGeometry=e)}(),function(){"use strict";pliny.value({name:"isChrome",type:"Boolean",description:'Flag indicating the browser is currently calling itself Chrome\nor Chromium. Chromium was one of the first browsers to implement virtual reality\nfeatures directly in the browser, thanks to the work of Brandon "Toji" Jones.'});var e=!!window.chrome&&!window.isOpera;"undefined"!=typeof window&&(window.isChrome=e)}(),function(){"use strict";pliny.value({name:"isFirefox",type:"Boolean",description:"Flag indicating the browser is currently calling itself Firefox.\nFirefox was one of the first browsers to implement virtual reality features directly\nin the browser, thanks to the work of the MozVR team."});var e="undefined"!=typeof window.InstallTrigger;"undefined"!=typeof window&&(window.isFirefox=e)}(),function(){"use strict";pliny.value({name:"isGearVR",type:"Boolean",description:"Flag indicating the application is running on the Samsung Gear VR in the Samsung Internet app."});var e=navigator.userAgent.indexOf("Mobile VR")>-1;"undefined"!=typeof window&&(window.isGearVR=e)}(),function(){"use strict";pliny.value({name:"isIE",type:"Boolean",description:"Flag indicating the browser is currently calling itself Internet\nExplorer. Once the bane of every web developer's existence, it has since passed\nthe torch on to Safari in all of its many useless incarnations."});var e=!!document.documentMode;"undefined"!=typeof window&&(window.isIE=e)}(),function(){"use strict";pliny.value({name:"isHomeScreen",type:"Boolean",description:"Flag indicating the script is currently running in an IFRAME or not."});var e=window.self!==window.top;"undefined"!=typeof window&&(window.isInIFrame=e)}(),function(){"use strict";pliny.value({name:"isiOS",type:"Boolean",description:"Flag indicating the current system is a device running the Apple\niOS operating system: iPad, iPod Touch, iPhone. Useful for invoking optional code\npaths necessary to deal with deficiencies in Apple's implementation of web standards."});var e=/iP(hone|od|ad)/.test(navigator.userAgent||"");"undefined"!=typeof window&&(window.isiOS=e)}(),function(){"use strict";pliny.value({name:"isMobile",type:"Boolean",description:'Flag indicating the current system is a recognized "mobile"\ndevice, usually possessing a motion sensor.'});var e=function(e){return/(android|bb\d+|meego).+|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od|ad)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(e)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(e.substring(0,4))}(navigator.userAgent||navigator.vendor||window.opera);"undefined"!=typeof window&&(window.isMobile=e)}(),function(){"use strict";pliny.value({name:"isOpera",type:"Boolean",description:"Flag indicating the browser is currently calling itself Opera.\nOpera is a substandard browser that lags adoption of cutting edge web technologies,\nso you are not likely to need this flag if you are using Primrose, other than to\ncajole users into downloading a more advanced browser such as Mozilla Firefox or\nGoogle Chrome."});var e=!!window.opera||navigator.userAgent.indexOf(" OPR/")>=0;"undefined"!=typeof window&&(window.isOpera=e)}(),function(){"use strict";pliny.value({name:"isOSX",type:"Boolean",description:"Flag indicating the current system is a computer running the Apple\nOSX operating system. Useful for changing keyboard shortcuts to support Apple's\nidiosynchratic, concensus-defying keyboard shortcuts."});var e=/Macintosh/.test(navigator.userAgent||"");"undefined"!=typeof window&&(window.isOSX=e)}(),function(){"use strict";pliny.value({name:"isSafari",type:"Boolean",description:"Flag indicating the browser is currently calling itself Safari.\nSafari is an overly opinionated browser that thinks users should be protected from\nthemselves in such a way as to prevent users from gaining access to the latest in\ncutting-edge web technologies. Essentially, it was replaced Microsoft Internet\nExplorer as the Internet Explorer of the web."});var e=Object.prototype.toString.call(window.HTMLElement).indexOf("Constructor")>0;"undefined"!=typeof window&&(window.isSafari=e)}(),function(){"use strict";pliny.value({name:"isWebKit",type:"Boolean",description:"Flag indicating the browser is one of Chrome, Safari, or Opera.\nWebKit browsers have certain issues in common that can be treated together, like\na common basis for orientation events."});var e=!/iP(hone|od|ad)/.test(navigator.userAgent||"")||isOpera||isChrome;"undefined"!=typeof window&&(window.isWebKit=e)}(),function(){"use strict";pliny.value({name:"isWindows",type:"Boolean",description:"Flag indicating the current system is a computer running one of\nthe Microsoft Windows operating systems. We have not yet found a use for this flag."});var e=/Windows/.test(navigator.userAgent||"");"undefined"!=typeof window&&(window.isWindows=e)}(),function(){"use strict";function e(e,t,n,r){return new THREE.PointLight(e,t,n,r)}pliny.function({name:"light",description:"Shortcut function for creating a new THREE.PointLight object.",parameters:[{name:"color",type:"Number",optional:!0,description:"The RGB color value for the light.",default:"0xffffff"},{name:"intensity",type:"Number",optional:!0,description:"The strength of the light.",default:1},{name:"distance",type:"Number",optional:!0,description:"The distance the light will shine.",default:0},{name:"decay",type:"Number",optional:!0,description:"How much the light dims over distance.",default:1}],returns:"THREE.PointLight",examples:[{name:"Basic usage",description:'    grammar("JavaScript");\n    put(light(0xffff00)).on(scene).at(0, 100, 0);'}]}),"undefined"!=typeof window&&(window.light=e)}(),function(){"use strict";function e(e,t){e=e||{};for(var n in t)void 0!==e[n]&&null!==e[n]||(e[n]=t[n]);return e}pliny.function({name:"patch",parameters:[{name:"obj1",type:"Object",description:"The object to which to copy values that don't yet exist in the object."},{name:"obj2",type:"Object",description:"The object from which to copy values to obj1, if obj1 does not already have a value in place."}],returns:"Object - the obj1 parameter, with the values copied from obj2",description:"Copies values into Object A from Object B, skipping any value names that already exist in Object A.",examples:[{name:"Set default values.",description:"The `patch` function is intended to copy default values onto a user-supplied 'options' object, without clobbering the values they have provided.\n    var obj1 = {\n      a: 1,\n      b: 2,\n      c: 3\n    },\n      obj2 = {\n      c: 4,\n      d: 5,\n      e: 6\n    },\n      obj3 = patch(obj1, obj2);\n    console.assert(obj1 === obj3); // the returned object is exactly the same object as the first parameter.\n    console.assert(obj3.a === 1); // the `a` property did not exist in obj2\n    console.assert(obj3.b === 2); // the `b` property did not exist in obj2\n    console.assert(obj3.c === 3); // the `c` property existed in obj2, but it already existed in obj1, so it doesn't get overwritten\n    console.assert(obj3.d === 5); // the `d` property did not exist in obj1\n    console.assert(obj3.e === 6); // the `e` property did not exist in obj1"}]}),"undefined"!=typeof window&&(window.patch=e)}(),function(){"use strict";pliny.value({name:"PIXEL_SCALES",description:"Scaling factors for changing the resolution of the display when the render quality level changes."});var e=[.5,.25,.333333,.5,1];"undefined"!=typeof window&&(window.PIXEL_SCALES=e)}(),function(){"use strict";pliny.namespace({name:"Primrose",description:"Primrose helps you make VR applications for web browsers as easy as making other types of interactive web pages.\n\nThis top-level namespace contains classes for manipulating and viewing 3D environments."});var e={};"undefined"!=typeof window&&(window.Primrose=e)}(),function(){"use strict";function e(e){var t={on:null,at:null,rot:null,scale:null,obj:function(){return e}},n=function(n){return n.appendChild?n.appendChild(e):n.add(e),t.on=null,t.at||t.rot||t.scale?t:e},r=function(n,r,i){return e.position.set(n,r,i),t.at=null,t.on||t.rot||t.scale?t:e},i=function(n,r,i){return e.rotation.set(n,r,i),t.rot=null,t.on||t.at||t.scale?t:e},o=function(n,r,i){return e.scale.set(n,r,i),t.scale=null,t.on||t.at||t.rot?t:e};return t.on=n,t.at=r,t.rot=i,t.scale=o,t}pliny.function({name:"put",description:"A literate interface for putting objects onto scenes with basic, common transformations. You call `put()` with an object, then have access to a series of methods that you can chain together, before receiving the object back again. This makes it possible to create objects in the parameter position of `put()` at the same time as declaring the variable that will hold it.\n\n* .on(scene) - the Primrose.Entity or THREE.Object3D on which to append the element.\n* .at(x, y, z) - set the translation for the object.\n* .rot(x, y, z) - set the rotation for the object.\n* .scale(x, y, z) - set the scale for the object.\n* .obj() - return the naked object, if not all of the transformations are desired.",parameters:[{name:"object",type:"Object",description:"The object to manipulate."}],returns:"Object",examples:[{name:"Put an object on a scene at a specific location.",description:'    grammar("JavaScript");\n    var myCylinder = put(textured(cylinder(), 0x00ff00))\n      .on(scene)\n      .at(1, 2, 3)\n      .obj();'}]}),"undefined"!=typeof window&&(window.put=e)}(),function(){"use strict";function e(e,t,n,r){return void 0===t&&(t=e),cache("PlaneBufferGeometry("+e+", "+t+", "+n+", "+r+")",function(){return new THREE.PlaneBufferGeometry(e,t,n,r)})}pliny.function({name:"quad",description:"| [under construction]"}),"undefined"!=typeof window&&(window.quad=e)}(),function(){"use strict";pliny.enumeration({name:"Quality",description:"Graphics quality settings."});var e={NONE:0,VERYLOW:1,LOW:2,MEDIUM:3,HIGH:4,MAXIMUM:PIXEL_SCALES.length-1};"undefined"!=typeof window&&(window.Quality=e)}(),function(){"use strict";function e(e,t,n,r){for(var i=n&&e||0,o=n&&t||e,s=r&&n||1,a=r||n||t,c=i;c<o;c+=s)a(c)}pliny.function({name:"range",description:"| [under construction]"}),"undefined"!=typeof window&&(window.range=e)}(),function(){"use strict";function e(e){var t={};if(e)for(var n in e){var r=e[n];"INPUT"!==r.tagName&&"SELECT"!==r.tagName||r.dataset&&r.dataset.skipcache||("text"===r.type||"password"===r.type||"SELECT"===r.tagName?t[n]=r.value:"checkbox"!==r.type&&"radio"!==r.type||(t[n]=r.checked))}return t}pliny.function({name:"readForm",parameters:[{name:"ctrls",type:"Hash of Elements",description:"An array of HTML form elements, aka INPUT, TEXTAREA, SELECT, etc."}],returns:"Object",description:"Scans through an array of input elements and builds a state object that contains the values the input elements represent. Elements that do not have an ID attribute set, or have an attribute `data-skipcache` set, will not be included.",examples:[{name:"Basic usage",description:'Assuming the following HTML form:\n\n    grammar("HTML");\n    <form>\n      <input type="text" id="txt" value="hello">\n      <input type="number" id="num" value="5">\n    </form>\n\n##Code:\n\n    grammar("JavaScript");\n    var ctrls = findEverything();\n    ctrls.txt.value = "world";\n    ctrls.num.value = "6"6;\n    var state = readForm(ctrls);\n    console.assert(state.txt === "world");\n    console.assert(state.num === "6");\n    state.txt = "mars";\n    state.num = 55;\n    writeForm(ctrls, state);\n    console.assert(ctrls.txt.value === "mars");\n    console.assert(ctrls.num.value === "55");'
}]}),"undefined"!=typeof window&&(window.readForm=e)}(),function(){"use strict";function e(e){e.returnValue=!1}"undefined"!=typeof window&&(window.setFalse=e)}(),function(){"use strict";function e(e,n){if(window.localStorage&&n)try{window.localStorage.setItem(e,JSON.stringify(n))}catch(r){console.error("setSetting",e,n,"undefined"==typeof n?"undefined":t(n),r)}}var t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};pliny.function({name:"setSetting",parameters:[{name:" name",type:"string",description:"The name of the setting to set."},{name:"val",type:"Object",description:"The value to write. It should be useable as a parameter to `JSON.stringify()`."}],description:"Writes named values to `localStorage`. The values should be valid\nfor passing to `JSON.stringify()`. Typically, you'd call this function at page-unload\ntime, then call the [`getSetting()`](#getSetting) function during a subsequent page load.",examples:[{name:"Basic usage",description:'Assuming a text input element with the id `text1`, the following\ncode should persist between reloads whatever the user writes in the text area:\n\n    grammar("JavaScript");\n    var text1 = document.getElementById("text1");\n    document.addEventListener("unload", function(){\n      setSetting("text1-value", text1.value);\n    }, false);\n    document.addEventListener("load", function(){\n      text1.value = getSetting("text1-value", "My default value!");\n    }, false);'}]}),"undefined"!=typeof window&&(window.setSetting=e)}(),function(){"use strict";function e(e,t,n,r,i){var o=.45;void 0===r&&(r=Math.PI*o),void 0===i&&(i=Math.PI*o*.6);var s=1.5*Math.PI-.5*r,a=.5*(Math.PI-i);return cache("InsideSphereGeometry("+e+", "+t+", "+n+", "+r+", "+i+")",function(){return new InsideSphereGeometry(e,t,n,s,r,a,i,(!0))})}pliny.function({name:"shell",parameters:[{name:"radius",type:"Number",description:"How far the sphere should extend away from a center point."},{name:"widthSegments",type:"Number",description:"The number of faces wide in which to slice the geometry."},{name:"heightSegments",type:"Number",description:"The number of faces tall in which to slice the geometry."},{name:"phi",type:"Number",optional:!0,description:"The angle in radians around the Y-axis of the sphere.",default:"80 degrees."},{name:"thetaStart",type:"Number",optional:!0,description:"The angle in radians around the Z-axis of the sphere.",default:"48 degrees."}],description:"The shell is basically an inside-out sphere. Say you want a to model\nthe sky as a sphere, or the inside of a helmet. You don't care anything about the\noutside of this sphere, only the inside. You would use InsideSphereGeometry in this\ncase. It is mostly an alias for [`InsideSphereGeometry`](#InsideSphereGeometry).",examples:[{name:"Create a sky sphere",description:"To create a sphere that hovers around the user at a\nfar distance, showing a sky of some kind, you can use the `shell()` function in\ncombination with the [`textured()`](#textured) function. Assuming you have an image\nfile to use as the texture, execute code as such:\n\n    grammar(\"JavaScript\");\n    var sky = textured(\n      shell(\n          // The radius value should be less than your draw distance.\n          1000,\n          // The number of slices defines how smooth the sphere will be in the\n          // horizontal direction. Think of it like lines of longitude.\n          18,\n          // The number of rings defines how smooth the sphere will be in the\n          // vertical direction. Think of it like lines of latitude.\n          9,\n          // The phi angle is the number or radians around the 'belt' of the sphere\n          // to sweep out the geometry. To make a full circle, you'll need 2 * PI\n          // radians.\n          Math.PI * 2,\n          // The theta angle is the number of radians above and below the 'belt'\n          // of the sphere to sweep out the geometry. Since the belt sweeps a full\n          // 360 degrees, theta only needs to sweep a half circle, or PI radians.\n          Math.PI ),\n      // Specify the texture image next.\n      \"skyTexture.jpg\",\n      // Specify that the material should be shadeless, i.e. no shadows. This\n      // works best for skymaps.\n      {unshaded: true} );"}]}),"undefined"!=typeof window&&(window.shell=e)}(),function(){"use strict";function e(e,t,n){return cache("SphereGeometry("+e+", "+t+", "+n+")",function(){return new THREE.SphereGeometry(e,t,n)})}pliny.function({name:"sphere",description:"| [under construction]"}),"undefined"!=typeof window&&(window.sphere=e)}(),function(){"use strict";function e(e,t,r){r=r||{},void 0===r.opacity&&(r.opacity=1),void 0===r.txtRepeatS&&(r.txtRepeatS=1),void 0===r.txtRepeatT&&(r.txtRepeatT=1),void 0===r.roughness&&(r.roughness=.5),void 0===r.metalness&&(r.metalness=0),r.unshaded=!!r.unshaded,r.wireframe=!!r.wireframe;var i,o=null;if(t instanceof THREE.Material)o=t,t=null;else{var s=(t.id||t).toString();i="Primrose.textured("+s+", "+r.txtRepeatS+", "+r.txtRepeatT+")";var a="Primrose.material("+i+", "+r.unshaded+", "+r.opacity+", "+r.roughness+", "+r.metalness+", "+r.wireframe+", "+r.emissive+")";o=cache(a,function(){var e={transparent:r.opacity<1,opacity:r.opacity,side:r.side||THREE.FrontSide},t=THREE.MeshStandardMaterial;return r.unshaded?(e.shading=THREE.FlatShading,t=THREE.MeshBasicMaterial):(e.roughness=r.roughness,e.metalness=r.metalness,void 0!==r.emissive&&(e.emissive=r.emissive)),new t(e)})}o.wireframe=r.wireframe;var c=null;if(e.type.indexOf("Geometry")>-1?c=new THREE.Mesh(e,o):e instanceof THREE.Object3D&&(c=e,c.material=o),"number"==typeof t||t instanceof Number)o.color.set(t);else if(t){o.color.set(16777215);var u=function(t){var s;if(t instanceof Primrose.Surface&&(s=t,t=s.texture,!r.scaleTextureWidth||!r.scaleTextureHeight)){var a=s.imageWidth,c=s.imageHeight,u=Math.ceil(Math.log(a)/Math.LN2),l=Math.ceil(Math.log(c)/Math.LN2),h=Math.pow(2,u),d=Math.pow(2,l),p=a/h,m=c/d;1===p&&1===m||(1!==p&&(r.scaleTextureWidth=p),1!==m&&(r.scaleTextureHeight=m),s.bounds.width=h,s.bounds.height=d,s.resize(),s.render(!0))}if(r.txtRepeatS*r.txtRepeatT>1&&(t.wrapS=t.wrapT=THREE.RepeatWrapping,t.repeat.set(r.txtRepeatS,r.txtRepeatT)),r.scaleTextureWidth||r.scaleTextureHeight)if(e.attributes&&e.attributes.uv&&e.attributes.uv.array){var f,y=e.attributes.uv,g=y.array;if(r.scaleTextureWidth)for(f=0;f<g.length;f+=y.itemSize)g[f]*=r.scaleTextureWidth;if(r.scaleTextureHeight)for(f=1;f<g.length;f+=y.itemSize)g[f]=1-(1-g[f])*r.scaleTextureHeight}else console.trace(e);n[i]=t,o.map=t,o.needsUpdate=!0,t.needsUpdate=!0};n[i]?u(n[i]):t instanceof Primrose.Surface?(t._material=o,Primrose.Entity.registerEntity(t),u(t),c.surface=t):"string"==typeof t?Primrose.loadTexture(t).then(u).catch(console.error.bind(console,"Error loading texture",t)):u(t instanceof Primrose.Text.Controls.TextBox?t.renderer.texture:t instanceof HTMLCanvasElement?new THREE.Texture(t):t)}return c}var t=null,n={};Primrose.loadTexture=function(e){return t||(t=new THREE.TextureLoader),t.setCrossOrigin(THREE.ImageUtils.crossOrigin),cache("Image("+e+")",function(){return new Promise(function(n,r){return t.load(e,n,null,r)})})},pliny.function({name:"textured",description:"| [under construction]"}),"undefined"!=typeof window&&(window.textured=e)}(),function(){"use strict";function e(e,t,n){return new THREE.Vector3(e,t,n)}pliny.function({name:"v3",description:"A shortcut function for creating a new THREE.Vector3 object.",parameters:[{name:"x",type:"Number",description:"The X component of the vector"},{name:"y",type:"Number",description:"The Y component of the vector"},{name:"z",type:"Number",description:"The Z component of the vector"}],returns:"THREE.Vector3",examples:[{name:"Create a vector",description:'    grammar("JavaScript");\n    var a = v3(1, 2, 3);\n    console.assert(a.x === 1);\n    console.assert(a.y === 2);\n    console.assert(a.z === 3);\n    console.assert(a.toArray().join(", ") === "1, 2, 3");'}]}),"undefined"!=typeof window&&(window.v3=e)}(),function(){"use strict";function e(e,t){if(t)for(var n in e){var r=e[n];null===t[n]||void 0===t[n]||"INPUT"!==r.tagName&&"SELECT"!==r.tagName||r.dataset&&r.dataset.skipcache||("text"===r.type||"password"===r.type||"SELECT"===r.tagName?r.value=t[n]:"checkbox"!==r.type&&"radio"!==r.type||(r.checked=t[n]))}}pliny.function({name:"writeForm",parameters:[{name:"ctrls",type:"Hash of Elements",description:"A hash-collection of HTML input elements that will have their values set."},{name:"state",type:"Hash object",description:"The values that will be set on the form. Hash keys should match IDs of the elements in the `ctrls` parameter."}],description:"Writes out a full set of state values to an HTML input form, wherever keys in the `ctrls` parameter match keys in the `state` parameter.",examples:[{name:"Basic usage",description:'Assuming the following HTML form:\n\n    grammar("HTML");\n    <form>\n      <input type="text" id="txt" value="hello">\n      <input type="number" id="num" value="5">\n    </form>\n\n## Code:\n\n    grammar("JavaScript");\n    var ctrls = findEverything();\n    ctrls.txt.value = "world";\n    ctrls.num.value = "6"6;\n    var state = readForm(ctrls);\n    console.assert(state.txt === "world");\n    console.assert(state.num === "6");\n    state.txt = "mars";\n    state.num = 55;\n    writeForm(ctrls, state);\n    console.assert(ctrls.txt.value === "mars");\n    console.assert(ctrls.num.value === "55");'}]}),"undefined"!=typeof window&&(window.writeForm=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),n=function(){function n(){e(this,n),this._handlers={}}return t(n,[{key:"addEventListener",value:function(e,t){this._handlers[e]||(this._handlers[e]=[]),this._handlers[e].push(t)}},{key:"removeEventListener",value:function(e,t){if(this._handlers[e]){var n=this._handlers[e].indexOf(t);n>-1&&this._handlers[e].splice(n,1)}}},{key:"emit",value:function(e,t){if(this._handlers[e])for(var n=0;n<this._handlers[e].length;++n)this._handlers[e][n](t)}}]),n}();"undefined"!=typeof window&&(window.Primrose.AbstractEventEmitter=n)}(),function(){"use strict";function e(e){if("number"!=typeof e)throw new Error("Angle must be initialized with a number. Initial value was: "+e);var t,n,r,i=e,o=0;pliny.property({parent:"Primrose.Angle",name:"degrees",type:"Number",description:"Get/set the current value of the angle in degrees."}),Object.defineProperty(this,"degrees",{set:function(e){do t=e+o-i,n=Math.abs(t+360),r=Math.abs(t-360),t=Math.abs(t),n<t&&n<r?o+=360:r<t&&(o-=360);while(t>n||t>r);i=e+o},get:function(){return i}})}var t=Math.PI/180,n=180/Math.PI;pliny.class({parent:"Primrose",name:"Angle",description:"The Angle class smooths out the jump from 360 to 0 degrees. It\nkeeps track of the previous state of angle values and keeps the change between\nangle values to a maximum magnitude of 180 degrees, plus or minus. This allows for\nsmoother opperation as rotating past 360 degrees will not reset to 0, but continue\nto 361 degrees and beyond, while rotating behind 0 degrees will not reset to 360\nbut continue to -1 and below.\n\nWhen instantiating, choose a value that is as close as you can guess will be your\ninitial sensor readings.\n\nThis is particularly important for the 180 degrees, +- 10 degrees or so. If you\nexpect values to run back and forth over 180 degrees, then initialAngleInDegrees\nshould be set to 180. Otherwise, if your initial value is anything slightly larger\nthan 180, the correction will rotate the angle into negative degrees, e.g.:\n* initialAngleInDegrees = 0\n* first reading = 185\n* updated degrees value = -175\n\nIt also automatically performs degree-to-radian and radian-to-degree conversions.\nFor more information, see [Radian - Wikipedia, the free encyclopedia](https://en.wikipedia.org/wiki/Radian).\n\n![Radians](https://upload.wikimedia.org/wikipedia/commons/4/4e/Circle_radians.gif)",parameters:[{name:"initialAngleInDegrees",type:"Number",description:"(Required) Specifies the initial context of the angle. Zero is not always the correct value."}],examples:[{name:"Basic usage",description:'To use the Angle class, create an instance of it with `new`, and modify the `degrees` property.\n\n## Code:\n\n  grammar("JavaScript");\n  var a = new Primrose.Angle(356);\n  a.degrees += 5;\n  console.log(a.degrees);\n\n## Results:\n> 361'},{name:"Convert degrees to radians",description:'Create an instance of Primrose.Angle, modify the `degrees` property, and read the `radians` property.\n\n## Code:\n\n  grammar("JavaScript");\n  var a = new Primrose.Angle(10);\n  a.degrees += 355;\n  console.log(a.radians);\n\n## Results:\n> 0.08726646259971647'},{name:"Convert radians to degress",description:'Create an instance of Primrose.Angle, modify the `radians` property, and read the `degrees` property.\n\n## Code:\n\n  grammar("JavaScript");\n  var a = new Primrose.Angle(0);\n  a.radians += Math.PI / 2;\n  console.log(a.degrees);\n\n## Results:\n> 90'}]}),pliny.property({parent:"Primrose.Angle",name:"radians",type:"Number",description:"Get/set the current value of the angle in radians."}),Object.defineProperty(e.prototype,"radians",{get:function(){return this.degrees*t},set:function(e){this.degrees=e*n}}),"undefined"!=typeof window&&(window.Primrose.Angle=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=1,o="([+-]?(?:(?:\\d+(?:\\.\\d*)?)|(?:\\.\\d+)))",s="\\s*,\\s*",a="(?:em|px)",c=new RegExp("translate3d\\s*\\(\\s*"+o+a+s+o+a+s+o+a+"\\s*\\)","i"),u=new RegExp("rotate3d\\s*\\(\\s*"+o+s+o+s+o+s+o+"rad\\s*\\)","i");pliny.class({parent:"Primrose",name:"BaseControl",description:"The BaseControl class is the parent class for all 3D controls.\nIt manages a unique ID for every new control, the focus state of the control, and\nperforms basic conversions from DOM elements to the internal Control format."}),pliny.method({parent:"Primrose.BaseControl",name:"focus",description:"Sets the focus property of the control, does not change the focus property of any other control.",examples:[{name:"Focus on one control, blur all the rest",description:'When we have a list of controls and we are trying to track\nfocus between them all, we must coordinate calls between `focus()` and `blur()`.\n\n  grammar("JavaScript");\n  var ctrls = [\n    new Primrose.Text.Controls.TextBox(),\n    new Primrose.Text.Controls.TextBox(),\n    new Primrose.Text.Button()\n  ];\n\n  function focusOn(id){\n    for(var i = 0; i < ctrls.length; ++i){\n      var c = ctrls[i];\n      if(c.controlID === id){\n        c.focus();\n      }\n      else{\n        c.blur();\n      }\n    }\n  }'}]}),pliny.method({parent:"Primrose.BaseControl",name:"blur",description:"Unsets the focus property of the control, does not change the focus property of any other control.",examples:[{name:"Focus on one control, blur all the rest",description:'When we have a list of controls and we are trying to track\nfocus between them all, we must coordinate calls between `focus()` and `blur()`.\n\n  grammar("JavaScript");\n  var ctrls = [\n    new Primrose.Text.Controls.TextBox(),\n    new Primrose.Text.Controls.TextBox(),\n    new Primrose.Text.Button()\n  ];\n  \n  function focusOn(id){\n    for(var i = 0; i < ctrls.length; ++i){\n      var c = ctrls[i];\n      if(c.controlID === id){\n        c.focus();\n      }\n      else{\n        c.blur();\n      }\n    }\n  }'}]}),pliny.method({parent:"Primrose.BaseControl",name:"copyElement",description:"Copies properties from a DOM element that the control is supposed to match.",parameters:[{name:"elem",type:"Element",description:"The element--e.g. a button or textarea--to copy."}],examples:[{name:"Rough concept",description:'The class is not used directly. Its methods would be used in a base\nclass that implements its functionality.\n\nThe `copyElement()` method gets used when a DOM element is getting "converted"\nto a 3D element on-the-fly.\n\n  grammar("JavaScript");\n  var myDOMButton = document.querySelector("button[type=\'button\']"),\n    my3DButton = new Primrose.Controls.Button3D();\n  my3DButton.copyElement(myDOMButton);'}]});var l=function(o){function s(){e(this,s);var n=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this));return pliny.property({name:"controlID",type:"Number",description:"Automatically incrementing counter for controls, to make sure there is a distinct differentiator between them all."}),n.controlID=i++,pliny.property({name:"focused",type:"Boolean",description:"Flag indicating this control has received focus. You should theoretically only read it."}),n.focused=!1,n}return n(s,o),r(s,[{key:"focus",value:function(){this.focused=!0,this.emit("focus",{target:this})}},{key:"blur",value:function(){this.focused=!1,emit.call(this,"blur",{target:this})}},{key:"copyElement",value:function(e){if(this.element=e,e.style.transform){var t=c.exec(e.style.transform);t&&this.position.set(parseFloat(t[1]),parseFloat(t[2]),parseFloat(t[3])),t=u.exec(e.style.transform),t&&this.quaternion.setFromAxisAngle((new THREE.Vector3).set(parseFloat(t[1]),parseFloat(t[2]),parseFloat(t[3])),parseFloat(t[4]))}}}]),s}(Primrose.AbstractEventEmitter);"undefined"!=typeof window&&(window.Primrose.BaseControl=l)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=.001;pliny.class({parent:"Primrose",name:"BrowserEnvironment",description:"Make a Virtual Reality app in your web browser!"});var o=function(o){function s(n){function r(e){for(var t="",n=0;n<e.length;++n)n>0&&(t+=","),t+=e[n];return t}function o(e){var t=e.clone(),n=t.getHSL();for(n.h=n.h+.5,n.l=1-n.l;n.h>1;)n.h-=1;return t.setHSL(n.h,n.s,n.l),t}var a=arguments;e(this,s);var c=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this));c.options=patch(n,s.DEFAULTS),c.options.foregroundColor=c.options.foregroundColor||o(new THREE.Color(c.options.backgroundColor)).getHex(),c.zero=function(){c.input.lockMovement||(c.input.zero(),c.quality===Quality.NONE&&(c.quality=Quality.HIGH))};var u=function(e,t){var n=e;"Object3D"!==e.type&&"Group"!==e.type||!e.children[0]||(n=e.children[0],n.name=n.name||e.name);for(var i,o=n.uuid,s=new THREE.Matrix4,a=(new THREE.Matrix4).identity(),u=!1,h=l[o],d=!1,p=!!e.disabled,m={uuid:o,name:null,inScene:null,visible:null,disabled:null,matrix:null,geometry:null},f=n;null!==f;)f.updateMatrix(),s.copy(f.matrix),s.multiply(a),i=s,s=a,a=i,f=f.parent,u=u||f===c.scene;h&&h.visible===e.visible||(d=!0,m.visible=e.visible),h&&h.disabled===p||(d=!0,m.disabled=p);var y=a.elements.subarray(0,a.elements.length),g=r(y);if(h&&h.matrix&&r(h.matrix)===g||(d=!0,m.matrix=y),h&&h.inScene===u||(d=!0,m.inScene=u),t===!0&&(d=!0,m.name=e.name,m.geometry=n.geometry),d){if(h)for(var v in m)h[v]=m[v];else l[o]=m;return m}},l={};c.registerPickableObject=function(e){if(e){var t,n,r,i,o=u(e,!0),s=o.geometry;if(s instanceof THREE.BufferGeometry){var a=s.attributes,l=a.position,h=a.uv,d=a.index;for(t=[],n=[],h&&(r=[]),i=0;i<l.count;++i)t.push([l.getX(i),l.getY(i),l.getZ(i)]),h&&r.push([h.getX(i),h.getY(i)]);if(d)for(i=0;i<d.count-2;++i)n.push([d.getX(i),d.getX(i+1),d.getX(i+2)]);else for(i=0;i<l.count;i+=3)n.push([i,i+1,i+2])}else for(t=s.vertices.map(function(e){return e.toArray()}),n=[],r=[],i=0;i<s.faces.length;++i){var p=s.faces[i],m=s.faceVertexUvs[0][i];n.push([p.a,p.b,p.c]),r[p.a]=[m[0].x,m[0].y],r[p.b]=[m[1].x,m[1].y],r[p.c]=[m[2].x,m[2].y]}o.geometry={uuid:s.uuid,vertices:t,faces:n,uvs:r},c.pickableObjects[o.uuid]=e,c.projector.setObject(o)}};var h=null,d={},p=function(e){c.projector.ready=!0,h=d,d=e},m=function(e){var t=e-x;x=e,f(t),c.input.resolvePicking(d,h,c.pickableObjects),y(),g(),c.network.update(t),G(),c.emit("update",t)},f=function(e){if(c.input.update(e),c.projector.ready){c.projector.ready=!1;var t=[],n=[];for(var r in c.pickableObjects){var i=c.pickableObjects[r],o=u(i);o&&(t.push(o),o.inScene===!1&&n.push(r))}t.length>0&&c.projector.updateObjects(t);for(var s=0;s<n.length;++s)delete c.pickableObjects[n[s]];c.projector.projectPointers(c.input.segments)}},y=function(){c.sky&&c.sky.position.copy(c.input.head.position)},g=function(){c.ground&&(c.ground.position.set(Math.floor(c.input.head.position.x),-.02,Math.floor(c.input.head.position.z)),c.ground.material.needsUpdate=!0)},v=function e(t){m(t*i),w(),A(e)},w=function(){if(c.camera.position.set(0,0,0),c.camera.quaternion.set(0,0,0,1),c.audio.setPlayer(c.input.head.mesh),c.input.VR.isPresenting){c.renderer.clear(!0,!0,!0);for(var e=c.input.VR.getTransforms(c.options.nearPlane,c.options.nearPlane+c.options.drawDistance),t=0;e&&t<e.length;++t){var n=e[t],r=n.viewport;Primrose.Entity.eyeBlankAll(t),c.camera.projectionMatrix.copy(n.projection),c.camera.translateOnAxis(n.translation,1),c.renderer.setViewport(r.left*T,r.top*T,r.width*T,r.height*T),c.renderer.render(c.scene,c.camera),c.camera.translateOnAxis(n.translation,-1)}c.input.submitFrame()}(!c.input.VR.isPresenting||c.input.VR.canMirror&&!c.options.disableMirroring)&&(c.camera.fov=c.options.defaultFOV,c.camera.aspect=c.renderer.domElement.width/c.renderer.domElement.height,c.camera.updateProjectionMatrix(),c.renderer.clear(!0,!0,!0),c.renderer.setViewport(0,0,c.renderer.domElement.width,c.renderer.domElement.height),c.renderer.render(c.scene,c.camera))},b=function(){var e=c.input.VR.getTransforms(c.options.nearPlane,c.options.nearPlane+c.options.drawDistance);if(e){for(var t=0,n=0,r=0;r<e.length;++r)t+=e[r].viewport.width,n=Math.max(n,e[r].viewport.height);t=Math.floor(t*T),n=Math.floor(n*T),c.renderer.domElement.width=t,c.renderer.domElement.height=n,c.timer||w()}},x=0,P=(new THREE.Quaternion,new THREE.Vector3,new THREE.Vector3,{scene:c.options.sceneModel,avatar:c.options.avatarModel,button:c.options.button&&"string"==typeof c.options.button.model&&c.options.button.model,font:c.options.font}),T=1,E={button:Primrose.Controls.Button2D,img:Primrose.Controls.Image,div:Primrose.Controls.HtmlDoc,section:Primrose.Surface,textarea:Primrose.Text.Controls.TextBox,avatar:null,pre:{create:function(){return new Primrose.Text.Controls.TextBox({tokenizer:Primrose.Text.Grammars.PlainText,hideLineNumbers:!0,readOnly:!0})}}};c.factories=E,c.createElement=function(e){if(E[e])return E[e].create()},c.appendChild=function(e){return e instanceof THREE.Mesh?(c.scene.add(e),void c.registerPickableObject(e)):e.addToBrowserEnvironment(c,c.scene)};var k=Primrose.ModelLoader.loadObjects(P).then(function(e){window.text3D=function(e,t,n){var r=new THREE.TextGeometry(n,{font:e,size:t,height:t/5,curveSegments:2});return r.computeBoundingSphere(),r.computeBoundingBox(),r}.bind(window,e.font),e.scene&&M(e.scene),e.avatar&&(E.avatar=new Primrose.ModelLoader(e.avatar)),e.button?c.buttonFactory=new Primrose.ButtonFactory(e.button,c.options.button.options):c.buttonFactory=new Primrose.ButtonFactory(brick(16711680,1,1,1),{maxThrow:.1,minDeflection:10,colorUnpressed:8323072,colorPressed:32512,toggle:!0})}).catch(function(e){console.error(e),c.buttonFactory||(c.buttonFactory=new Primrose.ButtonFactory(brick(16711680,1,1,1),{maxThrow:.1,minDeflection:10,colorUnpressed:8323072,colorPressed:32512,toggle:!0}))});c.avatarHeight=c.options.avatarHeight,c.walkSpeed=c.options.walkSpeed,c.audio=new Primrose.Output.Audio3D;var _=null,S=null;_=c.options.ambientSound&&!isMobile?c.audio.load3DSound(c.options.ambientSound,!0,-1,1,-1).then(function(e){S=e,S.source instanceof MediaElementAudioSourceNode||(S.volume.gain.value=.1,console.log(S.source),S.source.start())}).catch(console.error.bind(console,"Audio3D loadSource")):Promise.resolve();var C=null;if(C="complete"===document.readyState?Promise.resolve("already"):new Promise(function(e,t){document.addEventListener("readystatechange",function(t){"complete"===document.readyState&&e("had to wait for it")},!1)}),c.music=new Primrose.Output.Music(c.audio.context),c.pickableObjects={},c.projector=new Primrose.Workerize(Primrose.Projector),c.options.scene=c.scene=c.options.scene||new THREE.Scene,c.options.useFog&&(c.scene.fog=new THREE.FogExp2(c.options.backgroundColor,2/c.options.drawDistance)),c.camera=new THREE.PerspectiveCamera(75,1,c.options.nearPlane,c.options.nearPlane+c.options.drawDistance),void 0!==c.options.skyTexture&&(c.sky=textured(shell(c.options.drawDistance,18,9,2*Math.PI,Math.PI),c.options.skyTexture,{unshaded:!0}),c.sky.name="Sky",c.scene.add(c.sky)),void 0!==c.options.groundTexture){var R=10,O=new THREE.PlaneGeometry(5*R,5*R,R,R);c.ground=textured(O,c.options.groundTexture,{txtRepeatS:5*R,txtRepeatT:5*R}),void 0!==c.options.sceneModel&&(c.ground.position.y=-.02),c.ground.rotation.x=-Math.PI/2,c.ground.name="Ground",c.scene.add(c.ground),c.registerPickableObject(c.ground)}c.passthrough&&c.camera.add(c.passthrough.mesh);var M=function(e){return e.buttons=[],e.traverse(function(t){t.isButton&&e.buttons.push(new Primrose.Controls.Button3D(t.parent,t.name)),t.name&&(e[t.name]=t)}),c.scene.add.apply(c.scene,e.children),c.scene.traverse(function(e){c.options.disableDefaultLighting&&e.material&&e.material.map&&textured(e,e.material.map,{unshaded:!0}),e.name&&(c.scene[e.name]=e)}),e.Camera&&(c.camera.position.copy(e.Camera.position),c.camera.quaternion.copy(e.Camera.quaternion)),e};put(light(16777215,1.5,50)).on(c.scene).at(0,10,10);var I=null;c.timer=0;var A=function(e){I=c.input.VR.currentDevice||window,null!==c.timer&&(c.timer=I.requestAnimationFrame(e))};c.goFullScreen=function(e,t){"Gaze"!==t&&(c.input.VR.connect(e),c.input.VR.requestPresent([{source:c.renderer.domElement}]).catch(function(e){return console.error("whaaat",e)}).then(function(){return c.renderer.domElement.focus()}))};var j=function(e){c.scene.add(e.stage),c.scene.add(e.head)},N=function(e){c.scene.remove(e.stage),c.scene.remove(e.head)};window.addEventListener("keydown",function(e){c.input.VR.isPresenting&&(e.keyCode!==Primrose.Keys.ESCAPE||c.input.VR.isPolyfilled||c.input.VR.cancel())}),PointerLock.addChangeListener(function(e){c.input.VR.isPresenting&&!PointerLock.isActive&&c.input.VR.cancel()}),window.addEventListener("vrdisplaypresentchange",function(e){c.input.VR.isPresenting||c.input.VR.cancel(),b()}),window.addEventListener("resize",b,!1),window.addEventListener("blur",c.stop,!1),window.addEventListener("focus",c.start,!1),c.projector.addEventListener("hit",p,!1),C=C.then(function(){return c.options.renderer?c.renderer=c.options.renderer:(c.renderer=new THREE.WebGLRenderer({canvas:Primrose.DOM.cascadeElement(c.options.canvasElement,"canvas",HTMLCanvasElement),context:c.options.context,antialias:c.options.antialias,alpha:!0,logarithmicDepthBuffer:!1}),c.renderer.autoClear=!1,c.renderer.sortObjects=!0,c.renderer.setClearColor(c.options.backgroundColor),c.renderer.domElement.parentElement||document.body.appendChild(c.renderer.domElement)),c.renderer.domElement.addEventListener("webglcontextlost",c.stop,!1),c.renderer.domElement.addEventListener("webglcontextrestored",c.start,!1),c.input=new Primrose.Input.FPSInput(c.renderer.domElement,c.options),c.input.addEventListener("zero",c.zero,!1),window.addEventListener("paste",c.input.Keyboard.withCurrentControl("readClipboard"),!1),window.addEventListener("wheel",c.input.Keyboard.withCurrentControl("readWheel"),!1),c.input.Keyboard.operatingSystem=c.options.os,c.input.Keyboard.codePage=c.options.language,c.input.head.add(c.camera),c.network=new Primrose.Network.Manager(c.input,c.audio,E,c.options),c.network.addEventListener("addavatar",j),c.network.addEventListener("removeavatar",N),c.input.ready});var D=0,F=0,L=10,H=2e3,z=0,B=0,U=0,G=function(){if(c.options.autoScaleQuality&&c.quality!==Quality.NONE)if(F<z+H)F=performance.now();else if(++D,D===L){var e=performance.now(),t=.001*(e-F),n=Math.round(L/t);F=e,D=0,U=B,B=n<45?-1:!isMobile&&c.options.autoRescaleQuality&&n>=60&&c.quality<Quality.MAXIMUM&&U!==-1?1:0,0!==B&&(c.quality+=B),z=e}},V=Promise.all([k,_,C]).then(function(){c.renderer.domElement.style.cursor="default",c.input.VR.displays[0].DOMElement=c.renderer.domElement,c.input.VR.connect(0),c.emit("ready")});if(c.start=function(){V.then(function(){c.audio.start(),x=performance.now()*i,A(v)})},c.stop=function(){I&&(I.cancelAnimationFrame(c.timer),c.audio.stop(),c.timer=null)},Object.defineProperties(c,{quality:{get:function(){return c.options.quality},set:function(e){0<=e&&e<PIXEL_SCALES.length&&(c.options.quality=e,T=PIXEL_SCALES[e],"WebVRConfig"in window&&(WebVRConfig.BUFFER_SCALE=T)),V.then(b)}}}),c.quality=c.options.quality,window.alert.toString().indexOf("native code")>-1){var W=function(e,t){return t||(t=function(){}),function(){c.input.VR.isPresenting?t():e.apply(window,a)}};window.alert=W(window.alert),window.confirm=W(window.confirm),window.prompt=W(window.prompt)}return c.start(),c}return n(s,o),r(s,[{key:"connect",value:function(e,t){return this.network&&this.network.connect(e,t)}},{key:"disconnect",value:function(){return this.network&&this.network.disconnect()}},{key:"displays",get:function(){return this.input.VR.displays}}]),s}(Primrose.AbstractEventEmitter);o.DEFAULTS={antialias:!0,autoScaleQuality:!0,autoRescaleQuality:!1,quality:Quality.MAXIMUM,useLeap:!1,useFog:!1,avatarHeight:1.65,walkSpeed:2,gravity:9.8,gazeLength:1,disableMirroring:!1,disableDefaultLighting:!1,backgroundColor:11517951,nearPlane:.01,drawDistance:100,defaultFOV:75,ambientSound:null,canvasElement:"frontBuffer",renderer:null,context:null,scene:null},"undefined"!=typeof window&&(window.Primrose.BrowserEnvironment=o)}(),function(){"use strict";function e(e,t){pliny.property({name:"options",type:"Object",description:"The options that the user provided, so that we might change them after the factory has been created, if we so choose."}),this.options=t,pliny.property({name:"template",type:"THREE.Object3D",description:"The 3D model for the button, that will be cloned every time a new button is created."}),this.template=e}var t=0;pliny.class({parent:"Primrose",name:"ButtonFactory",description:"Loads a model file and holds the data, creating clones of the data whenever a new button is desired.",parameters:[{name:"template",type:"THREE.Object3D",description:"A THREE.Object3D that specifies a 3D model for a button, to be used as a template."
},{name:"options",type:"Object",description:"The options to apply to all buttons that get created by the factory."},{name:"complete",type:"Function",description:"A callback function to indicate when the loading process has completed, if `templateFile` was a String path."}]}),pliny.method({parent:"Primrose.ButtonFactory",name:"create",description:"Clones all of the geometry, materials, etc. in a 3D model to create a new copy of it. This really should be done with instanced objects, but I just don't have the time to deal with it right now.",parameters:[{name:"toggle",type:"Boolean",description:'True if the new button should be a toggle button (requiring additional clicks to deactivate) or a regular button (deactivating when the button is released, aka "momentary".'}],return:"The cloned button that which we so desired."}),e.prototype.create=function(e){var n="button"+ ++t,r=this.template.clone(),i=new Primrose.Controls.Button3D(r,n,this.options,e);return i},"undefined"!=typeof window&&(window.Primrose.ButtonFactory=e)}(),function(){"use strict";pliny.namespace({name:"Controls",parent:"Primrose",description:"Various 3D control objects."});var e={};"undefined"!=typeof window&&(window.Primrose.Controls=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"DOM",description:"A few functions for manipulating DOM."});var e={};"undefined"!=typeof window&&(window.Primrose.DOM=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),n=[],r=new WeakMap;pliny.class({parent:"Primrose",name:"Entity",description:"The Entity class is the parent class for all 3D controls. It manages a unique ID for every new control, the focus state of the control, and performs basic conversions from DOM elements to the internal Control format."});var i=function(){function i(t){e(this,i),this.id=t,pliny.property({parent:"Primrose.Entity",name:"parent ",type:"Primrose.Entity",description:"The parent element of this eleemnt, if this element has been added as a child to another element."}),this.parent=null,pliny.property({parent:"Primrose.Entity",name:"children",type:"Array",description:"The child elements of this element."}),this.children=[],pliny.property({parent:"Primrose.Entity",name:"focused",type:"Boolean",description:"A flag indicating if the element, or a child element within it, has received focus from the user."}),this.focused=!1,pliny.property({parent:"Primrose.Entity",name:"focusable",type:"Boolean",description:"A flag indicating if the element, or any child elements within it, is capable of receiving focus."}),this.focusable=!0,pliny.property({parent:"Primrose.Entity",name:"listeners",type:"Object",description:"The event listener container, holding the callbacks to trigger for each type of event."}),this.listeners={focus:[],blur:[],click:[],keydown:[],keyup:[],paste:[],copy:[],cut:[],wheel:[],_idchanged:[]},pliny.event({parent:"Primrose.Entity",name:"focus",description:"If the element is focusable, occurs when the user clicks on an element for the first time, or when a program calls the `focus()` method."}),pliny.event({parent:"Primrose.Entity",name:"blur",description:"If the element is focused (which implies it is also focusable), occurs when the user clicks off of an element, or when a program calls the `blur()` method."}),pliny.event({parent:"Primrose.Entity",name:"click",description:"Occurs whenever the user clicks on an element."}),pliny.event({parent:"Primrose.Entity",name:"keydown",description:"Occurs when the user pushes a key down while focused on the element."}),pliny.event({parent:"Primrose.Entity",name:"keyup",description:"Occurs when the user releases a key while focused on the element."}),pliny.event({parent:"Primrose.Entity",name:"paste",description:"Occurs when the user activates the clipboard's `paste` command while focused on the element."}),pliny.event({parent:"Primrose.Entity",name:"cut",description:"Occurs when the user activates the clipboard's `cut` command while focused on the element."}),pliny.event({parent:"Primrose.Entity",name:"copy",description:"Occurs when the user activates the clipboard's `copy` command while focused on the element."}),pliny.event({parent:"Primrose.Entity",name:"wheel",description:"Occurs when the user scrolls the mouse wheel while focused on the element."})}return t(i,null,[{key:"registerEntity",value:function(e){pliny.function({parent:"Primrose.Entity",name:"registerEntity",description:"Register an entity to be able to receive eyeBlank events.",parameters:[{name:"e",type:"Primrose.Entity",description:"The entity to register."}]}),r.set(e.id,e),n.push(e.id),e.addEventListener("_idchanged",function(e){n.splice(n.indexOf(e.oldID),1),r.delete(e.oldID),r.set(e.entity.id,e.entity),n.push(e.entity.id)},!1)}},{key:"eyeBlankAll",value:function(e){pliny.function({parent:"Primrose.Entity",name:"eyeBlankAll",description:"Trigger the eyeBlank event for all registered entities.",parameters:[{name:"eye",type:"Number",description:"The eye to switch to: -1 for left, +1 for right."}]}),n.forEach(function(t){r.get(t).eyeBlank(e)})}}]),t(i,[{key:"addEventListener",value:function(e,t){pliny.method({parent:"Primrose.Entity",name:"addEventListener",description:"Adding an event listener registers a function as being ready to receive events.",parameters:[{name:"evt",type:"String",description:"The name of the event for which we are listening."},{name:"thunk",type:"Function",description:"The callback to fire when the event occurs."}],examples:[{name:"Add an event listener.",description:'The `addEventListener()` method operates nearly identically to the method of the same name on DOM elements.\n\n  grammar("JavaScript");\n  var txt = new Primrose.Text.Controls.TextBox();\n  txt.addEventListener("mousemove", console.log.bind(console, "mouse move"));\n  txt.addEventListener("keydown", console.log.bind(console, "key down"));'}]}),this.listeners[e]&&this.listeners[e].push(t)}},{key:"removeEventListener",value:function(e,t){pliny.method({parent:"Primrose.Entity",name:"removeEventListener",description:"Removing an event listener so that it no longer receives events from this object. Note that it must be the same function instance that was used when the event listener was added.",parameters:[{name:"evt",type:"String",description:"The name of the event from which we are removing."},{name:"thunk",type:"Function",description:"The callback to remove."}],examples:[{name:"Remove an event listener.",description:'The `removeEventListener()` method operates nearly identically to the method of the same name on DOM elements.\n\n  grammar("JavaScript");\n  var txt = new Primrose.Text.Controls.TextBox(),\n  func = console.log.bind(console, "mouse move");\n  txt.addEventListener("mousemove", func);\n  txt.removeEventListener("mousemove", func);'}]});var n=this.listeners[e];if(evt){var r=n.indexOf(t);0<=r&&r<n.length&&n.splice(r,1)}}},{key:"focus",value:function(){pliny.method({parent:"Primrose.Entity",name:"focus",description:"If the control is focusable, sets the focus property of the control, does not change the focus property of any other control.",examples:[{name:"Focus on one control, blur all the rest",description:'When we have a list of controls and we are trying to track focus between them all, we must coordinate calls between `focus()` and `blur()`.\n\n  grammar("JavaScript");\n  var ctrls = [\n  new Primrose.Text.Controls.TextBox(),\n  new Primrose.Text.Controls.TextBox(),\n  new Primrose.Text.Button()\n  ];\n  \n  function focusOn(id){\n    for(var i = 0; i < ctrls.length; ++i){\n      var c = ctrls[i];\n      if(c.controlID === id){\n        c.focus();\n      }\n      else{\n        c.blur();\n      }\n    }\n  }'}]}),this.focusable&&(this.focused=!0,emit.call(this,"focus",{target:this}))}},{key:"blur",value:function(){if(pliny.method({parent:"Primrose.Entity",name:"blur",description:"If the element is focused, unsets the focus property of the control and all child controls. Does not change the focus property of any parent or sibling controls.",examples:[{name:"Focus on one control, blur all the rest",description:'When we have a list of controls and we are trying to track focus between them all, we must coordinate calls between `focus()` and `blur()`.\n\n  grammar("JavaScript");\n  var ctrls = [\n  new Primrose.Text.Controls.TextBox(),\n  new Primrose.Text.Controls.TextBox(),\n  new Primrose.Text.Button()\n  ];\n  \n  function focusOn(id){\n    for(var i = 0; i < ctrls.length; ++i){\n      var c = ctrls[i];\n      if(c.controlID === id){\n        c.focus();\n      }\n      else{\n        c.blur();\n      }\n    }\n  }'}]}),this.focused){this.focused=!1;for(var e=0;e<this.children.length;++e)this.children[e].focused&&this.children[e].blur();emit.call(this,"blur",{target:this})}}},{key:"appendChild",value:function(e){pliny.method({parent:"Primrose.Entity",name:"appendChild",description:"Adds an Entity as a child entity of this entity.",parameters:[{name:"child",type:"Primrose.Entity",description:"The object to add. Will only succeed if `child.parent` is not set to a value."}],examples:[{name:"Add an entity to another entity",description:'Entities can be arranged in parent-child relationships.\n\n  grammar("JavaScript");\n  var a = new Primrose.Entity(),\n  b = new Primrose.Entity();\n  a.appendChild(b);\n  console.assert(a.children.length === 1);\n  console.assert(a.children[0] === b);\n  console.assert(b.parent === a);'}]}),e&&!e.parent&&(e.parent=this,this.children.push(e))}},{key:"removeChild",value:function(e){pliny.method({parent:"Primrose.Entity",name:"removeChild",description:"Removes an Entity from another Entity of this entity.",parameters:[{name:"child",type:"Primrose.Entity",description:"The object to remove. Will only succeed if `child.parent` is this object."}],examples:[{name:"Remove an entity from another entity",description:'Entities can be arranged in parent-child relationships.\n\n  grammar("JavaScript");\n  var a = new Primrose.Entity(),\n  b = new Primrose.Entity();\n  a.appendChild(b);\n  console.assert(a.children.length === 1);\n  console.assert(a.children[0] === b);\n  console.assert(b.parent === a);\n  a.removeChild(b);\n  console.assert(a.children.length === 0)\n  console.assert(b.parent === null);'}]});var t=this.children.indexOf(e);0<=t&&t<this.children.length&&(this.children.splice(t,1),e.parent=null)}},{key:"eyeBlank",value:function(e){pliny.method({parent:"Primrose.Entity",name:"eyeBlank",parameters:[{name:"eye",type:"Number",description:"The eye to switch to: -1 for left, +1 for right."}],description:"Instructs any stereoscopically rendered surfaces to change their rendering offset."});for(var t=0;t<this.children.length;++t)this.children[t].eyeBlank(e)}},{key:"_forFocusedChild",value:function(e,t){var n=this.focusedElement;n&&n!==this&&n[e](t)}},{key:"startDOMPointer",value:function(e){pliny.method({parent:"Primrose.Entity",name:"startDOMPointer",parameters:[{name:"evt",type:"Event",description:"The pointer event to read"}],description:"Hooks up to the window's `mouseDown` and `touchStart` events and propagates it to any of its focused children."});for(var t=0;t<this.children.length;++t)this.children[t].startDOMPointer(e)}},{key:"moveDOMPointer",value:function(e){pliny.method({parent:"Primrose.Entity",name:"moveDOMPointer",parameters:[{name:"evt",type:"Event",description:"The pointer event to read"}],description:"Hooks up to the window's `mouseMove` and `touchMove` events and propagates it to any of its focused children."}),this._forFocusedChild("moveDOMPointer",e)}},{key:"startUV",value:function(e){pliny.method({parent:"Primrose.Entity",name:"startUV",parameters:[{name:"evt",type:"Event",description:"The pointer event to read"}],description:"Hooks up to the window's `mouseDown` and `touchStart` events, with coordinates translated to tangent-space UV coordinates, and propagates it to any of its focused children."}),this._forFocusedChild("startUV",e)}},{key:"moveUV",value:function(e){pliny.method({parent:"Primrose.Entity",name:"moveUV",parameters:[{name:"evt",type:"Event",description:"The pointer event to read"}],description:"Hooks up to the window's `mouseMove` and `touchMove` events, with coordinates translated to tangent-space UV coordinates, and propagates it to any of its focused children."}),this._forFocusedChild("moveUV",e)}},{key:"endPointer",value:function(){pliny.method({parent:"Primrose.Entity",name:"endPointer",description:"Hooks up to the window's `mouseUp` and `toucheEnd` events and propagates it to any of its focused children."}),this._forFocusedChild("endPointer")}},{key:"keyDown",value:function(e){pliny.method({parent:"Primrose.Entity",name:"keyDown",parameters:[{name:"evt",type:"Event",description:"The key event to read"}],description:"Hooks up to the window's `keyDown` event and propagates it to any of its focused children."}),this._forFocusedChild("keyDown",e)}},{key:"keyUp",value:function(e){pliny.method({parent:"Primrose.Entity",name:"keyUp",parameters:[{name:"evt",type:"Event",description:"The key event to read"}],description:"Hooks up to the window's `keyUp` event and propagates it to any of its focused children."}),this._forFocusedChild("keyUp",e)}},{key:"readClipboard",value:function(e){pliny.method({parent:"Primrose.Entity",name:"readClipboard",parameters:[{name:"evt",type:"Event",description:"The clipboard event to read"}],description:"Hooks up to the clipboard's `paste` event and propagates it to any of its focused children."}),this._forFocusedChild("readClipboard",e)}},{key:"copySelectedText",value:function(e){pliny.method({parent:"Primrose.Entity",name:"copySelectedText",parameters:[{name:"evt",type:"Event",description:"The clipboard event to read"}],description:"Hooks up to the clipboard's `copy` event and propagates it to any of its focused children."}),this._forFocusedChild("copySelectedText",e)}},{key:"cutSelectedText",value:function(e){pliny.method({parent:"Primrose.Entity",name:"cutSelectedText",parameters:[{name:"evt",type:"Event",description:"The clipboard event to read"}],description:"Hooks up to the clipboard's `cut` event and propagates it to any of its focused children."}),this._forFocusedChild("cutSelectedText",e)}},{key:"readWheel",value:function(e){pliny.method({parent:"Primrose.Entity",name:"readWheel",parameters:[{name:"evt",type:"Event",description:"The wheel event to read"}],description:"Hooks up to the window's `wheel` event and propagates it to any of its focused children."}),this._forFocusedChild("readWheel",e)}},{key:"id",get:function(){return pliny.property({parent:"Primrose.Entity",name:"id ",type:"String",description:"Get or set the id for the control."}),this._id},set:function(e){var t=this._id;this._id=new Object(e),emit.call(this,"_idchanged",{oldID:t,entity:this})}},{key:"theme",get:function(){return pliny.property({parent:"Primrose.Entity",name:"theme",type:"Primrose.Text.Themes.*",description:"Get or set the theme used for rendering text on any controls in the control tree."}),null},set:function(e){for(var t=0;t<this.children.length;++t)this.children[t].theme=e}},{key:"lockMovement",get:function(){pliny.property({parent:"Primrose.Entity",name:"lockMovement",type:"Boolean",description:"Recursively searches the deepest leaf-node of the control graph for a control that has its `lockMovement` property set to `true`, indicating that key events should not be used to navigate the user, because they are being interpreted as typing commands."});for(var e=!1,t=0;t<this.children.length&&!e;++t)e|=this.children[t].lockMovement;return e}},{key:"focusedElement",get:function(){pliny.property({parent:"Primrose.Entity",name:"focusedElement",type:"Primrose.Entity",description:"Searches the deepest leaf-node of the control graph for a control that has its `focused` property set to `true`."});for(var e=null,t=this;t&&t.focused;){e=t;var n=t.children;t=null;for(var r=0;r<n.length;++r){var i=n[r];i.focused&&(t=i)}}return e}}]),i}();"undefined"!=typeof window&&(window.Primrose.Entity=i)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"HTTP",description:"A collection of basic XMLHttpRequest wrappers."});var e={};"undefined"!=typeof window&&(window.Primrose.HTTP=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"Input",description:"The Input namespace contains classes that handle user input, for use in navigating the 3D environment."});var e={};"undefined"!=typeof window&&(window.Primrose.Input=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e},n=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),r=["heading","pitch","roll","pointerPitch","headX","headY","headZ"];new THREE.Vector3(0,0,(-1)),new THREE.Vector3(0,0,0);pliny.class({parent:"Primrose",name:"InputProcessor",description:"| [under construction]"});var i=function(){function i(t,n,r){var o=this;e(this,i),this.name=t,this.commands={},this.commandNames=[],this.enabled=!0,this.paused=!1,this.ready=!0,this.inPhysicalUse=!1,this.inputState={buttons:[],axes:[],ctrl:!1,alt:!1,shift:!1,meta:!1},this.lastState="",this.listeners={teleport:[]};var s=function(e){for(var t=0;t<Primrose.Keys.MODIFIER_KEYS.length;++t){var n=Primrose.Keys.MODIFIER_KEYS[t];o.inputState[n]=e[n+"Key"]}};for(window.addEventListener("keydown",s,!1),window.addEventListener("keyup",s,!1),this.axisNames=r||[],c=0;c<this.axisNames.length;++c)this.inputState.axes[c]=0;for(var a in n)this.addCommand(a,n[a]);var c;for(c=0;c<Primrose.Keys.MODIFIER_KEYS.length;++c)this.inputState[Primrose.Keys.MODIFIER_KEYS[c]]=!1}return n(i,[{key:"addCommand",value:function(e,t){t.name=e,t=this.cloneCommand(t),"undefined"==typeof t.repetitions&&(t.repetitions=1),t.state={value:null,pressed:!1,wasPressed:!1,fireAgain:!1,lt:0,ct:0,repeatCount:0},this.commands[e]=t,this.commandNames.push(e)}},{key:"addEventListener",value:function(e,t,n){this.listeners[e]&&this.listeners[e].push(t)}},{key:"cloneCommand",value:function(e){return{name:e.name,disabled:!!e.disabled,dt:e.dt||0,deadzone:e.deadzone||0,threshold:e.threshold||0,repetitions:e.repetitions,scale:e.scale,offset:e.offset,min:e.min,max:e.max,integrate:e.integrate||!1,delta:e.delta||!1,axes:this.maybeClone(e.axes),commands:e.commands&&e.commands.slice()||[],buttons:this.maybeClone(e.buttons),metaKeys:this.maybeClone(e.metaKeys&&e.metaKeys.map(function(e){for(var t=0;t<Primrose.Keys.MODIFIER_KEYS.length;++t){var n=Primrose.Keys.MODIFIER_KEYS[t];if(Math.abs(e)===Primrose.Keys[n.toLocaleUpperCase()])return Math.sign(e)*(t+1)}})),commandDown:e.commandDown,commandUp:e.commandUp}}},{key:"maybeClone",value:function(e){var n=[];if(e)for(var r=0;r<e.length;++r){var i=0,o=!1,s=1,a=t(e[r]);if("number"===a)i=Math.abs(e[r])-1,o=e[r]<0,s=e[r]<0?-1:1;else{if("string"!==a)throw new Error("Cannot clone command spec. Element was type: "+a,e[r]);i=this.axisNames.indexOf(e[r])}n[r]={index:i,toggle:o,sign:s}}return n}},{key:"update",value:function(e){if(this.enabled&&this.ready&&this.enabled&&this.inPhysicalUse&&!this.paused&&e>0){for(var t in this.commands){var n=this.commands[t];if(n.state.wasPressed=n.state.pressed,n.state.pressed=!1,!n.disabled){var r,i=!0;if(n.metaKeys)for(r=0;r<n.metaKeys.length&&i;++r){var o=n.metaKeys[r];i=i&&(this.inputState[Primrose.Keys.MODIFIER_KEYS[o.index]]&&!o.toggle||!this.inputState[Primrose.Keys.MODIFIER_KEYS[o.index]]&&o.toggle)}if(i){var s,a=!0,c=0,u=!1;for(r in this.inputState.buttons)if(this.inputState.buttons[r]){u=!0;break}if(n.buttons)for(r=0;r<n.buttons.length;++r){var l=n.buttons[r],h=l.index+1,d=h===Primrose.Keys.ANY&&u||!!this.inputState.buttons[h];s=d?l.sign:0,a=a&&(d&&!l.toggle||!d&&l.toggle),Math.abs(s)>Math.abs(c)&&(c=s)}if(n.axes)for(r=0;r<n.axes.length;++r){var p=n.axes[r];s=p.sign*this.inputState.axes[p.index],Math.abs(s)>Math.abs(c)&&(c=s)}for(r=0;r<n.commands.length;++r)s=this.getValue(n.commands[r]),Math.abs(s)>Math.abs(c)&&(c=s);if(void 0!==n.scale&&(c*=n.scale),void 0!==n.offset&&(c+=n.offset),n.deadzone&&Math.abs(c)<n.deadzone&&(c=0),n.integrate)c=this.getValue(n.name)+c*e;else if(n.delta){var m=c;void 0!==n.state.lv&&(c=(c-n.state.lv)/e),n.state.lv=m}void 0!==n.min&&(c=Math.max(n.min,c)),void 0!==n.max&&(c=Math.min(n.max,c)),n.threshold&&(a=a&&c>n.threshold),n.state.pressed=a,n.state.value=c}n.state.lt+=e,n.state.fireAgain=n.state.pressed&&n.state.lt>=n.dt&&(n.repetitions===-1||n.state.repeatCount<n.repetitions),n.state.fireAgain?(n.state.lt=0,++n.state.repeatCount):n.state.pressed||(n.state.repeatCount=0)}}this.fireCommands()}}},{key:"zero",value:function(){for(var e=0;this.enabled&&e<r.length;++e)this.setValue(r[e],0)}},{key:"fireCommands",value:function(){if(this.ready&&!this.paused)for(var e in this.commands){var t=this.commands[e];t.state.fireAgain&&t.commandDown&&t.commandDown(this.name),!t.state.pressed&&t.state.wasPressed&&t.commandUp&&t.commandUp(this.name)}}},{key:"makeStateSnapshot",value:function(){var e="",t=0,n=Object.keys(this.commands).length;for(var r in this.commands){var i=this.commands[r];i.state&&(e+=t<<2|(i.state.pressed?1:0)|(i.state.fireAgain?2:0)+":"+i.state.value,t<n-1&&(e+="|")),++t}return e}},{key:"decodeStateSnapshot",value:function(e){var t,n;for(n in this.commands)t=this.commands[n],t.state.wasPressed=t.state.pressed;for(var r=e.split("|"),i=0;i<r.length;++i){var o=r[i],s=o.split(":"),a=parseInt(s[0],10),c=0!==(1&a),u=0!==(2&l),l=parseInt(s[2],10);a>>=2,n=this.commandNames(a),t=this.commands[n],t.state={value:parseFloat(s[1]),pressed:c,fireAgain:u}}}},{key:"setProperty",value:function(e,t,n){this.commands[t]&&(this.commands[t][e]=n)}},{key:"setDeadzone",value:function(e,t){this.setProperty("deadzone",e,t)}},{key:"setScale",value:function(e,t){this.setProperty("scale",e,t)}},{key:"setDT",value:function(e,t){this.setProperty("dt",e,t)}},{key:"setMin",value:function(e,t){this.setProperty("min",e,t)}},{key:"setMax",value:function(e,t){this.setProperty("max",e,t)}},{key:"addToArray",value:function(e,t,n){this.commands[t]&&this.commands[t][e]&&this.commands[t][e].push(n)}},{key:"addMetaKey",value:function(e,t){this.addToArray("metaKeys",e,t)}},{key:"addAxis",value:function(e,t){this.addToArray("axes",e,t)}},{key:"addButton",value:function(e,t){this.addToArray("buttons",e,t)}},{key:"removeMetaKey",value:function(e,t){this.removeFromArray("metaKeys",e,t)}},{key:"removeAxis",value:function(e,t){this.removeFromArray("axes",e,t)}},{key:"removeButton",value:function(e,t){this.removeFromArray("buttons",e,t)}},{key:"invertAxis",value:function(e,t){this.invertInArray("axes",e,t)}},{key:"invertButton",value:function(e,t){this.invertInArray("buttons",e,t)}},{key:"invertMetaKey",value:function(e,t){this.invertInArray("metaKeys",e,t)}},{key:"removeFromArray",value:function(e,t,n){if(this.commands[t]&&this.commands[t][e]){var r=this.commands[t][e],i=r.indexOf(n);i>-1&&r.splice(i,1)}}},{key:"invertInArray",value:function(e,t,n){if(this.commands[t]&&this.commands[t][e]){var r=this.commands[t][e],i=r.indexOf(n);i>-1&&(r[i]*=-1)}}},{key:"pause",value:function(e){this.paused=e}},{key:"isPaused",value:function(){return this.paused}},{key:"enable",value:function(e,t){void 0!==t&&null!==t||(t=e,e=null),e?this.setProperty("disabled",e,!t):this.enabled=t}},{key:"isEnabled",value:function(e){return e&&this.commands[e]&&!this.commands[e].disabled}},{key:"getAxis",value:function(e){var t=this.axisNames.indexOf(e);if(t>-1){var n=this.inputState.axes[t]||0;return n}return null}},{key:"setAxis",value:function(e,t){var n=this.axisNames.indexOf(e);n>-1&&(this.inPhysicalUse=!0,this.inputState.axes[n]=t)}},{key:"setButton",value:function(e,t){this.inPhysicalUse=!0,this.inputState.buttons[e]=t}},{key:"isDown",value:function(e){return this.enabled&&this.isEnabled(e)&&this.commands[e].state.pressed}},{key:"isUp",value:function(e){return this.enabled&&this.isEnabled(e)&&this.commands[e].state.pressed}},{key:"getValue",value:function(e){return this.enabled&&this.isEnabled(e)&&(this.commands[e].state.value||this.getAxis(e))||0}},{key:"setValue",value:function(e,t){var n=this.axisNames.indexOf(e);!this.commands[e]&&n>-1?this.setAxis(e,t):this.commands[e]&&!this.commands[e].disabled&&(this.commands[e].state.value=t)}}]),i}();"undefined"!=typeof window&&(window.Primrose.InputProcessor=i)}(),function(){"use strict";pliny.enumeration({parent:"Primrose",name:"Keys",description:"Keycode values for system keys that are the same across all international standards"});var e={ANY:Number.MAX_VALUE,MODIFIER_KEYS:["ctrl","shift","alt","meta","meta_l","meta_r"],SHIFT:16,CTRL:17,ALT:18,META:91,META_L:91,META_R:92,BACKSPACE:8,TAB:9,ENTER:13,SPACE:32,DELETE:46,PAUSEBREAK:19,CAPSLOCK:20,NUMLOCK:144,SCROLLLOCK:145,INSERT:45,ESCAPE:27,PAGEUP:33,PAGEDOWN:34,END:35,HOME:36,LEFTARROW:37,UPARROW:38,RIGHTARROW:39,DOWNARROW:40,SELECTKEY:93,NUMBER0:48,NUMBER1:49,NUMBER2:50,NUMBER3:51,NUMBER4:52,NUMBER5:53,NUMBER6:54,NUMBER7:55,NUMBER8:56,NUMBER9:57,A:65,B:66,C:67,D:68,E:69,F:70,G:71,H:72,I:73,J:74,K:75,L:76,M:77,N:78,O:79,P:80,Q:81,R:82,S:83,T:84,U:85,V:86,W:87,X:88,Y:89,Z:90,NUMPAD0:96,NUMPAD1:97,NUMPAD2:98,NUMPAD3:99,NUMPAD4:100,NUMPAD5:101,NUMPAD6:102,NUMPAD7:103,NUMPAD8:104,NUMPAD9:105,MULTIPLY:106,ADD:107,SUBTRACT:109,DECIMALPOINT:110,DIVIDE:111,F1:112,F2:113,F3:114,F4:115,F5:116,F6:117,F7:118,F8:119,F9:120,F10:121,F11:122,F12:123,VOLUME_DOWN:174,VOLUME_UP:175,TRACK_NEXT:176,TRACK_PREVIOUS:177};for(var t in e){var n=e[t];e.hasOwnProperty(t)&&"number"==typeof n&&(e[n]=t)}"undefined"!=typeof window&&(window.Primrose.Keys=e)}(),function(){"use strict";function e(e){return e.traverse(function(e){e.geometry&&(e.geometry.computeBoundingSphere(),e.geometry.computeBoundingBox())}),e}function t(e){return e.traverse(function(e){if(e instanceof THREE.Mesh)for(var t in a)e[t]=e[t]||a[t](e)}),e}function n(e){pliny.property({name:"template",type:"THREE.Object3D",description:"When a model is loaded, stores a reference to the model so it can be cloned in the future."}),this.template=e}function r(e,t){return function(r){return n.loadObject(e[t]).then(function(e){return r[t]=e,r})}}var i={".json":THREE.ObjectLoader,".fbx":THREE.FBXLoader,".mtl":THREE.MTLLoader,".obj":THREE.OBJLoader,".stl":THREE.STLLoader,".typeface.json":THREE.FontLoader},o=/((?:[^\/]+\/)+)(\w+)(\.(?:\w+))$/,s=/(\.(?:\w+))+$/,a={isButton:function(e){return e.material&&e.material.name.match(/^button\d+$/)},isSolid:function(e){return!e.name.match(/^(water|sky)/)},isGround:function(e){return e.material&&e.material.name&&e.material.name.match(/\bground\b/)}};pliny.class({parent:"Primrose",name:"ModelLoader",description:"Creates an interface for cloning 3D models loaded from files, to instance those objects.\n\n> NOTE: You don't instantiate this class directly. Call `ModelLoader.loadModel`.",parameters:[{name:"template",type:"THREE.Object3D",description:"The 3D model to make clonable."}],examples:[{name:"Load a basic model.",description:'When Blender exports the Three.js JSON format, models are treated as full scenes, essentially making them scene-graph sub-trees. Instantiating a Primrose.ModelLoader object referencing one of these model files creates a factory for that model that we can use to generate an arbitrary number of copies of the model in our greater scene.\n\n## Code:\n\n  grammar("JavaScript");\n  // Create the scene where objects will go\n  var scene = new THREE.Scene(),\n   \n  // Load up the file, optionally "check it out"\n    modelFactory = new Primrose.loadModel("path/to/model.json", console.log.bind(console, "Progress:"))\n    .then(function(model){\n      model.template.traverse(function(child){\n        // Do whatever you want to the individual child objects of the scene.\n      });\n   \n    // Add copies of the model to the scene every time the user hits the ENTER key.\n    window.addEventListener("keyup", function(evt){\n      // If the template object exists, then the model loaded successfully.\n      if(evt.keyCode === 10){\n        scene.add(model.clone());\n      }\n    });\n  })\n  .catch(console.error.bind(console));'}]}),n.loadModel=function(e,t,r){return n.loadObject(e,t,r).then(function(e){return new n(e)})},pliny.method({parent:"Primrose.ModelLoader",name:"clone",description:"Creates a copy of the stored template model.",returns:"A THREE.Object3D that is a copy of the stored template.",examples:[{name:"Load a basic model.",description:'When Blender exports the Three.js JSON format, models are treated as full scenes, essentially making them scene-graph sub-trees. Instantiating a Primrose.ModelLoader object referencing one of these model files creates a factory for that model that we can use to generate an arbitrary number of copies of the model in our greater scene.\n\n## Code:\n\n  grammar("JavaScript");\n  // Create the scene where objects will go\n  var scene = new THREE.Scene(),\n  \n  // Load up the file, optionally "check it out"\n    modelFactory = new Primrose.ModelLoader("path/to/model.json", function(model){\n      model.traverse(function(child){\n        // Do whatever you want to the individual child objects of the scene.\n      });\n  }, console.error.bind(console), console.log.bind(console, "Progress:"));\n  \n  // Add copies of the model to the scene every time the user hits the ENTER key.\n  window.addEventListener("keyup", function(evt){\n    // If the template object exists, then the model loaded successfully.\n    if(modelFactory.template && evt.keyCode === 10){\n      scene.add(modelFactory.clone());\n    }\n  });'}]}),n.prototype.clone=function(){var e=this,n=this.template.clone();return n.traverse(function(t){t instanceof THREE.SkinnedMesh&&(n.animation=new THREE.Animation(t,t.geometry.animation),!e.template.originalAnimationData&&n.animation.data&&(e.template.originalAnimationData=n.animation.data),n.animation.data||(n.animation.data=e.template.originalAnimationData))}),t(n),n},pliny.function({parent:"Primrose.ModelLoader",name:"loadObject",description:"Asynchronously loads a JSON, OBJ, or MTL file as a Three.js object. It processes the scene for attributes, creates new properties on the scene to give us\nfaster access to some of the elements within it. It uses callbacks to tell you when loading progresses. It uses a Promise to tell you when it's complete, or when an error occurred.\nUseful for one-time use models.\n\n> NOTE: ModelLoader uses the same Cross-Origin Request policy as THREE.ImageUtils,\n> meaning you may use THREE.ImageUtils.crossOrigin to configure the cross-origin\n> policy that Primrose uses for requests.",returns:"Promise",parameters:[{name:"src",type:"String",description:"The file from which to load."},{name:"type",type:"String",optional:!0,description:"The type of the file--JSON, FBX, OJB, or STL--if it can't be determined from the file extension."},{name:"progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Load a basic model.",description:'When Blender exports the Three.js JSON format, models are treated as full scenes, essentially making them scene-graph sub-trees. Instantiating a Primrose.ModelLoader object referencing one of these model files creates a factory for that model that we can use to generate an arbitrary number of copies of the model in our greater scene.\n\n## Code:\n\n  grammar("JavaScript");\n  // Create the scene where objects will go\n  var renderer = new THREE.WebGLRenderer(),\n      currentScene = new THREE.Scene(),\n      camera = new THREE.PerspectiveCamera();\n   \n  // Load up the file\n  Primrose.ModelLoader.loadObject(\n    "path/to/model.json",\n    null,\n    console.log.bind(console, "Progress:"))\n    .then(scene.add.bind(scene))\n    .catch(console.error.bind(console));\n   \n  function paint(t){\n    requestAnimationFrame(paint);\n    renderer.render(scene, camera);\n  }\n   \n  requestAnimationFrame(paint);'
}]}),n.loadObject=function(r,a,c){var u=r.match(s),l=a&&"."+a||u[0];if(l){l=l.toLowerCase();var h=new i[l];if(h){var d=r.substring(0,u.index),p=d+"_"+l.toLowerCase(),m=document.getElementById(p),f=Promise.resolve();if(".obj"===l){var y=r.replace(s,".mtl");f=f.then(function(){return n.loadObject(y,"mtl",c)}).then(function(e){e.preload(),h.setMaterials(e)})}else if(".mtl"===l){var g=r.match(o),v=g[1];r=g[2]+g[3],h.setTexturePath(v),h.setPath(v)}if(m){var w=m.innerHTML.split(/\r?\n/g).map(function(e){return e.trim()}).join("\n");f=f.then(function(){return h.parse(w)})}else h.setCrossOrigin&&h.setCrossOrigin(THREE.ImageUtils.crossOrigin),f=f.then(function(){return new Promise(function(e,t){return h.load(r,e,c,t)})});return".json"===l&&(f=f.then(e)),".mtl"!==l&&".typeface.json"!==l&&(f=f.then(t)),f=f.catch(console.error.bind(console,"MODEL_ERR",r))}return Promise.reject("There is no loader type for the file extension: "+l)}return Promise.reject("File path `"+r+"` does not have a file extension, and a type was not provided as a parameter, so we can't determine the type.")},pliny.function({parent:"Primrose.ModelLoader",name:"loadObjects",description:"Asynchronously loads an array of JSON, OBJ, or MTL file as a Three.js object. It processes the objects for attributes, creating new properties on each object to give us\nfaster access to some of the elements within it. It uses callbacks to tell you when loading progresses. It uses a Promise to tell you when it's complete, or when an error occurred.\nUseful for static models.\n\nSee [`Primrose.ModelLoader.loadObject()`](#Primrose_ModelLoader_loadObject) for more details on how individual models are loaded.",returns:"Promise",parameters:[{name:"arr",type:"Array",description:"The files from which to load."},{name:"type",type:"String",optional:!0,description:"The type of the file--JSON, FBX, OJB, or STL--if it can't be determined from the file extension."},{name:"progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Load some models.",description:'When Blender exports models, they are frequently treated as full scenes, essentially making them scene-graph sub-trees.\nWe can load a bunch of models in one go using the following code.\n\n## Code:\n\n  grammar("JavaScript");\n  // Create the scene where objects will go\n  var renderer = new THREE.WebGLRenderer(),\n      currentScene = new THREE.Scene(),\n      camera = new THREE.PerspectiveCamera(),\n      allModels = null;\n   \n  // Load up the file\n  Primrose.ModelLoader.loadObjects(\n    ["path/to/model1.json",\n      "path/to/model2.obj",\n      "path/to/model3.obj",\n      "path/to/model4.fbx"],\n    console.log.bind(console, "Progress:"))\n    .then(function(models){\n      allModels = models;\n      models.forEach(function(model){\n        scene.add(model);\n      });\n    })\n    .catch(console.error.bind(console));\n   \n  function paint(t){\n    requestAnimationFrame(paint);\n    \n    if(allModels){\n      // do whatever updating you want on the models\n    }\n    \n    renderer.render(scene, camera);\n  }\n  \n  requestAnimationFrame(paint);'}]}),n.loadObjects=function(e){var t={},n=Promise.resolve(t);for(var i in e)e[i]&&(n=n.then(r(e,i)));return n},"undefined"!=typeof window&&(window.Primrose.ModelLoader=n)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"Network",description:"The Network namespace contains classes for communicating events between entities in a graph relationship across different types of communication boundaries: in-thread, cross-thread, cross-WAN, and cross-LAN."});var e={};"undefined"!=typeof window&&(window.Primrose.Network=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"Output",description:"The Output namespace contains classes that handle output to devices other than the screen (e.g. Audio, Music, etc.)."});var e={};"undefined"!=typeof window&&(window.Primrose.Output=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=.4,o=new THREE.Vector3(0,0,(-1)),s=5,a=s*s,c=.01,u=3*c,l=new THREE.Euler,h=new THREE.Vector3(0,0,0);pliny.class({parent:"Primrose",name:"Pointer",baseClass:"Primrose.AbstractEventEmitter",description:"An object that points into the scene somewhere, casting a ray at objects for picking operations.",parameters:[{name:"name ",type:"String",description:"A friendly name for this pointer object, to make debugging easier."},{name:"color",type:"Number",description:"The color to use to render the teleport pad and 3D pointer cursor."},{name:"emission",type:"Number",description:"The color to use to highlight the teleport pad and 3D pointer cursor so that it's not 100% black outside of lighted areas."},{name:"isHand",type:"Boolean",description:"Pass true to add a hand model at the origin of the pointer ray."},{name:"orientationDevices",type:"Array",description:"An Array of `Primrose.InputProcessor` objects that define the orientation for this pointer."},{name:"positionDevices",type:"Array",description:"An Array of `Primrose.PoseInputProcessor` objects that define the position for this pointer.",optional:!0,defaultValue:null},{name:"triggerDevices",type:"Array",description:"An Array of `Primrose.InputProcessor` objects that define the button trigger for this pointer.",optional:!0,defaultValue:null}]});var d=function(d){function p(n,r,o,s){var a=arguments.length<=4||void 0===arguments[4]?null:arguments[4],l=arguments.length<=5||void 0===arguments[5]?null:arguments[5];e(this,p);var h=t(this,(p.__proto__||Object.getPrototypeOf(p)).call(this));return h.name=n,h.orientationDevices=s,h.positionDevices=a||s.slice(),h.triggerDevices=l||s.slice(),h._currentControl=null,h.showPointer=!0,h.color=r,h.emission=o,h.velocity=new THREE.Vector3,h.mesh=textured(box(c,c,u),h.color,{emissive:h.emission}),h.mesh.geometry.vertices.forEach(function(e){e.z-=.5*u+.5}),h.disk=textured(sphere(i,128,3),h.color,{emissive:h.emission}),h.disk.geometry.computeBoundingBox(),h.disk.geometry.vertices.forEach(function(e){e.y-=h.disk.geometry.boundingBox.min.y}),h.disk.geometry.computeBoundingBox(),h.disk.scale.set(1,.1,1),h}return n(p,d),r(p,[{key:"add",value:function(e){this.mesh.add(e)}},{key:"addDevice",value:function(e,t,n){e&&this.orientationDevices.push(e),t&&this.positionDevices.push(t),n&&this.triggerDevices.push(n)}},{key:"addToBrowserEnvironment",value:function(e,t){pliny.method({parent:"Primrose.Pointer",name:"addToBrowserEnvironment",description:"Add this meshes that give the visual representation of the pointer, to the scene.",parameters:[{name:"env",type:"Primrose.BrowserEnvironment",description:"Not used, just here to fulfill a common interface in the framework."},{name:"scene",type:"THREE.Scene",description:"The scene to which to add the 3D cursor."}]}),t.add(this.mesh),t.add(this.disk)}},{key:"updateMatrix",value:function(){return this.mesh.updateMatrix()}},{key:"applyMatrix",value:function(e){return this.mesh.applyMatrix(e)}},{key:"update",value:function(){if(this.orientationDevices[0]instanceof Primrose.PoseInputProcessor)this.position.copy(this.orientationDevices[0].position),this.quaternion.copy(this.orientationDevices[0].quaternion);else{var e,t,n=0,r=0,i=0,o=0,s=0;for(e=0;e<this.orientationDevices.length;++e)t=this.orientationDevices[e],t.enabled&&(n+=t.getValue("pitch"),r+=t.getValue("heading"));for(e=0;e<this.positionDevices.length;++e)t=this.positionDevices[e],t.enabled&&(t.position?(i+=t.position.x,o+=t.position.y,s+=t.position.z):(i+=t.getValue("X"),o+=t.getValue("Y"),s+=t.getValue("Z")));l.set(n,r,0,"YXZ"),this.quaternion.setFromEuler(l),this.position.set(i,o,s)}}},{key:"resolvePicking",value:function(e,t,n){if(this.disk.visible=!1,this.mesh.visible=!1,this.showPointer){textured(this.mesh,this.color,{emissive:this.minorColor}),this.mesh.visible=!0;for(var r,i,o,c=0,u=0,l=e[this.name],d=(t&&t[this.name],!1),p="",m=0;m<this.triggerDevices.length;++m){var f=this.triggerDevices[m];if(f.enabled){var y=f.getValue("buttons"),g=f.getValue("dButtons");c+=y,u+=g,"Touch"===f.name&&(p+=y+" "+g)}}var v=0!==u;if(l){r=n[l.objectID],d=r&&"Ground"===r.name;var w=l.facePoint;if(o=l.point,i=r&&(r.button||r.surface),h.fromArray(w).sub(this.mesh.position),this.disk.visible=d,d){var b=h.x*h.x+h.z*h.z;if(b>a){var x=Math.sqrt(b),P=s/x,T=h.y;h.y=0,h.multiplyScalar(P),h.y=T,textured(this.mesh,16776960,{emissive:8355584})}this.disk.position.copy(this.mesh.position).add(h)}else textured(this.mesh,65280,{emissive:32512})}if(v)if(c)this.currentControl&&this.currentControl.endPointer();else{var E=!!this.currentControl,k=this.currentControl;this.currentControl=null,r&&(k&&k===i&&(E=!1),!this.currentControl&&i?(this.currentControl=i,this.currentControl.focus()):d&&this.emit("teleport",{name:this.name,position:this.disk.position}),this.currentControl&&this.currentControl.startUV(o)),E&&k.blur()}else!v&&c>0&&this.currentControl&&o&&this.currentControl.moveUV(o)}}},{key:"position",get:function(){return this.mesh.position}},{key:"quaternion",get:function(){return this.mesh.quaternion}},{key:"matrix",get:function(){return this.mesh.matrix}},{key:"currentControl",get:function(){return this._currentControl},set:function(e){for(var t=this;t;)t._currentControl=e,t=t.parent}},{key:"lockMovement",get:function(){for(var e=this;e;){if(this.currentControl&&this.currentControl.lockMovement)return!0;e=e.parent}return!1}},{key:"segment",get:function(){if(this.showPointer)return o.set(0,0,-1).applyQuaternion(this.mesh.quaternion).add(this.mesh.position),[this.name,this.mesh.position.toArray(),o.toArray()]}}]),p}(Primrose.AbstractEventEmitter);"undefined"!=typeof window&&(window.Primrose.Pointer=d)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},o={position:[0,0,0],orientation:[0,0,0,1]},s=new THREE.Vector3;pliny.class({parent:"Primrose",name:"PoseInputProcessor",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var a=function(a){function c(n,r,i){e(this,c);var o=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,n,r,i));return o.currentDevice=null,o.lastPose=null,o.currentPose=null,o.posePosition=new THREE.Vector3,o.poseQuaternion=new THREE.Quaternion,o.position=new THREE.Vector3,o.quaternion=new THREE.Quaternion,o.matrix=new THREE.Matrix4,o}return n(c,a),r(c,[{key:"update",value:function(e){if(i(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"update",this).call(this,e),this.currentDevice){var t=this.currentPose||this.lastPose||o;this.lastPose=t,this.inPhysicalUse=!!this.currentPose;var n=this.currentPose&&this.currentPose.orientation,r=this.currentPose&&this.currentPose.position;n?this.poseQuaternion.fromArray(n):this.poseQuaternion.set(0,0,0,1),r?this.posePosition.fromArray(r):this.posePosition.set(0,0,0)}}},{key:"updateStage",value:function(e){this.matrix.makeRotationFromQuaternion(this.poseQuaternion),this.matrix.setPosition(this.posePosition),this.matrix.multiplyMatrices(e,this.matrix),this.matrix.decompose(this.position,this.quaternion,s)}}]),c}(Primrose.InputProcessor);"undefined"!=typeof window&&(window.Primrose.PoseInputProcessor=a)}(),function(){"use strict";function e(e){!function(){"undefined"==typeof THREE&&(self.THREE={REVISION:"72dev"},void 0===Math.sign&&(Math.sign=function(e){return e<0?-1:e>0?1:+e}),void 0===Function.prototype.name&&void 0!==Object.defineProperty&&Object.defineProperty(Function.prototype,"name",{get:function(){return this.toString().match(/^\s*function\s*(\S*)\s*\(/)[1]}}),THREE.Quaternion=function(e,t,n,r){this._x=e||0,this._y=t||0,this._z=n||0,this._w=void 0!==r?r:1},THREE.Quaternion.prototype={constructor:THREE.Quaternion,get x(){return this._x},set x(e){this._x=e,this.onChangeCallback()},get y(){return this._y},set y(e){this._y=e,this.onChangeCallback()},get z(){return this._z},set z(e){this._z=e,this.onChangeCallback()},get w(){return this._w},set w(e){this._w=e,this.onChangeCallback()},set:function(e,t,n,r){return this._x=e,this._y=t,this._z=n,this._w=r,this.onChangeCallback(),this},clone:function(){return new this.constructor(this._x,this._y,this._z,this._w)},copy:function(e){return this._x=e.x,this._y=e.y,this._z=e.z,this._w=e.w,this.onChangeCallback(),this},setFromEuler:function(e,t){if(e instanceof THREE.Euler==!1)throw new Error("THREE.Quaternion: .setFromEuler() now expects a Euler rotation rather than a Vector3 and order.");var n=Math.cos(e._x/2),r=Math.cos(e._y/2),i=Math.cos(e._z/2),o=Math.sin(e._x/2),s=Math.sin(e._y/2),a=Math.sin(e._z/2);return"XYZ"===e.order?(this._x=o*r*i+n*s*a,this._y=n*s*i-o*r*a,this._z=n*r*a+o*s*i,this._w=n*r*i-o*s*a):"YXZ"===e.order?(this._x=o*r*i+n*s*a,this._y=n*s*i-o*r*a,this._z=n*r*a-o*s*i,this._w=n*r*i+o*s*a):"ZXY"===e.order?(this._x=o*r*i-n*s*a,this._y=n*s*i+o*r*a,this._z=n*r*a+o*s*i,this._w=n*r*i-o*s*a):"ZYX"===e.order?(this._x=o*r*i-n*s*a,this._y=n*s*i+o*r*a,this._z=n*r*a-o*s*i,this._w=n*r*i+o*s*a):"YZX"===e.order?(this._x=o*r*i+n*s*a,this._y=n*s*i+o*r*a,this._z=n*r*a-o*s*i,this._w=n*r*i-o*s*a):"XZY"===e.order&&(this._x=o*r*i-n*s*a,this._y=n*s*i-o*r*a,this._z=n*r*a+o*s*i,this._w=n*r*i+o*s*a),t!==!1&&this.onChangeCallback(),this},setFromAxisAngle:function(e,t){var n=t/2,r=Math.sin(n);return this._x=e.x*r,this._y=e.y*r,this._z=e.z*r,this._w=Math.cos(n),this.onChangeCallback(),this},setFromRotationMatrix:function(e){var t,n=e.elements,r=n[0],i=n[4],o=n[8],s=n[1],a=n[5],c=n[9],u=n[2],l=n[6],h=n[10],d=r+a+h;return d>0?(t=.5/Math.sqrt(d+1),this._w=.25/t,this._x=(l-c)*t,this._y=(o-u)*t,this._z=(s-i)*t):r>a&&r>h?(t=2*Math.sqrt(1+r-a-h),this._w=(l-c)/t,this._x=.25*t,this._y=(i+s)/t,this._z=(o+u)/t):a>h?(t=2*Math.sqrt(1+a-r-h),this._w=(o-u)/t,this._x=(i+s)/t,this._y=.25*t,this._z=(c+l)/t):(t=2*Math.sqrt(1+h-r-a),this._w=(s-i)/t,this._x=(o+u)/t,this._y=(c+l)/t,this._z=.25*t),this.onChangeCallback(),this},setFromUnitVectors:function(){var e,t,n=1e-6;return function(r,i){return void 0===e&&(e=new THREE.Vector3),t=r.dot(i)+1,t<n?(t=0,Math.abs(r.x)>Math.abs(r.z)?e.set(-r.y,r.x,0):e.set(0,-r.z,r.y)):e.crossVectors(r,i),this._x=e.x,this._y=e.y,this._z=e.z,this._w=t,this.normalize(),this}}(),inverse:function(){return this.conjugate().normalize(),this},conjugate:function(){return this._x*=-1,this._y*=-1,this._z*=-1,this.onChangeCallback(),this},dot:function(e){return this._x*e._x+this._y*e._y+this._z*e._z+this._w*e._w},lengthSq:function(){return this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w},length:function(){return Math.sqrt(this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w)},normalize:function(){var e=this.length();return 0===e?(this._x=0,this._y=0,this._z=0,this._w=1):(e=1/e,this._x=this._x*e,this._y=this._y*e,this._z=this._z*e,this._w=this._w*e),this.onChangeCallback(),this},multiply:function(e,t){return void 0!==t?(console.warn("THREE.Quaternion: .multiply() now only accepts one argument. Use .multiplyQuaternions( a, b ) instead."),this.multiplyQuaternions(e,t)):this.multiplyQuaternions(this,e)},multiplyQuaternions:function(e,t){var n=e._x,r=e._y,i=e._z,o=e._w,s=t._x,a=t._y,c=t._z,u=t._w;return this._x=n*u+o*s+r*c-i*a,this._y=r*u+o*a+i*s-n*c,this._z=i*u+o*c+n*a-r*s,this._w=o*u-n*s-r*a-i*c,this.onChangeCallback(),this},multiplyVector3:function(e){return console.warn("THREE.Quaternion: .multiplyVector3() has been removed. Use is now vector.applyQuaternion( quaternion ) instead."),e.applyQuaternion(this)},slerp:function(e,t){if(0===t)return this;if(1===t)return this.copy(e);var n=this._x,r=this._y,i=this._z,o=this._w,s=o*e._w+n*e._x+r*e._y+i*e._z;if(s<0?(this._w=-e._w,this._x=-e._x,this._y=-e._y,this._z=-e._z,s=-s):this.copy(e),s>=1)return this._w=o,this._x=n,this._y=r,this._z=i,this;var a=Math.acos(s),c=Math.sqrt(1-s*s);if(Math.abs(c)<.001)return this._w=.5*(o+this._w),this._x=.5*(n+this._x),this._y=.5*(r+this._y),this._z=.5*(i+this._z),this;var u=Math.sin((1-t)*a)/c,l=Math.sin(t*a)/c;return this._w=o*u+this._w*l,this._x=n*u+this._x*l,this._y=r*u+this._y*l,this._z=i*u+this._z*l,this.onChangeCallback(),this},equals:function(e){return e._x===this._x&&e._y===this._y&&e._z===this._z&&e._w===this._w},fromArray:function(e,t){return void 0===t&&(t=0),this._x=e[t],this._y=e[t+1],this._z=e[t+2],this._w=e[t+3],this.onChangeCallback(),this},toArray:function(e,t){return void 0===e&&(e=[]),void 0===t&&(t=0),e[t]=this._x,e[t+1]=this._y,e[t+2]=this._z,e[t+3]=this._w,e},onChange:function(e){return this.onChangeCallback=e,this},onChangeCallback:function(){}},THREE.Quaternion.slerp=function(e,t,n,r){return n.copy(e).slerp(t,r)},THREE.Vector3=function(e,t,n){this.x=e||0,this.y=t||0,this.z=n||0},THREE.Vector3.prototype={constructor:THREE.Vector3,set:function(e,t,n){return this.x=e,this.y=t,this.z=n,this},setX:function(e){return this.x=e,this},setY:function(e){return this.y=e,this},setZ:function(e){return this.z=e,this},setComponent:function(e,t){switch(e){case 0:this.x=t;break;case 1:this.y=t;break;case 2:this.z=t;break;default:throw new Error("index is out of range: "+e)}},getComponent:function(e){switch(e){case 0:return this.x;case 1:return this.y;case 2:return this.z;default:throw new Error("index is out of range: "+e)}},clone:function(){return new this.constructor(this.x,this.y,this.z)},copy:function(e){return this.x=e.x,this.y=e.y,this.z=e.z,this},add:function(e,t){return void 0!==t?(console.warn("THREE.Vector3: .add() now only accepts one argument. Use .addVectors( a, b ) instead."),this.addVectors(e,t)):(this.x+=e.x,this.y+=e.y,this.z+=e.z,this)},addScalar:function(e){return this.x+=e,this.y+=e,this.z+=e,this},addVectors:function(e,t){return this.x=e.x+t.x,this.y=e.y+t.y,this.z=e.z+t.z,this},addScaledVector:function(e,t){return this.x+=e.x*t,this.y+=e.y*t,this.z+=e.z*t,this},sub:function(e,t){return void 0!==t?(console.warn("THREE.Vector3: .sub() now only accepts one argument. Use .subVectors( a, b ) instead."),this.subVectors(e,t)):(this.x-=e.x,this.y-=e.y,this.z-=e.z,this)},subScalar:function(e){return this.x-=e,this.y-=e,this.z-=e,this},subVectors:function(e,t){return this.x=e.x-t.x,this.y=e.y-t.y,this.z=e.z-t.z,this},multiply:function(e,t){return void 0!==t?(console.warn("THREE.Vector3: .multiply() now only accepts one argument. Use .multiplyVectors( a, b ) instead."),this.multiplyVectors(e,t)):(this.x*=e.x,this.y*=e.y,this.z*=e.z,this)},multiplyScalar:function(e){return this.x*=e,this.y*=e,this.z*=e,this},multiplyVectors:function(e,t){return this.x=e.x*t.x,this.y=e.y*t.y,this.z=e.z*t.z,this},applyEuler:function(){var e;return function(t){return t instanceof THREE.Euler==!1&&console.error("THREE.Vector3: .applyEuler() now expects a Euler rotation rather than a Vector3 and order."),void 0===e&&(e=new THREE.Quaternion),this.applyQuaternion(e.setFromEuler(t)),this}}(),applyAxisAngle:function(){var e;return function(t,n){return void 0===e&&(e=new THREE.Quaternion),this.applyQuaternion(e.setFromAxisAngle(t,n)),this}}(),applyMatrix3:function(e){var t=this.x,n=this.y,r=this.z,i=e.elements;return this.x=i[0]*t+i[3]*n+i[6]*r,this.y=i[1]*t+i[4]*n+i[7]*r,this.z=i[2]*t+i[5]*n+i[8]*r,this},applyMatrix4:function(e){var t=this.x,n=this.y,r=this.z,i=e.elements;return this.x=i[0]*t+i[4]*n+i[8]*r+i[12],this.y=i[1]*t+i[5]*n+i[9]*r+i[13],this.z=i[2]*t+i[6]*n+i[10]*r+i[14],this},applyProjection:function(e){var t=this.x,n=this.y,r=this.z,i=e.elements,o=1/(i[3]*t+i[7]*n+i[11]*r+i[15]);return this.x=(i[0]*t+i[4]*n+i[8]*r+i[12])*o,this.y=(i[1]*t+i[5]*n+i[9]*r+i[13])*o,this.z=(i[2]*t+i[6]*n+i[10]*r+i[14])*o,this},applyQuaternion:function(e){var t=this.x,n=this.y,r=this.z,i=e.x,o=e.y,s=e.z,a=e.w,c=a*t+o*r-s*n,u=a*n+s*t-i*r,l=a*r+i*n-o*t,h=-i*t-o*n-s*r;return this.x=c*a+h*-i+u*-s-l*-o,this.y=u*a+h*-o+l*-i-c*-s,this.z=l*a+h*-s+c*-o-u*-i,this},project:function(){var e;return function(t){return void 0===e&&(e=new THREE.Matrix4),e.multiplyMatrices(t.projectionMatrix,e.getInverse(t.matrixWorld)),this.applyProjection(e)}}(),unproject:function(){var e;return function(t){return void 0===e&&(e=new THREE.Matrix4),e.multiplyMatrices(t.matrixWorld,e.getInverse(t.projectionMatrix)),this.applyProjection(e)}}(),transformDirection:function(e){var t=this.x,n=this.y,r=this.z,i=e.elements;return this.x=i[0]*t+i[4]*n+i[8]*r,this.y=i[1]*t+i[5]*n+i[9]*r,this.z=i[2]*t+i[6]*n+i[10]*r,this.normalize(),this},divide:function(e){return this.x/=e.x,this.y/=e.y,this.z/=e.z,this},divideScalar:function(e){if(0!==e){var t=1/e;this.x*=t,this.y*=t,this.z*=t}else this.x=0,this.y=0,this.z=0;return this},min:function(e){return this.x>e.x&&(this.x=e.x),this.y>e.y&&(this.y=e.y),this.z>e.z&&(this.z=e.z),this},max:function(e){return this.x<e.x&&(this.x=e.x),this.y<e.y&&(this.y=e.y),this.z<e.z&&(this.z=e.z),this},clamp:function(e,t){return this.x<e.x?this.x=e.x:this.x>t.x&&(this.x=t.x),this.y<e.y?this.y=e.y:this.y>t.y&&(this.y=t.y),this.z<e.z?this.z=e.z:this.z>t.z&&(this.z=t.z),this},clampScalar:function(){var e,t;return function(n,r){return void 0===e&&(e=new THREE.Vector3,t=new THREE.Vector3),e.set(n,n,n),t.set(r,r,r),this.clamp(e,t)}}(),floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this},negate:function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},dot:function(e){return this.x*e.x+this.y*e.y+this.z*e.z},lengthSq:function(){return this.x*this.x+this.y*this.y+this.z*this.z},length:function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},lengthManhattan:function(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)},normalize:function(){return this.divideScalar(this.length())},setLength:function(e){var t=this.length();return 0!==t&&e!==t&&this.multiplyScalar(e/t),this},lerp:function(e,t){return this.x+=(e.x-this.x)*t,this.y+=(e.y-this.y)*t,this.z+=(e.z-this.z)*t,this},lerpVectors:function(e,t,n){return this.subVectors(t,e).multiplyScalar(n).add(e),this},cross:function(e,t){if(void 0!==t)return console.warn("THREE.Vector3: .cross() now only accepts one argument. Use .crossVectors( a, b ) instead."),this.crossVectors(e,t);var n=this.x,r=this.y,i=this.z;return this.x=r*e.z-i*e.y,this.y=i*e.x-n*e.z,this.z=n*e.y-r*e.x,this},crossVectors:function(e,t){var n=e.x,r=e.y,i=e.z,o=t.x,s=t.y,a=t.z;return this.x=r*a-i*s,this.y=i*o-n*a,this.z=n*s-r*o,this},projectOnVector:function(){var e,t;return function(n){return void 0===e&&(e=new THREE.Vector3),e.copy(n).normalize(),t=this.dot(e),this.copy(e).multiplyScalar(t)}}(),projectOnPlane:function(){var e;return function(t){return void 0===e&&(e=new THREE.Vector3),e.copy(this).projectOnVector(t),this.sub(e)}}(),reflect:function(){var e;return function(t){return void 0===e&&(e=new THREE.Vector3),this.sub(e.copy(t).multiplyScalar(2*this.dot(t)))}}(),angleTo:function(e){var t=this.dot(e)/(this.length()*e.length());return Math.acos(THREE.Math.clamp(t,-1,1))},distanceTo:function(e){return Math.sqrt(this.distanceToSquared(e))},distanceToSquared:function(e){var t=this.x-e.x,n=this.y-e.y,r=this.z-e.z;return t*t+n*n+r*r},setEulerFromRotationMatrix:function(e,t){console.error("THREE.Vector3: .setEulerFromRotationMatrix() has been removed. Use Euler.setFromRotationMatrix() instead.")},setEulerFromQuaternion:function(e,t){console.error("THREE.Vector3: .setEulerFromQuaternion() has been removed. Use Euler.setFromQuaternion() instead.")},getPositionFromMatrix:function(e){return console.warn("THREE.Vector3: .getPositionFromMatrix() has been renamed to .setFromMatrixPosition()."),this.setFromMatrixPosition(e)},getScaleFromMatrix:function(e){return console.warn("THREE.Vector3: .getScaleFromMatrix() has been renamed to .setFromMatrixScale()."),this.setFromMatrixScale(e)},getColumnFromMatrix:function(e,t){return console.warn("THREE.Vector3: .getColumnFromMatrix() has been renamed to .setFromMatrixColumn()."),this.setFromMatrixColumn(e,t)},setFromMatrixPosition:function(e){return this.x=e.elements[12],this.y=e.elements[13],this.z=e.elements[14],this},setFromMatrixScale:function(e){var t=this.set(e.elements[0],e.elements[1],e.elements[2]).length(),n=this.set(e.elements[4],e.elements[5],e.elements[6]).length(),r=this.set(e.elements[8],e.elements[9],e.elements[10]).length();return this.x=t,this.y=n,this.z=r,this},setFromMatrixColumn:function(e,t){var n=4*e,r=t.elements;return this.x=r[n],this.y=r[n+1],this.z=r[n+2],this},equals:function(e){return e.x===this.x&&e.y===this.y&&e.z===this.z},fromArray:function(e,t){return void 0===t&&(t=0),this.x=e[t],this.y=e[t+1],this.z=e[t+2],this},toArray:function(e,t){return void 0===e&&(e=[]),void 0===t&&(t=0),e[t]=this.x,e[t+1]=this.y,e[t+2]=this.z,e},fromAttribute:function(e,t,n){return void 0===n&&(n=0),t=t*e.itemSize+n,this.x=e.array[t],this.y=e.array[t+1],this.z=e.array[t+2],this}},THREE.Matrix4=function(){this.elements=new Float32Array([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])},THREE.Matrix4.prototype={constructor:THREE.Matrix4,set:function(e,t,n,r,i,o,s,a,c,u,l,h,d,p,m,f){var y=this.elements;return y[0]=e,y[4]=t,y[8]=n,y[12]=r,y[1]=i,y[5]=o,y[9]=s,y[13]=a,y[2]=c,y[6]=u,y[10]=l,y[14]=h,y[3]=d,y[7]=p,y[11]=m,y[15]=f,this},identity:function(){return this.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1),this},clone:function(){return(new THREE.Matrix4).fromArray(this.elements)},copy:function(e){return this.elements.set(e.elements),this},extractPosition:function(e){return console.warn("THREE.Matrix4: .extractPosition() has been renamed to .copyPosition()."),this.copyPosition(e)},copyPosition:function(e){var t=this.elements,n=e.elements;return t[12]=n[12],t[13]=n[13],t[14]=n[14],this},extractBasis:function(e,t,n){var r=this.elements;return e.set(r[0],r[1],r[2]),t.set(r[4],r[5],r[6]),n.set(r[8],r[9],r[10]),this},makeBasis:function(e,t,n){return this.set(e.x,t.x,n.x,0,e.y,t.y,n.y,0,e.z,t.z,n.z,0,0,0,0,1),this},extractRotation:function(){var e;return function(t){void 0===e&&(e=new THREE.Vector3);var n=this.elements,r=t.elements,i=1/e.set(r[0],r[1],r[2]).length(),o=1/e.set(r[4],r[5],r[6]).length(),s=1/e.set(r[8],r[9],r[10]).length();return n[0]=r[0]*i,n[1]=r[1]*i,n[2]=r[2]*i,n[4]=r[4]*o,n[5]=r[5]*o,n[6]=r[6]*o,n[8]=r[8]*s,n[9]=r[9]*s,n[10]=r[10]*s,this}}(),makeRotationFromEuler:function(e){e instanceof THREE.Euler==!1&&console.error("THREE.Matrix: .makeRotationFromEuler() now expects a Euler rotation rather than a Vector3 and order.");var t=this.elements,n=e.x,r=e.y,i=e.z,o=Math.cos(n),s=Math.sin(n),a=Math.cos(r),c=Math.sin(r),u=Math.cos(i),l=Math.sin(i);if("XYZ"===e.order){var h=o*u,d=o*l,p=s*u,m=s*l;t[0]=a*u,t[4]=-a*l,t[8]=c,t[1]=d+p*c,t[5]=h-m*c,t[9]=-s*a,t[2]=m-h*c,t[6]=p+d*c,t[10]=o*a}else if("YXZ"===e.order){var f=a*u,y=a*l,g=c*u,v=c*l;t[0]=f+v*s,t[4]=g*s-y,t[8]=o*c,t[1]=o*l,t[5]=o*u,t[9]=-s,t[2]=y*s-g,t[6]=v+f*s,t[10]=o*a}else if("ZXY"===e.order){var f=a*u,y=a*l,g=c*u,v=c*l;t[0]=f-v*s,t[4]=-o*l,t[8]=g+y*s,t[1]=y+g*s,t[5]=o*u,t[9]=v-f*s,t[2]=-o*c,t[6]=s,t[10]=o*a}else if("ZYX"===e.order){var h=o*u,d=o*l,p=s*u,m=s*l;t[0]=a*u,t[4]=p*c-d,t[8]=h*c+m,t[1]=a*l,t[5]=m*c+h,t[9]=d*c-p,t[2]=-c,t[6]=s*a,t[10]=o*a}else if("YZX"===e.order){var w=o*a,b=o*c,x=s*a,P=s*c;t[0]=a*u,t[4]=P-w*l,t[8]=x*l+b,t[1]=l,t[5]=o*u,t[9]=-s*u,t[2]=-c*u,t[6]=b*l+x,t[10]=w-P*l}else if("XZY"===e.order){var w=o*a,b=o*c,x=s*a,P=s*c;t[0]=a*u,t[4]=-l,t[8]=c*u,t[1]=w*l+P,t[5]=o*u,t[9]=b*l-x,t[2]=x*l-b,t[6]=s*u,t[10]=P*l+w}return t[3]=0,t[7]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,this},setRotationFromQuaternion:function(e){return console.warn("THREE.Matrix4: .setRotationFromQuaternion() has been renamed to .makeRotationFromQuaternion()."),this.makeRotationFromQuaternion(e)},makeRotationFromQuaternion:function(e){var t=this.elements,n=e.x,r=e.y,i=e.z,o=e.w,s=n+n,a=r+r,c=i+i,u=n*s,l=n*a,h=n*c,d=r*a,p=r*c,m=i*c,f=o*s,y=o*a,g=o*c;return t[0]=1-(d+m),t[4]=l-g,t[8]=h+y,t[1]=l+g,t[5]=1-(u+m),t[9]=p-f,t[2]=h-y,t[6]=p+f,t[10]=1-(u+d),t[3]=0,t[7]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,this},lookAt:function(){var e,t,n;return function(r,i,o){void 0===e&&(e=new THREE.Vector3),void 0===t&&(t=new THREE.Vector3),void 0===n&&(n=new THREE.Vector3);var s=this.elements;return n.subVectors(r,i).normalize(),0===n.length()&&(n.z=1),e.crossVectors(o,n).normalize(),0===e.length()&&(n.x+=1e-4,e.crossVectors(o,n).normalize()),t.crossVectors(n,e),s[0]=e.x,s[4]=t.x,s[8]=n.x,s[1]=e.y,s[5]=t.y,s[9]=n.y,s[2]=e.z,s[6]=t.z,s[10]=n.z,this}}(),multiply:function(e,t){return void 0!==t?(console.warn("THREE.Matrix4: .multiply() now only accepts one argument. Use .multiplyMatrices( a, b ) instead."),this.multiplyMatrices(e,t)):this.multiplyMatrices(this,e)},multiplyMatrices:function(e,t){var n=e.elements,r=t.elements,i=this.elements,o=n[0],s=n[4],a=n[8],c=n[12],u=n[1],l=n[5],h=n[9],d=n[13],p=n[2],m=n[6],f=n[10],y=n[14],g=n[3],v=n[7],w=n[11],b=n[15],x=r[0],P=r[4],T=r[8],E=r[12],k=r[1],_=r[5],S=r[9],C=r[13],R=r[2],O=r[6],M=r[10],I=r[14],A=r[3],j=r[7],N=r[11],D=r[15];return i[0]=o*x+s*k+a*R+c*A,i[4]=o*P+s*_+a*O+c*j,i[8]=o*T+s*S+a*M+c*N,i[12]=o*E+s*C+a*I+c*D,i[1]=u*x+l*k+h*R+d*A,i[5]=u*P+l*_+h*O+d*j,i[9]=u*T+l*S+h*M+d*N,i[13]=u*E+l*C+h*I+d*D,i[2]=p*x+m*k+f*R+y*A,i[6]=p*P+m*_+f*O+y*j,i[10]=p*T+m*S+f*M+y*N,i[14]=p*E+m*C+f*I+y*D,i[3]=g*x+v*k+w*R+b*A,i[7]=g*P+v*_+w*O+b*j,i[11]=g*T+v*S+w*M+b*N,i[15]=g*E+v*C+w*I+b*D,this},multiplyToArray:function(e,t,n){var r=this.elements;return this.multiplyMatrices(e,t),n[0]=r[0],n[1]=r[1],n[2]=r[2],n[3]=r[3],n[4]=r[4],n[5]=r[5],n[6]=r[6],n[7]=r[7],n[8]=r[8],n[9]=r[9],n[10]=r[10],n[11]=r[11],n[12]=r[12],n[13]=r[13],n[14]=r[14],n[15]=r[15],this},multiplyScalar:function(e){var t=this.elements;return t[0]*=e,t[4]*=e,t[8]*=e,t[12]*=e,t[1]*=e,t[5]*=e,t[9]*=e,t[13]*=e,t[2]*=e,t[6]*=e,t[10]*=e,t[14]*=e,t[3]*=e,t[7]*=e,t[11]*=e,t[15]*=e,this},multiplyVector3:function(e){return console.warn("THREE.Matrix4: .multiplyVector3() has been removed. Use vector.applyMatrix4( matrix ) or vector.applyProjection( matrix ) instead."),e.applyProjection(this)},multiplyVector4:function(e){return console.warn("THREE.Matrix4: .multiplyVector4() has been removed. Use vector.applyMatrix4( matrix ) instead."),
e.applyMatrix4(this)},multiplyVector3Array:function(e){return console.warn("THREE.Matrix4: .multiplyVector3Array() has been renamed. Use matrix.applyToVector3Array( array ) instead."),this.applyToVector3Array(e)},applyToVector3Array:function(){var e;return function(t,n,r){void 0===e&&(e=new THREE.Vector3),void 0===n&&(n=0),void 0===r&&(r=t.length);for(var i=0,o=n;i<r;i+=3,o+=3)e.fromArray(t,o),e.applyMatrix4(this),e.toArray(t,o);return t}}(),applyToBuffer:function(){var e;return function(t,n,r){void 0===e&&(e=new THREE.Vector3),void 0===n&&(n=0),void 0===r&&(r=t.length/t.itemSize);for(var i=0,o=n;i<r;i++,o++)e.x=t.getX(o),e.y=t.getY(o),e.z=t.getZ(o),e.applyMatrix4(this),t.setXYZ(e.x,e.y,e.z);return t}}(),rotateAxis:function(e){console.warn("THREE.Matrix4: .rotateAxis() has been removed. Use Vector3.transformDirection( matrix ) instead."),e.transformDirection(this)},crossVector:function(e){return console.warn("THREE.Matrix4: .crossVector() has been removed. Use vector.applyMatrix4( matrix ) instead."),e.applyMatrix4(this)},determinant:function(){var e=this.elements,t=e[0],n=e[4],r=e[8],i=e[12],o=e[1],s=e[5],a=e[9],c=e[13],u=e[2],l=e[6],h=e[10],d=e[14],p=e[3],m=e[7],f=e[11],y=e[15];return p*(+i*a*l-r*c*l-i*s*h+n*c*h+r*s*d-n*a*d)+m*(+t*a*d-t*c*h+i*o*h-r*o*d+r*c*u-i*a*u)+f*(+t*c*l-t*s*d-i*o*l+n*o*d+i*s*u-n*c*u)+y*(-r*s*u-t*a*l+t*s*h+r*o*l-n*o*h+n*a*u)},transpose:function(){var e,t=this.elements;return e=t[1],t[1]=t[4],t[4]=e,e=t[2],t[2]=t[8],t[8]=e,e=t[6],t[6]=t[9],t[9]=e,e=t[3],t[3]=t[12],t[12]=e,e=t[7],t[7]=t[13],t[13]=e,e=t[11],t[11]=t[14],t[14]=e,this},flattenToArrayOffset:function(e,t){var n=this.elements;return e[t]=n[0],e[t+1]=n[1],e[t+2]=n[2],e[t+3]=n[3],e[t+4]=n[4],e[t+5]=n[5],e[t+6]=n[6],e[t+7]=n[7],e[t+8]=n[8],e[t+9]=n[9],e[t+10]=n[10],e[t+11]=n[11],e[t+12]=n[12],e[t+13]=n[13],e[t+14]=n[14],e[t+15]=n[15],e},getPosition:function(){var e;return function(){void 0===e&&(e=new THREE.Vector3),console.warn("THREE.Matrix4: .getPosition() has been removed. Use Vector3.setFromMatrixPosition( matrix ) instead.");var t=this.elements;return e.set(t[12],t[13],t[14])}}(),setPosition:function(e){var t=this.elements;return t[12]=e.x,t[13]=e.y,t[14]=e.z,this},getInverse:function(e,t){var n=this.elements,r=e.elements,i=r[0],o=r[4],s=r[8],a=r[12],c=r[1],u=r[5],l=r[9],h=r[13],d=r[2],p=r[6],m=r[10],f=r[14],y=r[3],g=r[7],v=r[11],w=r[15];n[0]=l*f*g-h*m*g+h*p*v-u*f*v-l*p*w+u*m*w,n[4]=a*m*g-s*f*g-a*p*v+o*f*v+s*p*w-o*m*w,n[8]=s*h*g-a*l*g+a*u*v-o*h*v-s*u*w+o*l*w,n[12]=a*l*p-s*h*p-a*u*m+o*h*m+s*u*f-o*l*f,n[1]=h*m*y-l*f*y-h*d*v+c*f*v+l*d*w-c*m*w,n[5]=s*f*y-a*m*y+a*d*v-i*f*v-s*d*w+i*m*w,n[9]=a*l*y-s*h*y-a*c*v+i*h*v+s*c*w-i*l*w,n[13]=s*h*d-a*l*d+a*c*m-i*h*m-s*c*f+i*l*f,n[2]=u*f*y-h*p*y+h*d*g-c*f*g-u*d*w+c*p*w,n[6]=a*p*y-o*f*y-a*d*g+i*f*g+o*d*w-i*p*w,n[10]=o*h*y-a*u*y+a*c*g-i*h*g-o*c*w+i*u*w,n[14]=a*u*d-o*h*d-a*c*p+i*h*p+o*c*f-i*u*f,n[3]=l*p*y-u*m*y-l*d*g+c*m*g+u*d*v-c*p*v,n[7]=o*m*y-s*p*y+s*d*g-i*m*g-o*d*v+i*p*v,n[11]=s*u*y-o*l*y-s*c*g+i*l*g+o*c*v-i*u*v,n[15]=o*l*d-s*u*d+s*c*p-i*l*p-o*c*m+i*u*m;var b=i*n[0]+c*n[4]+d*n[8]+y*n[12];if(0===b){var x="THREE.Matrix4.getInverse(): can't invert matrix, determinant is 0";if(t)throw new Error(x);return console.warn(x),this.identity(),this}return this.multiplyScalar(1/b),this},translate:function(e){console.error("THREE.Matrix4: .translate() has been removed.")},rotateX:function(e){console.error("THREE.Matrix4: .rotateX() has been removed.")},rotateY:function(e){console.error("THREE.Matrix4: .rotateY() has been removed.")},rotateZ:function(e){console.error("THREE.Matrix4: .rotateZ() has been removed.")},rotateByAxis:function(e,t){console.error("THREE.Matrix4: .rotateByAxis() has been removed.")},scale:function(e){var t=this.elements,n=e.x,r=e.y,i=e.z;return t[0]*=n,t[4]*=r,t[8]*=i,t[1]*=n,t[5]*=r,t[9]*=i,t[2]*=n,t[6]*=r,t[10]*=i,t[3]*=n,t[7]*=r,t[11]*=i,this},getMaxScaleOnAxis:function(){var e=this.elements,t=e[0]*e[0]+e[1]*e[1]+e[2]*e[2],n=e[4]*e[4]+e[5]*e[5]+e[6]*e[6],r=e[8]*e[8]+e[9]*e[9]+e[10]*e[10];return Math.sqrt(Math.max(t,Math.max(n,r)))},makeTranslation:function(e,t,n){return this.set(1,0,0,e,0,1,0,t,0,0,1,n,0,0,0,1),this},makeRotationX:function(e){var t=Math.cos(e),n=Math.sin(e);return this.set(1,0,0,0,0,t,-n,0,0,n,t,0,0,0,0,1),this},makeRotationY:function(e){var t=Math.cos(e),n=Math.sin(e);return this.set(t,0,n,0,0,1,0,0,-n,0,t,0,0,0,0,1),this},makeRotationZ:function(e){var t=Math.cos(e),n=Math.sin(e);return this.set(t,-n,0,0,n,t,0,0,0,0,1,0,0,0,0,1),this},makeRotationAxis:function(e,t){var n=Math.cos(t),r=Math.sin(t),i=1-n,o=e.x,s=e.y,a=e.z,c=i*o,u=i*s;return this.set(c*o+n,c*s-r*a,c*a+r*s,0,c*s+r*a,u*s+n,u*a-r*o,0,c*a-r*s,u*a+r*o,i*a*a+n,0,0,0,0,1),this},makeScale:function(e,t,n){return this.set(e,0,0,0,0,t,0,0,0,0,n,0,0,0,0,1),this},compose:function(e,t,n){return this.makeRotationFromQuaternion(t),this.scale(n),this.setPosition(e),this},decompose:function(){var e,t;return function(n,r,i){void 0===e&&(e=new THREE.Vector3),void 0===t&&(t=new THREE.Matrix4);var o=this.elements,s=e.set(o[0],o[1],o[2]).length(),a=e.set(o[4],o[5],o[6]).length(),c=e.set(o[8],o[9],o[10]).length(),u=this.determinant();u<0&&(s=-s),n.x=o[12],n.y=o[13],n.z=o[14],t.elements.set(this.elements);var l=1/s,h=1/a,d=1/c;return t.elements[0]*=l,t.elements[1]*=l,t.elements[2]*=l,t.elements[4]*=h,t.elements[5]*=h,t.elements[6]*=h,t.elements[8]*=d,t.elements[9]*=d,t.elements[10]*=d,r.setFromRotationMatrix(t),i.x=s,i.y=a,i.z=c,this}}(),makeFrustum:function(e,t,n,r,i,o){var s=this.elements,a=2*i/(t-e),c=2*i/(r-n),u=(t+e)/(t-e),l=(r+n)/(r-n),h=-(o+i)/(o-i),d=-2*o*i/(o-i);return s[0]=a,s[4]=0,s[8]=u,s[12]=0,s[1]=0,s[5]=c,s[9]=l,s[13]=0,s[2]=0,s[6]=0,s[10]=h,s[14]=d,s[3]=0,s[7]=0,s[11]=-1,s[15]=0,this},makePerspective:function(e,t,n,r){var i=n*Math.tan(THREE.Math.degToRad(.5*e)),o=-i,s=o*t,a=i*t;return this.makeFrustum(s,a,o,i,n,r)},makeOrthographic:function(e,t,n,r,i,o){var s=this.elements,a=t-e,c=n-r,u=o-i,l=(t+e)/a,h=(n+r)/c,d=(o+i)/u;return s[0]=2/a,s[4]=0,s[8]=0,s[12]=-l,s[1]=0,s[5]=2/c,s[9]=0,s[13]=-h,s[2]=0,s[6]=0,s[10]=-2/u,s[14]=-d,s[3]=0,s[7]=0,s[11]=0,s[15]=1,this},equals:function(e){for(var t=this.elements,n=e.elements,r=0;r<16;r++)if(t[r]!==n[r])return!1;return!0},fromArray:function(e){return this.elements.set(e),this},toArray:function(){var e=this.elements;return[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15]]}},THREE.Math={generateUUID:function(){var e,t="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),n=new Array(36),r=0;return function(){for(var i=0;i<36;i++)8===i||13===i||18===i||23===i?n[i]="-":14===i?n[i]="4":(r<=2&&(r=33554432+16777216*Math.random()|0),e=15&r,r>>=4,n[i]=t[19===i?3&e|8:e]);return n.join("")}}(),clamp:function(e,t,n){return e<t?t:e>n?n:e},clampBottom:function(e,t){return e<t?t:e},euclideanModulo:function(e,t){return(e%t+t)%t},mapLinear:function(e,t,n,r,i){return r+(e-t)*(i-r)/(n-t)},smoothstep:function(e,t,n){return e<=t?0:e>=n?1:(e=(e-t)/(n-t),e*e*(3-2*e))},smootherstep:function(e,t,n){return e<=t?0:e>=n?1:(e=(e-t)/(n-t),e*e*e*(e*(6*e-15)+10))},random16:function(){return(65280*Math.random()+255*Math.random())/65535},randInt:function(e,t){return e+Math.floor(Math.random()*(t-e+1))},randFloat:function(e,t){return e+Math.random()*(t-e)},randFloatSpread:function(e){return e*(.5-Math.random())},degToRad:function(){var e=Math.PI/180;return function(t){return t*e}}(),radToDeg:function(){var e=180/Math.PI;return function(t){return t*e}}(),isPowerOfTwo:function(e){return 0===(e&e-1)&&0!==e},nextPowerOfTwo:function(e){return e--,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,e++,e}})}(),this.objectIDs=[],this.objects={},this.geometryCache={},this.a=new THREE.Vector3,this.b=new THREE.Vector3,this.c=new THREE.Vector3,this.d=new THREE.Vector3,this.from=new THREE.Vector3,this.to=new THREE.Vector3,this.m=new THREE.Matrix4,this.listeners={hit:[]},this.ready=!0}pliny.class({parent:"Primrose",name:"Projector",description:"| [under construction]"}),e.prototype.addEventListener=function(e,t){this.listeners[e]||(this.listeners[e]=[]),this.listeners[e].push(t)},e.prototype._emit=emit,e.prototype._transform=function(e,t){return t.clone().applyMatrix4(e.matrix)},e.prototype._getVerts=function(e){for(var t=[],n=this.geometryCache[e.geomID],r=n.vertices,i=0;i<r.length;++i)t[i]=this._transform(e,r[i]);return t},e.prototype.setObject=function(e){this.objectIDs.push(e.uuid),this.objects[e.uuid]=e,e.matrix=(new THREE.Matrix4).fromArray(e.matrix);var t=e.geometry.uvs,n=Number.MAX_VALUE,r=Number.MAX_VALUE,i=Number.MIN_VALUE,o=Number.MIN_VALUE;if(t&&t.length>0)for(var s=0;s<t.length;++s){var a=t[s];if(a){var c=a[0],u=a[1];n=Math.min(n,c),i=Math.max(i,c),r=Math.min(r,u),o=Math.max(o,u)}}else n=0,i=1,r=0,o=1;if(this.setProperty(e.uuid,"minU",n),this.setProperty(e.uuid,"maxU",i),this.setProperty(e.uuid,"minV",r),this.setProperty(e.uuid,"maxV",o),this.setProperty(e.uuid,"geomID",e.geometry.uuid),!this.geometryCache[e.geometry.uuid]){this.geometryCache[e.geometry.uuid]=e.geometry;for(var l=0,h=e.geometry.vertices,d=h.length;l<d;++l)h[l]=(new THREE.Vector3).fromArray(h[l])}this.updateObjects([e])},e.prototype.updateObjects=function(e){for(var t=0;t<e.length;++t){var n=e[t];if(n.inScene!==!1){var r=this.objects[n.uuid];null!==n.matrix&&r.matrix.fromArray(n.matrix),null!==n.visible&&this.setProperty(n.uuid,"visible",n.visible),null!==n.disabled&&this.setProperty(n.uuid,"disabled",n.disabled)}else{delete this.objects[n.uuid];for(var i=!1,o=0;!i&&o<this.objectIDs.length;++o){var s=this.objects[this.objectIDs[o]];i=i||s&&s.geomID===n.geomID}i||delete this.geometryCache[n.geomID],this.objectIDs.splice(this.objectIDs.indexOf(n.uuid),1)}}},e.prototype.setProperty=function(e,t,n){for(var r=this.objects[e],i=t.split(".");i.length>1;)t=i.shift(),r[t]||(r[t]={}),r=r[t];1===i.length&&(t=i[0],r[i[0]]=n)},e.prototype.projectPointers=function(e){for(var t={},n=0;n<e.length;++n){var r=e[n],i=r[0],o=r[1],s=r[2],a=null;this.from.fromArray(o),this.to.fromArray(s);for(var c=0;c<this.objectIDs.length;++c){var u=this.objectIDs[c],l=this.objects[u];if(!l.disabled)for(var h=this._getVerts(l),d=l.geometry.faces,p=l.geometry.uvs,m=0;m<d.length;++m){var f=d[m],y=h[f[0]%h.length],g=h[f[1]%h.length],v=h[f[2]%h.length];if(this.a.subVectors(g,y),this.b.subVectors(v,y),this.c.subVectors(this.to,this.from),this.m.set(this.a.x,this.b.x,-this.c.x,0,this.a.y,this.b.y,-this.c.y,0,this.a.z,this.b.z,-this.c.z,0,0,0,0,1),Math.abs(this.m.determinant())>1e-10&&(this.m.getInverse(this.m),this.d.subVectors(this.from,y).applyMatrix4(this.m),0<=this.d.x&&this.d.x<=1&&0<=this.d.y&&this.d.y<=1&&this.d.z>0)){this.c.multiplyScalar(this.d.z).add(this.from);var w=Math.sign(this.d.z)*this.to.distanceTo(this.c);if((!a||w<a.distance)&&(a={name:i,objectID:u,distance:w,faceIndex:m,facePoint:this.c.toArray(),faceNormal:this.d.toArray()},p)){y=p[f[0]%p.length],g=p[f[1]%p.length],v=p[f[2]%p.length];var b=this.d.x*(g[0]-y[0])+this.d.y*(v[0]-y[0])+y[0],x=this.d.x*(g[1]-y[1])+this.d.y*(v[1]-y[1])+y[1];l.minU<=b&&b<=l.maxU&&l.minV<=x&&x<l.maxV?a.point=[b,x]:a=null}}}}a&&(t[i]=a)}this._emit("hit",t)},"undefined"!=typeof window&&(window.Primrose.Projector=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"Random",description:"Functions for handling random numbers of different criteria, or selecting random elements of arrays."});var e={};"undefined"!=typeof window&&(window.Primrose.Random=e)}(),function(){"use strict";pliny.value({name:"SKINS",type:"Array of String",description:"A selection of color values that closely match skin colors of people."});var e=["#FFDFC4","#F0D5BE","#EECEB3","#E1B899","#E5C298","#FFDCB2","#E5B887","#E5A073","#E79E6D","#DB9065","#CE967C","#C67856","#BA6C49","#A57257","#F0C8C9","#DDA8A0","#B97C6D","#A8756C","#AD6452","#5C3836","#CB8442","#BD723C","#704139","#A3866A","#870400","#710101","#430000","#5B0001","#302E2E"];"undefined"!=typeof window&&(window.Primrose.SKINS=e)}(),function(){"use strict";pliny.value({name:"SKIN_VALUES",type:"Array of Number",description:"A selection of color values that closely match skin colors of people."});var e=Primrose.SKINS.map(function(e){return parseInt(e.substring(1),16)});"undefined"!=typeof window&&(window.Primrose.SKINS_VALUES=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e},i=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),s=0;pliny.class({parent:"Primrose",name:"Surface",description:"Cascades through a number of options to eventually return a CanvasRenderingContext2D object on which one will perform drawing operations.",baseClass:"Primrose.Entity",parameters:[{name:"options.id",type:"String or HTMLCanvasElement or CanvasRenderingContext2D",description:"Either an ID of an element that exists, an element, or the ID to set on an element that is to be created."},{name:"options.bounds",type:"Primrose.Text.Rectangle",description:"The size and location of the surface to create."}]});var a=function(a){function c(n){e(this,c);var i=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this));if(i.options=patch(n,{id:"Primrose.Surface["+s++ +"]",bounds:new Primrose.Text.Rectangle}),i.listeners.move=[],i.bounds=i.options.bounds,i.canvas=null,i.context=null,i._opacity=1,i.style={},Object.defineProperties(i.style,{width:{get:function(){return i.bounds.width},set:function(e){i.bounds.width=e,i.resize()}},height:{get:function(){return i.bounds.height},set:function(e){i.bounds.height=e,i.resize()}},left:{get:function(){return i.bounds.left},set:function(e){i.bounds.left=e}},top:{get:function(){return i.bounds.top},set:function(e){i.bounds.top=e}},opacity:{get:function(){return i._opacity},set:function(e){i._opacity=e}},fontSize:{get:function(){return i.fontSize},set:function(e){i.fontSize=e}},backgroundColor:{get:function(){return i.backgroundColor},set:function(e){i.backgroundColor=e}},color:{get:function(){return i.color},set:function(e){i.color=e}}}),i.options.id instanceof c)throw new Error("Object is already a Surface. Please don't try to wrap them.");if(i.options.id instanceof CanvasRenderingContext2D?(i.context=i.options.id,i.canvas=i.context.canvas):i.options.id instanceof HTMLCanvasElement?i.canvas=i.options.id:("string"==typeof i.options.id||i.options.id instanceof String)&&(i.canvas=document.getElementById(i.options.id),null===i.canvas?(i.canvas=document.createElement("canvas"),i.canvas.id=i.options.id):"CANVAS"!==i.canvas.tagName&&(i.canvas=null)),null===i.canvas)throw pliny.error({name:"Invalid element",type:"Error",description:"If the element could not be found, could not be created, or one of the appropriate ID was found but did not match the expected type, an error is thrown to halt operation."}),console.error(r(i.options.id)),console.error(i.options.id),new Error(i.options.id+" does not refer to a valid canvas element.");return i.id=i.canvas.id,0===i.bounds.width&&(i.bounds.width=i.imageWidth,i.bounds.height=i.imageHeight),i.imageWidth=i.bounds.width,i.imageHeight=i.bounds.height,null===i.context&&(i.context=i.canvas.getContext("2d")),i.canvas.style.imageRendering=isChrome?"pixelated":"optimizespeed",i.context.imageSmoothingEnabled=!1,i.context.textBaseline="top",i._texture=null,i._material=null,i}return n(c,a),o(c,null,[{key:"create",value:function(){return new c}}]),o(c,[{key:"addToBrowserEnvironment",value:function(e,t){var n="shell"===this.className?shell(3,10,10):quad(2,2),r=textured(n,this,{opacity:this._opacity});return t.add(r),e.registerPickableObject(r),r}},{key:"invalidate",value:function(e){e?e instanceof Primrose.Text.Rectangle&&(e=e.clone()):(e=this.bounds.clone(),e.left=0,e.top=0);for(var t=0;t<this.children.length;++t){var n=this.children[t],r=e.overlap(n.bounds);if(r){var i=r.left-n.bounds.left,o=r.top-n.bounds.top;this.context.drawImage(n.canvas,i,o,r.width,r.height,r.x,r.y,r.width,r.height)}}this._texture&&(this._texture.needsUpdate=!0),this._material&&(this._material.needsUpdate=!0),this.parent&&this.parent.invalidate&&(e.left+=this.bounds.left,e.top+=this.bounds.top,this.parent.invalidate(e))}},{key:"render",value:function(){this.invalidate()}},{key:"resize",value:function(){this.setSize(this.surfaceWidth,this.surfaceHeight)}},{key:"setSize",value:function(e,t){var n=this.context.textBaseline,r=this.context.textAlign;this.imageWidth=e,this.imageHeight=t,this.context.textBaseline=n,this.context.textAlign=r}},{key:"appendChild",value:function(e){if(!(e instanceof c))throw new Error("Can only append other Surfaces to a Surface. You gave: "+e);i(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"appendChild",this).call(this,e),this.invalidate()}},{key:"mapUV",value:function(e){return{x:e[0]*this.imageWidth,y:(1-e[1])*this.imageHeight}}},{key:"unmapUV",value:function(e){return[e.x/this.imageWidth,1-e.y/this.imageHeight]}},{key:"_findChild",value:function(e,t,n){for(var r=this.inBounds(e,t),i=null,o=this.children.length-1;o>=0;--o){var s=this.children[o];!i&&s.inBounds(e-this.bounds.left,t-this.bounds.top)?i=s:s.focused&&s.blur()}return i||r&&this}},{key:"DOMInBounds",value:function(e,t){return this.inBounds(e*devicePixelRatio,t*devicePixelRatio)}},{key:"UVInBounds",value:function(e){return this.inBounds(e[0]*this.imageWidth,(1-e[1])*this.imageHeight)}},{key:"inBounds",value:function(e,t){return this.bounds.left<=e&&e<this.bounds.right&&this.bounds.top<=t&&t<this.bounds.bottom}},{key:"startDOMPointer",value:function(e){this.startPointer(x*devicePixelRatio,y*devicePixelRatio)}},{key:"moveDOMPointer",value:function(e){this.movePointer(x*devicePixelRatio,y*devicePixelRatio)}},{key:"startPointer",value:function(e,t){if(this.inBounds(e,t)){var n=this._findChild(e,t,function(e,t,n){return e.startPointer(t,n)});n?(this.focused||this.focus(),emit.call(this,"click",{target:n,x:e,y:t}),n!==this&&n.startPointer(e-this.bounds.left,t-this.bounds.top)):this.focused&&this.blur()}}},{key:"movePointer",value:function(e,t){var n=this._findChild(e,t,function(e,t,n){return e.startPointer(t,n)});n&&(emit.call(this,"move",{target:n,x:e,y:t}),n!==this&&n.movePointer(e-this.bounds.left,t-this.bounds.top))}},{key:"startUV",value:function(e){var t=this.mapUV(e);this.startPointer(t.x,t.y)}},{key:"moveUV",value:function(e){var t=this.mapUV(e);this.movePointer(t.x,t.y)}},{key:"imageWidth",get:function(){return this.canvas.width},set:function(e){this.canvas.width=e,this.bounds.width=e}},{key:"imageHeight",get:function(){return this.canvas.height},set:function(e){this.canvas.height=e,this.bounds.height=e}},{key:"elementWidth",get:function(){return this.canvas.clientWidth*devicePixelRatio},set:function(e){this.canvas.style.width=e/devicePixelRatio+"px"}},{key:"elementHeight",get:function(){return this.canvas.clientHeight*devicePixelRatio},set:function(e){this.canvas.style.height=e/devicePixelRatio+"px"}},{key:"surfaceWidth",get:function(){return this.canvas.parentElement?this.elementWidth:this.bounds.width}},{key:"surfaceHeight",get:function(){return this.canvas.parentElement?this.elementHeight:this.bounds.height}},{key:"resized",get:function(){return this.imageWidth!==this.surfaceWidth||this.imageHeight!==this.surfaceHeight}},{key:"texture",get:function(){return this._texture||(this._texture=new THREE.Texture(this.canvas)),this._texture}}]),c}(Primrose.Entity);"undefined"!=typeof window&&(window.Primrose.Surface=a)}(),function(){"use strict";pliny.value({parent:"Primrose",name:"SYS_FONTS",type:"String",description:"A selection of fonts that will match whatever the user's operating system normally uses."});var e="-apple-system, '.SFNSText-Regular', 'San Francisco', 'Roboto', 'Segoe UI', 'Helvetica Neue', 'Lucida Grande', sans-serif";"undefined"!=typeof window&&(window.Primrose.SYS_FONTS=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"Text",description:"The Text namespace contains classes everything regarding the Primrose source code editor."});var e={};"undefined"!=typeof window&&(window.Primrose.Text=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e){for(var t=e.getMilliseconds().toString();t.length<3;)t="0"+t;return e.toLocaleTimeString().replace(/(\d+:\d+:\d+)/,function(e,n){return n+"."+t})}var n=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),r=1e4;window.RTCPeerConnection=window.RTCPeerConnection||window.webkitRTCPeerConnection||window.mozRTCPeerConnection,window.RTCIceCandidate=window.RTCIceCandidate||window.mozRTCIceCandidate,window.RTCSessionDescription=window.RTCSessionDescription||window.mozRTCSessionDescription;var i=[{url:"stun:stun.l.google.com:19302"},{url:"stun:stun1.l.google.com:19302"},{url:"stun:stun2.l.google.com:19302"},{url:"stun:stun3.l.google.com:19302"},{url:"stun:stun4.l.google.com:19302"}],o=0;pliny.class({parent:"Primrose",name:"WebRTCSocket",description:"Manages the negotiation between peer users to set up bidirectional audio between the two.",parameters:[{name:"extraIceServers",type:"Array",description:"A collection of ICE servers to use on top of the default Google STUN servers."},{name:"proxyServer",type:"WebSocket",description:"A connection over which to negotiate the peering."},{name:"fromUserName",type:"String",description:"The name of the local user, from which the peering is being initiated."},{name:"fromUserIndex",type:"Number",description:"For users with multiple devices logged in at one time, this is the index of the device that is performing the peering operation."},{name:"toUserName",type:"String",description:"The name of the remote user, to which the peering is being requested."},{name:"toUserIndex",type:"Number",description:"For users with multiple devices logged in at one time, this is the index of the device that is receiving the peering operation."}]});var s=function(){function s(n,r,a,c,u,l,h){var d=this;e(this,s);var p=5,m=++o,f=function(e,n,r){if(n<p){for(var i=new Date,s=["[%s:%s %s] "+r,o,m,t(i)],a=3;a<arguments.length;++a)s.push(arguments[a]);console[e].apply(console,s)}return arguments[3]};this._timeout=null,this._onError=null,this._log=f.bind(null,"log"),this._error=f.bind(null,"error",0),pliny.property({parent:"Primrose.WebRTCSocket",name:"proxyServer",type:"WebSocket",description:"The connection over which to negotiate the peering."}),Object.defineProperty(this,"proxyServer",{get:function(){return r}}),pliny.property({parent:"Primrose.WebRTCSocket",name:"fromUserName",type:"String",description:"The name of the local user."}),Object.defineProperty(this,"fromUserName",{get:function(){return a}}),pliny.property({parent:"Primrose.WebRTCSocket",name:"fromUserIndex",type:"Number",description:"The index of the local user's current device."}),Object.defineProperty(this,"fromUserIndex",{get:function(){return c}}),pliny.property({parent:"Primrose.WebRTCSocket",name:"toUserName",type:"String",description:"The name of the remote user."}),Object.defineProperty(this,"toUserName",{get:function(){return u}}),pliny.property({parent:"Primrose.WebRTCSocket",name:"toUserIndex",type:"Number",description:"The index of the remote user's current device."}),Object.defineProperty(this,"toUserIndex",{get:function(){return l}});var y=i.concat(n);isFirefox&&(y=[{urls:y.map(function(e){return e.url})}]),this._log(1,y),pliny.property({parent:"Primrose.WebRTCSocket",name:"rtc",type:"RTCPeerConnection",description:"The raw RTCPeerConnection that got negotiated."}),this.rtc=new RTCPeerConnection({iceServers:y}),pliny.property({parent:"Primrose.WebRTCSocket",name:"progress",type:"WebSocket",description:"The connection over which to negotiate the peering."});var g={offer:{created:!1,received:!1},answer:{created:!1,recieved:!1}};Object.defineProperty(this,"progress",{get:function(){return g}}),pliny.property({parent:"Primrose.WebRTCSocket",name:"goFirst",type:"Boolean",description:"We don't want the ICE candidates, offers, and answers clashing in the middle, so we need to be careful about order of operations. Users already in the room will initiate peer connections with users that are just joining."}),Object.defineProperty(this,"goFirst",{get:function(){return!h}}),window.addEventListener("unload",this.close.bind(this)),this.ready=new Promise(function(e,t){var n=function(e){console.log(d.rtc),d._log(2,"Tearing down event handlers"),d.clearTimeout(),d.proxyServer.off("cancel",d._onError),d.proxyServer.off("peer",c),d.proxyServer.off("offer",s),d.proxyServer.off("ice",a),d.proxyServer.off("answer",i),d.rtc.onsignalingstatechange=null,d.rtc.oniceconnectionstatechange=null,d.rtc.onnegotiationneeded=null,d.rtc.onicecandidate=null,d.teardown(),e&&d.close()},r=function(t){return d.complete&&(d._log(1,"Timeout avoided."),n(),e()),t},i=function(e){if(d._log(1,"description",e),d.isExpected(e.item.type,e))return d.recordProgress(e.item,"received"),d.rtc.setRemoteDescription(new RTCSessionDescription(e.item)).then(r).catch(d._onError)},o=function(e){return d.recordProgress(e,"created"),d.rtc.setLocalDescription(e).then(function(){return d.proxyServer.emit(e.type,d.wrap(e))}).then(r).catch(d._onError)};d._onError=function(e){d._error(e),d.proxyServer.emit("cancel",e),d._log(1,"Timeout avoided, but only because of an error."),n(!0),t(e)};var s=function(e){d._log(1,"offer",e);var t=i(e);if(t)return t.then(function(){return d.rtc.createAnswer()}).then(o)},a=function(e){if(d._log(1,"ice",e),d.isExpected("ice",e)){var t=new RTCIceCandidate(e.item);return d.rtc.addIceCandidate(t).catch(d._error)}},c=function(e){d.isExpected("new user",e)&&(d.proxyServer.on("cancel",d._onError),d.proxyServer.on("answer",i),d.proxyServer.on("offer",s),d.proxyServer.on("ice",a),d.rtc.onsignalingstatechange=function(e){return d._log(1,"[%s] Signal State: %s",m,d.rtc.signalingState)},d.rtc.oniceconnectionstatechange=function(e){return d._log(1,"[%s] ICE Connection %s, Gathering %s",m,d.rtc.iceConnectionState,d.rtc.iceGatheringState)},d.rtc.onnegotiationneeded=function(e){return d.createOffer(d.offerOptions).then(o)},d.rtc.onicecandidate=function(e){e.candidate&&d.proxyServer.emit("ice",d.wrap(e.candidate))},d.issueRequest())};d.proxyServer.on("peer",c),setTimeout(function(){return d.proxyServer.emit("peer",d.wrap())},250)})}return n(s,[{key:"startTimeout",value:function(){null===this._timeout&&(this._log(1,"Timing out in 10 seconds."),this._timeout=setTimeout(this.cancel.bind(this),r))}},{key:"clearTimeout",value:function(e){function t(){return e.apply(this,arguments)}return t.toString=function(){return e.toString()},t}(function(){null!==this._timeout&&(clearTimeout(this._timeout),this._timeout=null)})},{key:"cancel",value:function(){this._log(1,"Timed out!"),this._onError("Gave up waiting on the peering connection.")}},{key:"createOffer",value:function(){return this.rtc.createOffer()}},{key:"recordProgress",value:function(e,t){pliny.method({parent:"Primrose.WebRTCSocket",name:"recordProgress",description:"mark that we made progress towards our goals.",parameters:[{name:"description",type:"RTCSessionDescription",description:"An answer or offer object."},{name:"method",type:"String",description:"Whether or not the description had been 'created' or 'received' here."}]}),this.progress[e.type][t]=!0}},{key:"wrap",value:function(e){return pliny.method({parent:"Primrose.WebRTCSocket",name:"wrap",returns:"Object",description:"Provides the context into a message so that the remote user can tell if the message `this.isExpected()`",parameters:[{name:"item",type:"Object",description:"The object to wrap."}]}),{fromUserName:this.fromUserName,fromUserIndex:this.fromUserIndex,toUserName:this.toUserName,toUserIndex:this.toUserIndex,item:e}}},{key:"isExpected",value:function e(t,n){pliny.method({parent:"Primrose.WebRTCSocket",name:"isExpected",returns:"Boolean",description:"A test to see if we were expecting a particular message. Sometimes the messages get criss-crossed on the negotiation server, and this just makes sure we don't cause an error.",parameters:[{name:"tag",type:"String",description:"A name for the operation being tested."},{name:"obj",type:"Object",description:"The object within the operating being tested."}]});var r=!this.complete,i=n.fromUserName===this.toUserName,o=n.fromUserIndex===this.toUserIndex,s=n.toUserName===this.fromUserName,a=n.toUserIndex===this.fromUserIndex,e=r&&i&&o&&s&&a;return this._log(1,"[%s->%s] I %s || FROM %s==%s (%s), %s==%s (%s) || TO %s==%s (%s), %s==%s (%s)",t,e,r,n.fromUserName,this.toUserName,i,n.fromUserIndex,this.toUserIndex,o,n.toUserName,this.fromUserName,s,n.toUserIndex,this.fromUserIndex,a),this._log(2,n),e}},{key:"close",value:function(){pliny.method({parent:"Primrose.WebRTCSocket",name:"close",description:"shut down the peer connection, if it was succesful in being created."}),this.rtc&&"closed"!==this.rtc.signalingState&&(this.rtc.close(),this.rtc=null)}},{key:"teardown",value:function(){throw pliny.method({parent:"Primrose.WebRTCSocket",name:"teardown",description:"Whether ending succesfully or failing, the processing is mostly the same: teardown all the event handlers."}),new Error("Not implemented.")}},{key:"issueRequest",value:function(){throw pliny.property({parent:"Primrose.WebRTCSocket",name:"issueRequest",description:"Override this method in subClasses to trigger the peering process."}),new Error("Not implemented")}},{key:"complete",get:function(){return pliny.property({parent:"Primrose.WebRTCSocket",name:"complete",returns:"Boolean",description:"Override this method in subClasses to indicate when the peering process is complete. The peering process is complete when all offers are answered."}),!this.rtc||"closed"===this.rtc.signalingState}}]),s}();"undefined"!=typeof window&&(window.Primrose.WebRTCSocket=s)}(),function(){"use strict";function e(t){var n,r=this,i=t.toString(),o=i.match(/function\s+(\w+)\s*\(/),s=o[1];for(n in t.prototype)i+="\n\n"+s+".prototype."+n+" = "+t.prototype[n].toString()+";";i+="\n\n(function(){\n  var instance = new "+s+"(true);",i+="\n  if(instance.addEventListener){\n    self.args = [null, null];\n    for(var k in instance.listeners) {\n      instance.addEventListener(k, function(eventName, args){\n        self.args[0] = eventName;\n        self.args[1] = args;\n        postMessage(self.args);\n      }.bind(this, k));\n    }\n  }",i+="\n\n  onmessage = function(evt){\n    var f = evt.data[0],\n        t = instance[f];\n    if(t){\n      t.call(instance, evt.data[1]);\n    }\n  };\n\n})();",pliny.property({name:"worker",type:"WebWorker",description:"The worker thread containing our class."}),this.worker=e.createWorker(i,!1),pliny.property({name:"args",type:"Array",description:"Static allocation of an array to save on memory usage when piping commands to a worker."}),this.args=[null,null],pliny.property({name:"listeners",type:"Object",
description:"A bag of arrays of callbacks for each of the class' events."}),this.listeners={},this.worker.onmessage=function(e){return emit.call(r,e.data[0],e.data[1])},pliny.property({name:"&lt;mappings for each method in the original class&gt;",type:"Function",description:"Each mapped function causes a message to be posted to the worker thread with its arguments packed into an array."});for(n in t.prototype)"addEventListener"!==n&&"_"!==n[0]&&(this[n]=this.methodShim.bind(this,n));this.ready=!0}pliny.class({parent:"Primrose",name:"Workerize",description:"Builds a WebWorker thread out of a JavaScript class's source code, and attempts to create a message interface that matches the message-passing interface that the class already uses.\n\nAutomatically workerized classes should have methods that take a single array for any parameters and return no values. All return results should come through an Event that the class emits.",parameters:[{name:"func",type:"Function",description:"The class function to workerize"}],examples:[{name:"Create a basic workerized class.",description:'Classes in JavaScript are created by adding new functions to the `prototype` of another function, then instantiating objects from that class with `new`. When creating such a class for automatic workerization, a few restrictions are required:\n* All methods in the class must be on the prototype. Any methods created and assigned in the constructor will not be available to the message passing interface.\n* All interaction with objects of the class must be through these publicly accessible methods. This includes initialization.\n* All methods should take at most a single argument. If you need multiple arguments, pack them into an array.\n* The methods cannot return any values. If a value must be returned to the calling context, it must be done through an event callback.\n* The class must assign handlers to events through an addEventListener method that mirrors the standard interface used in DOM. Workerize will not respect the 3rd `bubbles` parameter that is so often omitted when programming against DOM.\n\nAssuming the following class:\n\n  grammar("JavaScript");\n  function MyClass(){\n    this.listeners = {\n      complete: []\n    };\n    this.objects = [];\n  }\n\n  MyClass.prototype.addEventListener = function(evt, handler){\n    if(this.listeners[evt]){\n      this.listeners[evt].push(handler);\n    }\n  };\n\n  MyClass.prototype.addObject = function(obj){\n    this.objects.push(obj);\n  };\n\n  MyClass.prototype.update = function(dt){\n    // we can make essentially arbitrarily small timeslice updates\n    var SLICE = 0.1;\n    for(var ddt = 0; ddt < dt; ddt += SLICE){\n      for(var i = 0; i < this.objects.length; ++i){\n        var o = this.objects[i];\n        o.x += o.vx * SLICE;\n        o.y += o.vy * SLICE;\n        o.z += o.vz * SLICE;\n      }\n    }\n    // prepare our return state for the UI thread.\n    var returnValue = [];\n    for(var i = 0; i < this.objects.length; ++i){\n      returnValue.push([o.x, o.y, o.z]);\n    }\n    // and emit the event to all of the listeners.\n    for(var i = 0; i < this.listeners.complete.length; ++i){\n      this.listeners.complete[i](returnValue);\n    }\n  };\n\nThen we can create and use an automatically workerized version of it as follows.\n\n  grammar("JavaScript");\n  var phys = new Primrose.Workerize(MyClass);\n  // we keep a local copy of the state so we can perform other operations on it.\n  var objects = [];\n  for(var i = 0; i < 10; ++i){\n    var obj = {\n      // random values between -1 and 1\n      x: 2 * Math.random() - 1,\n      y: 2 * Math.random() - 1,\n      z: 2 * Math.random() - 1,\n      vx: 2 * Math.random() - 1,\n      vy: 2 * Math.random() - 1,\n      vz: 2 * Math.random() - 1\n    };\n    objects.push(obj);\n    phys.addObject(obj);\n  }\n  \n  // this flag lets us keep track of whether or not we know that the worker is in the middle of an expensive operation.\n  phys.ready = true;\n  phys.addEventListener("complete", function(newPositions){\n    // We update the state in the UI thread with the expensively-computed values.\n    for(var i = 0; i < newPositions.length; ++i){\n      objects[i].x = newPositions[i][0];\n      objects[i].y = newPositions[i][1];\n      objects[i].z = newPositions[i][2];\n    }\n    phys.ready = true;\n  });\n  \n  var lt = null;\n  function paint(t){\n    requestAnimationFrame(paint);\n    if(lt === undefined || lt === null){\n      lt = t;\n    } else {\n      var dt = t - lt;\n      if(phys.ready){\n        phys.ready = false;\n        phys.update(dt);\n        lt = t;\n      }\n      for(var i = 0; i < objects.length; ++i){\n        var o = objects[i];\n        // We can even perform a much cheaper position update to smooth over the blips in the expensive update on the worker thread.\n        drawObjectAt(o.x + o.vx * dt, o.y + o.vy * dt, o.z + o.vz * dt);\n      }\n    }\n  }\n  requestAnimationFrame(paint);'}]}),pliny.method({parent:"Primrose.Workerize",name:"methodShim",description:"Posts messages to the worker thread by packing arguments into an array. The worker will receive the array and interpret the first value as the name of the method to invoke and the second value as another array of parameters.",parameters:[{name:"methodName",type:"String",description:"The method inside the worker context that we want to invoke."},{name:"args",type:"Array",description:"The arguments that we want to pass to the method that we are calling in the worker context."}]}),e.prototype.methodShim=function(e,t){this.args[0]=e,this.args[1]=t,this.worker.postMessage(this.args)},pliny.method({parent:"Primrose.Workerize",name:"addEventListener",description:"Adding an event listener just registers a function as being ready to receive events, it doesn't do anything with the worker thread yet.",parameters:[{name:"evt",type:"String",description:"The name of the event for which we are listening."},{name:"thunk",type:"Function",description:"The callback to fire when the event occurs."}]}),e.prototype.addEventListener=function(e,t){this.listeners[e]||(this.listeners[e]=[]),this.listeners[e].push(t)},pliny.function({parent:"Primrose.Workerize",name:"createWorker",description:"A static function that loads Plain Ol' JavaScript Functions into a WebWorker.",parameters:[{name:"script",type:"(String|Function)",description:"A String defining a script, or a Function that can be toString()'d to get it's script."},{name:"stripFunc",type:"Boolean",description:"Set to true if you want the function to strip the surround function block scope from the script."}],returns:"The WebWorker object."}),e.createWorker=function(e,t){if("function"==typeof e&&(e=e.toString()),t){e=e.trim();var n=e.indexOf("{");e=e.substring(n+1,e.length-1)}var r=new Blob([e],{type:"text/javascript"}),i=URL.createObjectURL(r);return new Worker(i)},"undefined"!=typeof window&&(window.Primrose.Workerize=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose",name:"X",description:"Extensions and components that combine other Primrose elements."});var e={};"undefined"!=typeof window&&(window.Primrose.X=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0;pliny.class({parent:"Primrose.Controls",name:"AbstractLabel",description:"A simple label of text to put on a Surface.",baseClass:"Primrose.Surface",parameters:[{name:"idOrCanvasOrContext",type:"String or HTMLCanvasElement or CanvasRenderingContext2D",description:"Either an ID of an element that exists, an element, or the ID to set on an element that is to be created."},{name:"options",type:"Object",description:"Named parameters for creating the Button."}]});var o=function(o){function s(n){e(this,s);var r=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,patch(n,{id:"Primrose.Controls.AbstractLabel["+i++ +"]"})));return r._lastFont=null,r._lastText=null,r._lastCharacterWidth=null,r._lastCharacterHeight=null,r._lastPadding=null,r._lastWidth=-1,r._lastHeight=-1,r._lastTextAlign=null,r.textAlign=r.options.textAlign,r.character=new Primrose.Text.Size,r.theme=r.options.theme,r.fontSize=r.options.fontSize||16,r.refreshCharacter(),r.backgroundColor=r.options.backgroundColor||r.theme.regular.backColor,r.color=r.options.color||r.theme.regular.foreColor,r.value=r.options.value,r}return n(s,o),r(s,[{key:"refreshCharacter",value:function(){this.character.height=this.fontSize,this.context.font=this.character.height+"px "+this.theme.fontFamily,this.character.width=this.context.measureText("MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM").width/100}},{key:"_isChanged",value:function(){var e=this._lastText!==this.value,t=this.character.width!==this._lastCharacterWidth,n=this.character.height!==this._lastCharacterHeight,r=this.context.font!==this._lastFont,i=this.textAlign!==this._lastTextAlign,o=this.resized||e||t||n||this.resized||r||i;return o}},{key:"render",value:function(){if(this.resized&&this.resize(),this.theme&&this._isChanged){this._lastText=this.value,this._lastCharacterWidth=this.character.width,this._lastCharacterHeight=this.character.height,this._lastWidth=this.imageWidth,this._lastHeight=this.imageHeight,this._lastFont=this.context.font,this._lastTextAlign=this.textAlign,this.context.textAlign=this.textAlign||"left";var e=this.backgroundColor?"fillRect":"clearRect";if(this.theme.regular.backColor&&(this.context.fillStyle=this.backgroundColor),this.context[e](0,0,this.imageWidth,this.imageHeight),this.value)for(var t=this.value.split("\n"),n=0;n<t.length;++n){var r=t[n],i=(this.imageHeight-t.length*this.character.height)/2+n*this.character.height,o=null;switch(this.textAlign){case"right":o=this.imageWidth;break;case"center":o=this.imageWidth/2;break;default:o=0}var s=(this.theme.regular.fontWeight||"")+" "+(this.theme.regular.fontStyle||"")+" "+this.character.height+"px "+this.theme.fontFamily;this.context.font=s.trim(),this.context.fillStyle=this.color,this.context.fillText(r,o,i)}this.renderCanvasTrim(),this.invalidate()}}},{key:"renderCanvasTrim",value:function(){}},{key:"textAlign",get:function(){return this.context.textAlign},set:function(e){this.context.textAlign=e,this.render()}},{key:"value",get:function(){return this._value},set:function(e){e=e||"",this._value=e.replace(/\r\n/g,"\n"),this.render()}},{key:"theme",get:function(){return this._theme},set:function(e){this._theme=clone(e||Primrose.Text.Themes.Default),this._theme.fontSize=this.fontSize,this.refreshCharacter(),this.render()}}]),s}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Controls.AbstractLabel=o)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=0;pliny.class({parent:"Primrose.Controls",name:"Button2D",description:"A simple button to put on a Surface.",baseClass:"Primrose.Controls.AbstractLabel",parameters:[{name:"idOrCanvasOrContext",type:"String or HTMLCanvasElement or CanvasRenderingContext2D",description:"Either an ID of an element that exists, an element, or the ID to set on an element that is to be created."},{name:"options",type:"Object",description:"Named parameters for creating the Button."}]});var s=function(s){function a(n){e(this,a);var r=t(this,(a.__proto__||Object.getPrototypeOf(a)).call(this,patch(n,{id:"Primrose.Controls.Button2D["+o++ +"]",textAlign:"center"})));return r._lastActivated=null,r}return n(a,s),i(a,null,[{key:"create",value:function(){return new a}}]),i(a,[{key:"addToBrowserEnvironment",value:function(e,t){var n=e.buttonFactory.create();return n.listeners=this.listeners,e.appendChild(n)}},{key:"startPointer",value:function(e,t){this.focus(),this._activated=!0,this.render()}},{key:"endPointer",value:function(){this._activated&&(this._activated=!1,emit.call(this,"click",{target:this}),this.render())}},{key:"_isChanged",value:function(){var e=this._activated!==this._lastActivated,t=r(a.prototype.__proto__||Object.getPrototypeOf(a.prototype),"_isChanged",this)||e;return t}},{key:"renderCanvasTrim",value:function(){this.context.lineWidth=this._activated?4:2,this.context.strokeStyle=this.theme.regular.foreColor||Primrose.Text.Themes.Default.regular.foreColor,this.context.strokeRect(0,0,this.imageWidth,this.imageHeight)}}]),a}(Primrose.Controls.AbstractLabel);"undefined"!=typeof window&&(window.Primrose.Controls.Button2D=s)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose",name:"Button3D",baseClass:"Primrose.BaseControl",parameters:[{name:"model",type:"THREE.Object3D",description:"A 3D model to use as the graphics for this button."},{name:"name",type:"String",description:"A name for the button, to make it distinct from other buttons."},{name:"options",type:"Object",description:"A hash of options:\n\t\t\tmaxThrow - The limit for how far the button can be depressed.\n\t\t\tminDeflection - The minimum distance the button must be depressed before it is activated.\n\t\t\tcolorPressed - The color to change the button cap to when the button is activated.\n\t\t\tcolorUnpressed - The color to change the button cap to when the button is deactivated.\n\t\t\ttoggle - True if deactivating the button should require a second click. False if the button should deactivate when it is released."}],description:"A 3D button control, with a separate cap from a stand that it sits on. You click and depress the cap on top of the stand to actuate."});var i=function(i){function o(n,r,i){e(this,o);var s=t(this,(o.__proto__||Object.getPrototypeOf(o)).call(this));return i=patch(i,o),i.minDeflection=Math.cos(i.minDeflection),i.colorUnpressed=new THREE.Color(i.colorUnpressed),i.colorPressed=new THREE.Color(i.colorPressed),pliny.event({name:"click",description:"Occurs when the button is activated."}),s.listeners.click=[],pliny.event({name:"release",description:"Occurs when the button is deactivated."}),s.listeners.release=[],pliny.property({name:"base",type:"THREE.Object3D",description:"The stand the button cap sits on."}),s.base=n.children[1],pliny.property({name:"base",type:"THREE.Object3D",description:"The moveable part of the button, that triggers the click event."}),s.cap=n.children[0],s.cap.name=r,s.cap.material=s.cap.material.clone(),s.cap.button=s,s.cap.base=s.base,pliny.property({name:"container",type:"THREE.Object3D",description:"A grouping collection for the base and cap."}),s.container=new THREE.Object3D,s.container.add(s.base),s.container.add(s.cap),pliny.property({name:"color",type:"Number",description:"The current color of the button cap."}),s.color=s.cap.material.color,s.name=r,s.element=null,s.startUV=function(){this.color.copy(i.colorPressed),this.element?this.element.click():emit.call(this,"click")},s.moveUV=function(){},s.endPointer=function(){this.color.copy(i.colorUnpressed),emit.call(this,"release")},s}return n(o,i),r(o,[{key:"addToBrowserEnvironment",value:function(e,t){return t.add(this.container),e.registerPickableObject(this.cap),this.container}},{key:"position",get:function(){return this.container.position}}]),o}(Primrose.BaseControl);pliny.record({parent:"Primrose.Controls.Button3D",name:"DEFAULTS",description:"Default option values that override undefined options passed to the Button3D class."}),pliny.property({parent:"Primrose.Controls.Button3D",name:"position",type:"THREE.Vector3",description:"The location of the button."}),pliny.value({parent:"Primrose.Controls.Button3D.DEFAULTS",name:"maxThrow",type:"Number",description:"The limit for how far the button can be depressed."}),pliny.value({parent:"Primrose.Controls.Button3D.DEFAULTS",name:"minDeflection",type:"Number",description:"The minimum distance the button must be depressed before it is activated."}),pliny.value({parent:"Primrose.Controls.Button3D.DEFAULTS",name:"colorUnpressed",type:"Number",description:"The color to change the button cap to when the button is deactivated."}),pliny.value({parent:"Primrose.Controls.Button3D.DEFAULTS",name:"colorPressed",type:"Number",description:"The color to change the button cap to when the button is activated."}),pliny.value({parent:"Primrose.Controls.Button3D.DEFAULTS",name:"toggle",type:"Boolean",description:"True if deactivating the button should require a second click. False if the button should deactivate when it is released."}),i.DEFAULTS={maxThrow:.1,minDeflection:10,colorUnpressed:8323072,colorPressed:32512,toggle:!0},"undefined"!=typeof window&&(window.Primrose.Controls.Button3D=i)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0;pliny.class({parent:"Primrose.Controls",name:"Form",baseClass:"Primrose.Entity",description:"A basic 2D form control, with its own mesh to use as a frame."});var o=function(o){function s(n){e(this,s);var r=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,patch(n,{id:"Primrose.Controls.Form["+i++ +"]"})));return r._mesh=textured(quad(1,r.bounds.height/r.bounds.width),r),r._mesh.name=r.id+"-mesh",Object.defineProperties(r.style,{display:{get:function(){return r._mesh.visible?"":"none"},set:function(e){"none"===e?r.hide():r.show()}},visible:{get:function(){return r._mesh.visible?"":"hidden"},set:function(e){return r.visible="hidden"!==e}}}),r}return n(s,o),r(s,null,[{key:"create",value:function(){return new s}}]),r(s,[{key:"addToBrowserEnvironment",value:function(e,t){return t.add(this._mesh),e.registerPickableObject(this._mesh),this._mesh}},{key:"hide",value:function(){this.visible=!1,this.disabled=!0}},{key:"show",value:function(){this.visible=!0,this.disabled=!1}},{key:"position",get:function(){return this._mesh.position}},{key:"visible",get:function(){return this._mesh.visible},set:function(e){this._mesh.visible=e}},{key:"disabled",get:function(){return this._mesh.disabled},set:function(e){this._mesh.disabled=e}},{key:"enabled",get:function(){return!this.disabled},set:function(e){this.disabled=!e}}]),s}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Controls.Form=o)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0;pliny.class({parent:"Primrose.Controls",name:"HtmlDoc",baseClass:"Primrose.Surface",description:"A rendering of an HTML document.",parameters:[{name:"options",type:"Object",description:"Named parameters for creating the Document."}]});var o=function(o){function s(n){e(this,s);var r=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,patch(n,{id:"Primrose.Controls.HtmlDoc["+i++ +"]"})));return"string"==typeof n?r.options={element:r.options}:r.options=n||{},r._lastImage=null,r._image=null,r.element=r.options.element,r}return n(s,o),r(s,null,[{key:"create",value:function(){return new s}}]),r(s,[{key:"addToBrowserEnvironment",value:function(e,t){var n=textured(quad(2,2),this);return t.add(n),e.registerPickableObject(n),n}},{key:"_render",value:function(){var e=this;html2canvas(this._element,{onrendered:function(t){e._image=t,e.setSize(t.width,t.height),e.render()}})}},{key:"render",value:function(){this._image!==this._lastImage&&(this._lastImage=this._image,this.context.fillStyle="white",this.context.fillRect(0,0,this.imageWidth,this.imageHeight),this.context.drawImage(this._image,0,0),this.invalidate())}},{key:"element",get:function(){return this._element},set:function(e){e&&(this._element=Primrose.DOM.cascadeElement(e,"DIV",HTMLDivElement),this._element.style.position="absolute",this._element.style.display="",this._element.style.width=this.bounds.width+"px",this._element.style.height=this.bounds.height+"px",document.body.appendChild(Primrose.DOM.makeHidingContainer(this.id+"-hider",this._element)),this._render())}},{key:"value",get:function(){return this._element.innerHTML},set:function(e){e!==this._element.innerHTML&&(this._element.innerHTML=e,this._render())}}]),s}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Controls.HtmlDoc=o)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0,o=window.Image,s={};pliny.class({parent:"Primrose.Controls",name:"Image",baseClass:"Primrose.Surface",description:"A simple 2D image to put on a Surface.",parameters:[{name:"options",type:"Object",description:"Named parameters for creating the Image."}]});var a=function(a){function c(n){e(this,c),n=n||{},"string"==typeof n&&(n={value:n});var r=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,patch(n,{id:"Primrose.Controls.Image["+i++ +"]",bounds:new Primrose.Text.Rectangle(0,0,1,1)})));return r.listeners.load=[],r._lastWidth=-1,r._lastHeight=-1,r._lastImage=null,r._images=[],r._currentImageIndex=0,r.className="",setTimeout(function(){n.value&&(/\.stereo\./.test(n.value)?r.loadStereoImage(n.value):r.loadImage(n.value))}),r}return n(c,a),r(c,null,[{key:"create",value:function(){return new c}}]),r(c,[{key:"addToBrowserEnvironment",value:function(e,t){var n=textured(quad(.5,.5*this.imageHeight/this.imageWidth),this);return t.add(n),e.registerPickableObject(n),n}},{key:"loadImage",value:function(e,t){var n=this;return"number"==typeof e||e instanceof Number||(t=e,e=0),new Promise(function(e,n){if(s[t])e(s[t]);else if(t){var r=new o;r.addEventListener("load",function(){s[t]=r,e(s[t])},!1),r.addEventListener("error",function(){n("error loading image")},!1),r.src=t}else n("Image was null")}).then(function(t){return n.setImage(e,t),t}).catch(function(r){console.error("Failed to load image "+t),console.error(r),n.setImage(e,null)})}},{key:"loadStereoImage",value:function(e){var t=this;return this.loadImage(e).then(function(e){var n=new Primrose.Text.Rectangle(0,0,e.width/2,e.height),r=new Primrose.Surface({id:t.id+"-left",bounds:n}),i=new Primrose.Surface({id:t.id+"-right",bounds:n});return r.context.drawImage(e,0,0),i.context.drawImage(e,-n.width,0),t.setImage(0,r.canvas),t.setImage(1,i.canvas),t.bounds.width=n.width,t.bounds.height=n.height,t.render(),emit.call(t,"load",{target:t}),t})}},{key:"getImage",value:function(e){return this._images[e%this._images.length]}},{key:"setImage",value:function(e,t){this._images[e]=t,this.render()}},{key:"eyeBlank",value:function(e){this._currentImageIndex=e,this.render()}},{key:"render",value:function(e){(this._changed||e)&&(this.resized?this.resize():this.image!==this._lastImage&&this.context.clearRect(0,0,this.imageWidth,this.imageHeight),this.image&&this.context.drawImage(this.image,0,0),this._lastWidth=this.imageWidth,this._lastHeight=this.imageHeight,this._lastImage=this.image,this.invalidate())}},{key:"src",get:function(){return this.getImage(this._currentImageIndex).src},set:function(e){"stereo"===this.className?this.loadStereoImage(e):this.loadImage(0,src)}},{key:"image",get:function(){return this.getImage(this._currentImageIndex)},set:function(e){this.setImage(this._currentImageIndex,e)}},{key:"_changed",get:function(){return this.resized||this.image!==this._lastImage}}]),c}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Controls.Image=a)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0;pliny.class({parent:"Primrose.Controls",name:"VUMeter",baseClass:"Primrose.Surface",description:"A visualization of audio data.",parameters:[{name:"analyzer",type:"MediaStream",description:"The audio stream to analyze."},{name:"options",type:"Object",description:"Named parameters for creating the Button."}]});var o=function(o){function s(n,r){e(this,s),r=r||{},"string"==typeof r&&(r={value:r});var o=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,patch(r,{id:"Primrose.Controls.VUMeter["+i++ +"]",bounds:new Primrose.Text.Rectangle(0,0,512,256),backgroundColor:0,foregroundColor:16777215})));return o.analyzer=n,o.analyzer.fftSize=o.bounds.width,o.buffer=new Uint8Array(o.analyzer.frequencyBinCount),o}return n(s,o),r(s,[{key:"addToBrowserEnvironment",value:function(e,t){var n=textured(quad(.5,.5*this.imageHeight/this.imageWidth),this);return t.add(n),e.registerPickableObject(n),n}},{key:"render",value:function(){this.resized&&this.resize(),this.analyzer.getByteTimeDomainData(this.buffer),this.context.fillStyle=this.options.backgroundColor,this.context.fillRect(0,0,this.bounds.width,this.bounds.height),this.context.lineWidth=2,this.context.strokeStyle=this.options.foregroundColor,this.context.beginPath();for(var e=0;e<this.buffer.length;++e){var t=e*this.bounds.width/this.buffer.length,n=this.buffer[e]*this.bounds.height/256,r=e>0?"lineTo":"moveTo";this.context[r](t,n)}this.context.stroke(),this.invalidate()}}]),s}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Controls.VUMeter=o)}(),function(){"use strict";function e(e,t,n,r){var i=null;if(null===e?(i=document.createElement(t),i.id=e="auto_"+t+Date.now()):void 0===n||e instanceof n?i=e:"string"==typeof e&&(i=document.getElementById(e),null===i?(i=document.createElement(t),i.id=e,r&&document.body.appendChild(i)):i.tagName!==t.toUpperCase()&&(i=null)),null===i)throw pliny.error({name:"Invalid element",type:"Error",description:"If the element could not be found, could not be created, or one of the appropriate ID was found but did not match the expected type, an error is thrown to halt operation."}),new Error(e+" does not refer to a valid "+t+" element.");return i}pliny.function({parent:"Primrose.DOM",name:"cascadeElement",returns:"Element",parameters:[{name:"id",type:"(String|Element)",description:"A vague reference to the element. Either a String id where the element can be had, a String id to give a newly created element if it does not exist, or an Element to manipulate and validate"},{name:"tag",type:"String",description:"The HTML tag name of the element we are finding/creating/validating."},{name:"DOMClass",type:"Class",description:"The class Function that is the type of element that we are frobnicating."}],description:"* If `id` is a string, tries to find the DOM element that has said ID\n  * If it exists, and it matches the expected tag type, returns the element, or throws an error if validation fails.\n  * If it doesn't exist, creates it and sets its ID to the provided id, then returns the new DOM element, not yet placed in the document anywhere.\n* If `id` is a DOM element, validates that it is of the expected type,\n  * returning the DOM element back if it's good,\n  * or throwing an error if it is not\n* If `id` is null, creates the DOM element to match the expected type.",examples:[{name:"Get an element by ID that already exists.",description:'Assuming the following HTML snippet:\n\n  grammar("HTML");\n  <div>\n    <div id="First">first element</div>\n    <section id="second-elem">\n      Second element\n      <img id="img1" src="img.png">\n    </section>\n  </div>\n\n## Code:\n\n  grammar("JavaScript");\n  var elem = Primrose.DOM.cascadeElement("second-elem", "section", HTMLElement);\n  console.assert(elem.textContent === "Second element");'
},{name:"Validate the tag type.",description:'Assuming the following HTML snippet:\n\n  grammar("HTML");\n  <div>\n    <div id="First">first element</div>\n    <section id="second-elem">\n      Second element\n      <img id="img1" src="img.png">\n    </section>\n  </div>\n\n## Code:\n\n  grammar("JavaScript");\n  //The following line of code should cause a runtime error.\n  Primrose.DOM.cascadeElement("img1", "section", HTMLElement);'},{name:"Create an element.",description:'Assuming the following HTML snippet:\n\n  grammar("HTML");\n  <div>\n    <div id="First">first element</div>\n    <section id="second-elem">\n      Second element\n      <img id="img1" src="img.png">\n    </section>\n  </div>\n\n## Code:\n\n  grammar("JavaScript");\n  var elem = Primrose.DOM.cascadeElement("img2", "img", HTMLImageElement);\n  console.assert(elem.id === "img2");\n  console.assert(elem.parentElement === null);\n  document.body.appendChild(elem);\n  console.assert(elem.parentElement === document.body);'}]}),"undefined"!=typeof window&&(window.Primrose.DOM.cascadeElement=e)}(),function(){"use strict";function e(e,t){e=e||document,t=t||{};for(var n=e.querySelectorAll("*"),r=0;r<n.length;++r){var i=n[r];i.id&&i.id.length>0&&(t[i.id]=i,i.parentElement&&(i.parentElement[i.id]=i))}return t}pliny.function({parent:"Primrose.DOM",name:"findEverything",description:"Searches an element for all sub elements that have a named ID,\nusing that ID as the name of a field in a hashmap to store a reference to the element.\nBasically, a quick way to get at all the named elements in a page. Returns an object full\nof element references, with fields named by the ID of the elements that were found.\n\n> NOTE: You may name your IDs pretty much anything you want, but for ease of use,\n> you should name them in a camalCase fashion. See [CamelCase - Wikipedia, the free encyclopedia](https://en.wikipedia.org/wiki/CamelCase).",parameters:[{name:"elem",type:"Element",optional:!0,description:"the root element from which to search.",default:"`document`."},{name:"obj",type:"Object",optional:!0,description:"the object in which to store the element references. If no object is provided, one will be created."}],returns:"Object",examples:[{name:"Get all child elements.",description:'Assuming the following HTML snippet:\n\n  grammar("HTML");\n  <div>\n    <div id="First">first element</div>\n    <section id="second-elem">\n      Second element\n      <img id="img1" src="img.png">\n    </section>\n  </div>\n\n## Code:\n\n  grammar("JavaScript");\n  var elems = Primrose.DOM.findEverything();\n  console.log(elems.First.innerHTML);\n  console.log(elems["second-elem"].textContent);\n  console.log(elems.img1.src);\n\n## Results:\n> first element  \n> Second element  \n> img.png'}]}),"undefined"!=typeof window&&(window.Primrose.DOM.findEverything=e)}(),function(){"use strict";function e(e,t){var n=Primrose.DOM.cascadeElement(e,"div",window.HTMLDivElement);return n.style.position="absolute",n.style.left=0,n.style.top=0,n.style.width=0,n.style.height=0,n.style.overflow="hidden",n.appendChild(t),n}pliny.function({parent:"Primrose.DOM",name:"makeHidingContainer",description:"Takes an element and shoves it into a containing element that\nis 0x0 pixels in size, with the overflow hidden. Sometimes, we need an element\nlike a TextArea in the DOM to be able to receive key events, but we don't want the\nuser to see it, so the makeHidingContainer function makes it easy to make it disappear.",parameters:[{name:"id",type:"(String|Element)",description:"A vague reference to\nthe element. Either a String id where the element can be had, a String id to give\na newly created element if it does not exist, or an Element to manipulate and validate."},{name:"obj",type:"Element",description:"The child element to stow in the hiding container."}],returns:"The hiding container element, not yet inserted into the DOM."}),"undefined"!=typeof window&&(window.Primrose.DOM.makeHidingContainer=e)}(),function(){"use strict";function e(e,t,n){return Primrose.HTTP.XHR("DELETE",e,t,n)}pliny.function({parent:"Primrose.HTTP",name:"del",description:"Process an HTTP DELETE request.",returns:"Promise",parameters:[{name:"type",type:"String",description:'How the response should be interpreted. One of ["text", "json", "arraybuffer"]. See the [MDN - XMLHttpRequest - responseType](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#xmlhttprequest-responsetype).',default:'"text"'},{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.data",type:"Object",description:"The data object to use as the request body payload."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.del=e)}(),function(){"use strict";function e(e,t){return Primrose.HTTP.del("json",e,t)}pliny.function({parent:"Primrose.HTTP",name:"delObject",description:"Delete something on the server, and receive JSON in response.",returns:"Promise",parameters:[{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.data",type:"Object",description:"The data object to use as the request body payload, if this is a PUT request."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.delObject=e)}(),function(){"use strict";function e(e,t,n){return Primrose.HTTP.XHR("GET",e||"text",t,n)}pliny.function({parent:"Primrose.HTTP",name:"get",description:"Process an HTTP GET request.",returns:"Promise",parameters:[{name:"type",type:"String",description:'How the response should be interpreted. One of ["text", "json", "arraybuffer"]. See the [MDN - XMLHttpRequest - responseType](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#xmlhttprequest-responsetype).',default:'"text"'},{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Make a GET request.",description:'Typically, you would use one of the other functions in the Primrose.HTTP namespace, but the XHR function is provided as a fallback in case those others do not meet your needs.\n\n## Code:\n\n  grammar("JavaScript");\n  Primrose.HTTP.get("json", "localFile.json",\n    console.log.bind(console, "progress"),\n    console.log.bind(console, "done"),\n    console.error.bind(console));\n\n## Results:\n> Object {field1: 1, field2: "Field2"}'}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.get=e)}(),function(){"use strict";function e(e,t){return Primrose.HTTP.get("arraybuffer",e,t)}pliny.function({parent:"Primrose.HTTP",name:"getBuffer",description:"Get an ArrayBuffer from a server.",returns:"Promise",parameters:[{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Make a GET request for an ArrayBuffer.",description:'Use this to load audio files and do whatever you want with them.\n\n## Code:\n\n  grammar("JavaScript");\n  var context = new AudioContext();\n  Primrose.HTTP.getBuffer("audio.mp3",\n    console.log.bind(console, "progress"));,\n    function(buffer){\n      context.decodeAudioData(\n        buffer,\n        console.log.bind(console, "success"),\n        console.error.bind(console, "error decoding"));\n    },\n    console.error.bind(console, "error loading")\n'}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.getBuffer=e)}(),function(){"use strict";function e(e,t){return Primrose.HTTP.get("json",e,t)}pliny.function({parent:"Primrose.HTTP",name:"getObject",description:"Get a JSON object from a server.",returns:"Promise",parameters:[{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Make a GET request for a JSON object.",description:'Typically, you would use one of the other functions in the Primrose.HTTP namespace, but the XHR function is provided as a fallback in case those others do not meet your needs.\n\n## Code:\n\n  grammar("JavaScript");\n  Primrose.HTTP.getObject("localFile.json", {\n      progress: console.log.bind(console, "progress")\n    })\n    .then(console.log.bind(console, "done"))\n    .catch(console.error.bind(console)));\n\n## Results:\n> Object {field1: 1, field2: "Field2"}'}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.getObject=e)}(),function(){"use strict";function e(e,t){return Primrose.HTTP.get("text",e,t)}pliny.function({parent:"Primrose.HTTP",name:"getText",description:"Get plain text from a server. Returns a promise that will be resolve with the text retrieved from the server.",returns:"Promise",parameters:[{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Make a GET request for plain text.",description:'Use this to load arbitrary files and do whatever you want with them.\n\n## Code:\n\n  grammar("JavaScript");\n  Primrose.HTTP.getText("localFile.json",\n    console.log.bind(console, "progress"),\n    console.log.bind(console, "done"),\n    console.error.bind(console));\n\n## Results:\n> "Object {field1: 1, field2: \\"Field2\\"}"'}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.getText=e)}(),function(){"use strict";function e(e,t,n){return Primrose.HTTP.XHR("POST",e,t,n)}pliny.function({parent:"Primrose.HTTP",name:"post",description:"Process an HTTP POST request.",returns:"Promise",parameters:[{name:"type",type:"String",description:'How the response should be interpreted. One of ["text", "json", "arraybuffer"]. See the [MDN - XMLHttpRequest - responseType](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#xmlhttprequest-responsetype).',default:'"text"'},{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.data",type:"Object",description:"The data object to use as the request body payload, if this is a POST request."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.post=e)}(),function(){"use strict";function e(e,t){return Primrose.HTTP.post("json",e,t)}pliny.function({parent:"Primrose.HTTP",name:"postObject",description:"Send a JSON object to a server.",returns:"Promise",parameters:[{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.data",type:"Object",description:"The data object to use as the request body payload, if this is a PUT request."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.postObject=e)}(),function(){"use strict";function e(e,t,n,r){return new Promise(function(i,o){r=r||{},r.headers=r.headers||{},"POST"===e&&(r.headers["Content-Type"]=r.headers["Content-Type"]||t);var s=new XMLHttpRequest;s.onerror=function(e){return o(new Error("Request error: "+e.message))},s.onabort=function(e){return o(new Error("Request abort: "+e.message))},s.onload=function(){s.status<400?i(s.response):o(s)},s.open(e,n),t&&(s.responseType=t),s.onprogress=r.progress;for(var a in r.headers)s.setRequestHeader(a,r.headers[a]);s.withCredentials=!!r.withCredentials,r.data?s.send(JSON.stringify(r.data)):s.send()})}pliny.function({parent:"Primrose.HTTP",name:"XHR",description:"Wraps up the XMLHttpRequest object into a workflow that is easier for me to handle: a single function call. Can handle both GETs and POSTs, with or  without a payload.",returns:"Promise",parameters:[{name:"method",type:"String",description:"The HTTP Verb being used for the request."},{name:"type",type:"String",description:'How the response should be interpreted. One of ["text", "json", "arraybuffer"]. See the [MDN - XMLHttpRequest - responseType](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#xmlhttprequest-responsetype).',default:'"text"'},{name:"url",type:"String",description:"The resource to which the request is being sent."},{name:"options.data",type:"Object",description:"The data object to use as the request body payload, if this is a PUT request."},{name:"options.progress",type:"Function",optional:!0,description:"A callback function to be called as the download from the server progresses."}],examples:[{name:"Make a GET request.",description:'Typically, you would use one of the other functions in the Primrose.HTTP namespace, but the XHR function is provided as a fallback in case those others do not meet your needs.\n\n## Code:\n\n  grammar("JavaScript");\n  Primrose.HTTP.XHR("GET", "json", "localFile.json", {\n    progress: console.log.bind(console, "progress"))\n    .then(console.log.bind(console, "done")))\n    .catch(console.error.bind(console));\n\n## Results:\n> Object {field1: 1, field2: "Field2"}'}]}),"undefined"!=typeof window&&(window.Primrose.HTTP.XHR=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),n=new THREE.Vector3,r=new THREE.Euler,i=Math.PI/3,o=250;pliny.class({parent:"Primrose.Input",name:"FPSInput",description:"| [under construction]"});var s=function(){function s(t,n){var r=this;e(this,s),t=t||window,this.options=n,this.listeners={zero:[],motioncontroller:[],gamepad:[]},this.managers=[],this.newState=[],this.pointers=[],this.motionDevices=[],this.velocity=new THREE.Vector3,this.matrix=new THREE.Matrix4;var i=function(e){return r.currentControl&&r.currentControl.keyUp&&r.currentControl.keyUp(e)},o=function(e){return r.Keyboard.doTyping(r.currentControl&&r.currentControl.focusedElement,e)};this.add(new Primrose.Input.Keyboard(this,{strafeLeft:{buttons:[-Primrose.Keys.A,-Primrose.Keys.LEFTARROW]},strafeRight:{buttons:[Primrose.Keys.D,Primrose.Keys.RIGHTARROW]},strafe:{commands:["strafeLeft","strafeRight"]},boost:{buttons:[Primrose.Keys.E],scale:.2},driveForward:{buttons:[-Primrose.Keys.W,-Primrose.Keys.UPARROW]},driveBack:{buttons:[Primrose.Keys.S,Primrose.Keys.DOWNARROW]},drive:{commands:["driveForward","driveBack"]},select:{buttons:[Primrose.Keys.ENTER]},dSelect:{buttons:[Primrose.Keys.ENTER],delta:!0},zero:{buttons:[Primrose.Keys.Z],metaKeys:[-Primrose.Keys.CTRL,-Primrose.Keys.ALT,-Primrose.Keys.SHIFT,-Primrose.Keys.META],commandUp:emit.bind(this,"zero")}})),this.Keyboard.addEventListener("keydown",o),this.Keyboard.addEventListener("keyup",i),this.add(new Primrose.Input.Touch(t,{buttons:{axes:["FINGERS"]},dButtons:{axes:["FINGERS"],delta:!0},dx:{axes:["X0"],delta:!0,scale:-.005,min:-5,max:5},heading:{commands:["dx"],integrate:!0},dy:{axes:["Y0"],delta:!0,scale:-.005,min:-5,max:5},pitch:{commands:["dy"],integrate:!0,min:.5*-Math.PI,max:.5*Math.PI}})),this.add(new Primrose.Input.Mouse(t,{buttons:{buttons:[1]},dButtons:{buttons:[1],delta:!0},dx:{axes:["X"],delta:!0,scale:-.005,min:-5,max:5},heading:{metaKeys:[-Primrose.Keys.CTRL,-Primrose.Keys.ALT,-Primrose.Keys.SHIFT,-Primrose.Keys.META],commands:["dx"],integrate:!0},dy:{axes:["Y"],delta:!0,scale:-.005,min:-5,max:5},pitch:{metaKeys:[-Primrose.Keys.CTRL,-Primrose.Keys.ALT,-Primrose.Keys.SHIFT,-Primrose.Keys.META],commands:["dy"],integrate:!0,min:.5*-Math.PI,max:.5*Math.PI}})),this.add(new Primrose.Input.VR(this.options.avatarHeight)),this.motionDevices.push(this.VR),Primrose.Input.Gamepad.addEventListener("gamepadconnected",function(e){var t,n=Primrose.Input.Gamepad.ID(e),i=0===n.indexOf("Vive");if("Unknown"!==n&&"Rift"!==n)if(i){for(var o=0,s=0;s<r.managers.length;++s)t=r.managers[s],t.currentPad&&t.currentPad.id===e.id&&++o;t=new Primrose.Input.Gamepad(e,o,{buttons:{axes:["BUTTONS"]},dButtons:{axes:["BUTTONS"],delta:!0},zero:{buttons:[Primrose.Input.Gamepad.VIVE_BUTTONS.GRIP_PRESSED],commandUp:emit.bind(r,"zero")}}),r.add(t),r.motionDevices.push(t);var a=8*(r.motionDevices.length-2),c=255<<a,u=127<<a,l=new Primrose.Pointer(n+"Pointer",c,u,[t]);l.add(textured(box(.1,.025,.2),c,{emissive:u})),r.pointers.push(l),l.addToBrowserEnvironment(null,r.options.scene),l.addEventListener("teleport",r.teleport)}else t=new Primrose.Input.Gamepad(e,0,{buttons:{axes:["BUTTONS"]},dButtons:{axes:["BUTTONS"],delta:!0},strafe:{axes:["LSX"],deadzone:.2},drive:{axes:["LSY"],deadzone:.2},heading:{axes:["RSX"],scale:-1,deadzone:.2,integrate:!0},dHeading:{commands:["heading"],delta:!0},pitch:{axes:["RSY"],scale:-1,deadzone:.2,integrate:!0},zero:{buttons:[Primrose.Input.Gamepad.XBOX_ONE_BUTTONS.BACK],commandUp:emit.bind(r,"zero")}}),r.add(t),r.mousePointer.addDevice(t,t,t),r.head.addDevice(t,t,t)}),Primrose.Input.Gamepad.addEventListener("gamepaddisconnected",this.remove.bind(this)),this.stage=new THREE.Object3D,this.mousePointer=new Primrose.Pointer("MousePointer",16711680,8323072,[this.Mouse],[this.VR,this.Keyboard]),this.pointers.push(this.mousePointer),this.mousePointer.addToBrowserEnvironment(null,this.options.scene),this.head=new Primrose.Pointer("GazePointer",16776960,8355584,[this.VR,this.Mouse,this.Touch,this.Keyboard]),this.pointers.push(this.head),this.head.addToBrowserEnvironment(null,this.options.scene),this.teleport=this.teleport.bind(this),this.lastTeleport=0,this.pointers.forEach(function(e){return e.addEventListener("teleport",r.teleport)}),this.ready=Promise.all(this.managers.map(function(e){return e.ready}).filter(identity))}return t(s,[{key:"teleport",value:function(e){var t=performance.now(),n=t-this.lastTeleport;n>o&&(this.lastTeleport=t,this.moveStage(e.position))}},{key:"remove",value:function(e){var t=this[e],n=this.managers.indexOf(t);n>-1&&(this.managers.splice(n,1),delete this[e]),console.log("removed",t)}},{key:"add",value:function(e){for(var t=this.managers.length-1;t>=0;--t)this.managers[t].name===e.name&&this.managers.splice(t,1);this.managers.push(e),this[e.name]=e}},{key:"zero",value:function(){for(var e=0;e<this.managers.length;++e)this.managers[e].zero()}},{key:"submitFrame",value:function(){this.VR.submitFrame()}},{key:"update",value:function(e){var t;this.Keyboard.enabled=this.Touch.enabled=this.Mouse.enabled=!this.hasMotionControllers,this.Gamepad_0&&(this.Gamepad_0.enabled=!this.hasMotionControllers);var n=this.hasGamepad;for(Primrose.Input.Gamepad.poll(),t=0;t<this.managers.length;++t)this.managers[t].update(e);for(!n&&this.hasGamepad&&(this.Mouse.inPhysicalUse=!1),this.updateStage(e),this.stage.updateMatrix(),this.matrix.multiplyMatrices(this.stage.matrix,this.VR.stage.matrix),t=0;t<this.motionDevices.length;++t)this.motionDevices[t].updateStage(this.matrix);for(t=0;t<this.pointers.length;++t)this.pointers[t].update();this.VR.hasOrientation?(this.mousePointer.showPointer=(this.hasMouse||this.hasGamepad)&&!(this.hasTouch||this.hasMotionControllers),this.head.showPointer=!0):(this.head.quaternion.copy(this.mousePointer.quaternion),this.head.showPointer=!1,this.mousePointer.showPointer=!0),this.newState=[],this.head.updateMatrix(),this.stage.updateMatrix(),this.head.position.toArray(this.newState,0),this.stage.quaternion.toArray(this.newState,3),this.head.quaternion.toArray(this.newState,7)}},{key:"updateStage",value:function(e){for(var t=0,o=0,s=0,a=0;a<this.managers.length;++a){var c=this.managers[a];t+=c.getValue("heading"),o+=c.getValue("strafe"),s+=c.getValue("drive")}this.VR.hasOrientation&&(t=i*Math.floor(t/i+.5)),r.set(0,t,0,"YXZ"),this.stage.quaternion.setFromEuler(r),this.velocity.x=o,this.velocity.z=s,this.stage.isOnGround||(this.velocity.y-=this.options.gravity*e,this.stage.position.y<0&&(this.velocity.y=0,this.stage.position.y=0,this.stage.isOnGround=!0)),this.moveStage(n.copy(this.velocity).multiplyScalar(e).applyQuaternion(this.stage.quaternion).add(this.head.position))}},{key:"moveStage",value:function(e){n.copy(e).sub(this.head.position),this.stage.position.x+=n.x,this.stage.position.z+=n.z}},{key:"resolvePicking",value:function(e,t,n){for(var r=0;r<this.pointers.length;++r)this.pointers[r].resolvePicking(e,t,n)}},{key:"addEventListener",value:function(e,t,n){if(this.listeners[e])this.listeners[e].push(t);else for(var r=0;r<this.managers.length;++r)this.managers[r].addEventListener(e,t,n)}},{key:"hasMotionControllers",get:function(){return!!(this.Vive_0&&this.Vive_0.enabled&&this.Vive_0.inPhysicalUse||this.Vive_1&&this.Vive_1.enabled&&this.Vive_1.inPhysicalUse)}},{key:"hasGamepad",get:function(){return!!(this.Gamepad_0&&this.Gamepad_0.enabled&&this.Gamepad_0.inPhysicalUse)}},{key:"hasMouse",get:function(){return!!(this.Mouse&&this.Mouse.enabled&&this.Mouse.inPhysicalUse)}},{key:"hasTouch",get:function(){return!!(this.Touch&&this.Touch.enabled&&this.Touch.inPhysicalUse)}},{key:"segments",get:function(){for(var e=[],t=0;t<this.pointers.length;++t){var n=this.pointers[t].segment;n&&e.push(n)}return e}},{key:"lockMovement",get:function(){for(var e=0;e<this.pointers.length;++e){var t=this.pointers[e];if(t.lockMovement)return!0}return!1}},{key:"currentControl",get:function(){for(var e=0;e<this.pointers.length;++e){var t=this.pointers[e];if(t.currentControl)return t.currentControl}}}]),s}();"undefined"!=typeof window&&(window.Primrose.Input.FPSInput=s)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();navigator.getGamepads=navigator.getGamepads||navigator.webkitGetGamepads;var i={gamepadconnected:[],gamepaddisconnected:[]},o=[],s=[],a={};pliny.class({parent:"Primrose.Input",name:"Gamepad",baseClass:"Primrose.PoseInputProcessor",parameters:[{name:"name",type:"string",description:"An unique name for this input manager. Note that systems with motion controllers will often have two controllers with the same ID, but different indexes. The name should take that into account."},{name:"commands",type:"Array",optional:!0,description:"An array of input command descriptions."}],description:"An input processor for Gamepads, including those with positional data."});var c=function(c){function u(n,r,i){e(this,u);var o=u.ID(n),s=t(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,o,i,["LSX","LSY","RSX","RSY","IDK1","IDK2","Z","BUTTONS"]));return a[o]=s,s.currentDevice=n,s.axisOffset=r,s}return n(u,c),r(u,null,[{key:"ID",value:function(e){var t=e.id;return"OpenVR Gamepad"===t?t="Vive":0===t.indexOf("Xbox")?t="Gamepad":0===t.indexOf("Rift")?t="Rift":0===t.indexOf("Unknown")&&(t="Unknown"),t=(t+"_"+(e.index||0)).replace(/\s+/g,"_")}},{key:"poll",value:function(){var e,t,n=navigator.getGamepads(),r=[],i=[],c=[],l=[];if(n)for(e=0;e<n.length;++e){var h=n[e];if(h){t=u.ID(h);var d=o.indexOf(t);r.push(h),i.push(t),d===-1?(c.push(h),o.push(t),s.push(h),delete a[t]):s[d]=h}}for(e=o.length-1;e>=0;--e){t=o[e];var p=a[t],m=s[e];i.indexOf(t)===-1?(l.push(t),s.splice(e,1),o.splice(e,1)):p&&p.checkDevice(m)}c.forEach(emit.bind(u,"gamepadconnected")),l.forEach(emit.bind(u,"gamepaddisconnected"))}},{key:"addEventListener",value:function(e,t){i[e]&&i[e].push(t)}},{key:"pads",get:function(){return s}},{key:"listeners",get:function(){return i}}]),r(u,[{key:"checkDevice",value:function(e){var t,n=0;for(this.currentDevice=e,this.currentPose=this.currentDevice.pose,t=0;t<e.buttons.length;++t){var r=e.buttons[t];this.setButton(t,r.pressed),r.pressed&&(n|=1<<t),this.setButton(t+e.buttons.length,r.touched)}for(this.setAxis("BUTTONS",n),t=0;t<e.axes.length;++t){var i=this.axisNames[this.axisOffset*e.axes.length+t];this.setAxis(i,e.axes[t])}}},{key:"vibrate",value:function(e){this.currentDevice&&this.currentDevice.vibrate&&this.currentDevice.vibrate(e)}}]),u}(Primrose.PoseInputProcessor);pliny.enumeration({parent:"Primrose.Input.Gamepad",name:"XBOX_360_BUTTONS",description:"Labeled names for each of the different control features of the Xbox 360 controller."}),c.XBOX_360_BUTTONS={A:1,B:2,X:3,Y:4,LEFT_BUMPER:5,RIGHT_BUMPER:6,LEFT_TRIGGER:7,RIGHT_TRIGGER:8,BACK:9,START:10,LEFT_STICK:11,RIGHT_STICK:12,UP_DPAD:13,DOWN_DPAD:14,LEFT_DPAD:15,RIGHT_DPAD:16},pliny.enumeration({parent:"Primrose.Input.Gamepad",name:"XBOX_ONE_BUTTONS",description:"Labeled names for each of the different control features of the Xbox 360 controller."}),c.XBOX_ONE_BUTTONS={A:1,B:2,X:3,Y:4,LEFT_BUMPER:5,RIGHT_BUMPER:6,LEFT_TRIGGER:7,RIGHT_TRIGGER:8,BACK:9,START:10,LEFT_STICK:11,RIGHT_STICK:12,UP_DPAD:13,DOWN_DPAD:14,LEFT_DPAD:15,RIGHT_DPAD:16},pliny.enumeration({parent:"Primrose.Input.Gamepad",name:"VIVE_BUTTONS",description:"Labeled names for each of the different control buttons of the HTC Vive Motion Controllers."}),c.VIVE_BUTTONS={TOUCHPAD_PRESSED:0,TRIGGER_PRESSED:1,GRIP_PRESSED:2,MENU_PRESSED:3,TOUCHPAD_TOUCHED:4,GRIP_TOUCHED:6,MENU_TOUCHED:7},"undefined"!=typeof window&&(window.Primrose.Input.Gamepad=c)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Input",name:"Keyboard",baseClass:"Primrose.InputProcessor",description:"| [under construction]",parameters:[{name:"",type:"",description:""},{name:"",type:"",description:""},{name:"",type:"",description:""},{name:"",type:"",description:""}]});var i=function(i){function o(n,r){e(this,o);var i=t(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,"Keyboard",r));i.listeners.clipboard=[],i.listeners.keydown=[],i.listeners.keyup=[],i._operatingSystem=null,i.browser=isChrome?"CHROMIUM":isFirefox?"FIREFOX":isIE?"IE":isOpera?"OPERA":isSafari?"SAFARI":"UNKNOWN",i._codePage=null;var s=function(e){n.lockMovement?emit.call(i,e.type,e):i.setButton(e.keyCode,"keydown"===e.type)},a=function(e){if(i.lockMovement){var t=i.operatingSystem.makeCommandName(e,i.codePage);"CUT"!==t&&"COPY"!==t||(u.style.display="block",u.focus())}},c=function(e){i.currentControl&&(i.currentControl[e.type+"SelectedText"](e),e.returnValue||e.preventDefault(),u.style.display="none",i.currentControl.focus())},u=Primrose.DOM.cascadeElement("primrose-surrogate-textarea","textarea",HTMLTextAreaElement),l=Primrose.DOM.makeHidingContainer("primrose-surrogate-textarea-container",u);return l.style.position="absolute",l.style.overflow="hidden",l.style.width=0,l.style.height=0,u.addEventListener("beforecopy",setFalse,!1),u.addEventListener("copy",c,!1),u.addEventListener("beforecut",setFalse,!1),u.addEventListener("cut",c,!1),document.body.insertBefore(l,document.body.children[0]),window.addEventListener("beforepaste",setFalse,!1),window.addEventListener("keydown",a,!0),window.addEventListener("keydown",s,!1),window.addEventListener("keyup",s,!1),i}return n(o,i),r(o,[{key:"doTyping",value:function(e,t){if(e)if(e.execCommand&&this.operatingSystem&&this.browser&&this.codePage){var n=this.operatingSystem._deadKeyState,r=this.operatingSystem.makeCommandName(t,this.codePage);e.execCommand(this.browser,this.codePage,r)&&t.preventDefault(),this.operatingSystem._deadKeyState===n&&(this.operatingSystem._deadKeyState="")}else e.keyDown(t)}},{key:"withCurrentControl",value:function(e){var t=this;return function(n){t.currentControl&&(t.currentControl[e]?t.currentControl[e](n):console.warn("Couldn't find %s on %o",e,t.currentControl))}}},{key:"operatingSystem",get:function(){return this._operatingSystem},set:function(e){this._operatingSystem=e||(isOSX?Primrose.Text.OperatingSystems.OSX:Primrose.Text.OperatingSystems.Windows)}},{key:"codePage",get:function(){return this._codePage},set:function(e){var t;if(this._codePage=e,!this._codePage){var n=navigator.languages&&navigator.languages[0]||navigator.language||navigator.userLanguage||navigator.browserLanguage;n&&"en"!==n||(n="en-US");for(t in Primrose.Text.CodePages)if(e=Primrose.Text.CodePages[t],e.language===n){this._codePage=e;break}this._codePage||(this._codePage=Primrose.Text.CodePages.EN_US)}}}]),o}(Primrose.InputProcessor);"undefined"!=typeof window&&(window.Primrose.Input.Keyboard=i)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Input",name:"LeapMotionInput",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var i=function(i){function o(n){e(this,o);var r=t(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,"LeapMotion",n,["X0","Y0","Z0","X1","Y1","Z1","FINGER0TIPX","FINGER0TIPY","FINGER0DIPX","FINGER0DIPY","FINGER0PIPX","FINGER0PIPY","FINGER0MCPX","FINGER0MCPY","FINGER0CARPX","FINGER0CARPY","FINGER1TIPX","FINGER1TIPY","FINGER1DIPX","FINGER1DIPY","FINGER1PIPX","FINGER1PIPY","FINGER1MCPX","FINGER1MCPY","FINGER1CARPX","FINGER1CARPY","FINGER2TIPX","FINGER2TIPY","FINGER2DIPX","FINGER2DIPY","FINGER2PIPX","FINGER2PIPY","FINGER2MCPX","FINGER2MCPY","FINGER2CARPX","FINGER2CARPY","FINGER3TIPX","FINGER3TIPY","FINGER3DIPX","FINGER3DIPY","FINGER3PIPX","FINGER3PIPY","FINGER3MCPX","FINGER3MCPY","FINGER3CARPX","FINGER3CARPY","FINGER4TIPX","FINGER4TIPY","FINGER4DIPX","FINGER4DIPY","FINGER4PIPX","FINGER4PIPY","FINGER4MCPX","FINGER4MCPY","FINGER4CARPX","FINGER4CARPY","FINGER5TIPX","FINGER5TIPY","FINGER5DIPX","FINGER5DIPY","FINGER5PIPX","FINGER5PIPY","FINGER5MCPX","FINGER5MCPY","FINGER5CARPX","FINGER5CARPY","FINGER6TIPX","FINGER6TIPY","FINGER6DIPX","FINGER6DIPY","FINGER6PIPX","FINGER6PIPY","FINGER6MCPX","FINGER6MCPY","FINGER6CARPX","FINGER6CARPY","FINGER7TIPX","FINGER7TIPY","FINGER7DIPX","FINGER7DIPY","FINGER7PIPX","FINGER7PIPY","FINGER7MCPX","FINGER7MCPY","FINGER7CARPX","FINGER7CARPY","FINGER8TIPX","FINGER8TIPY","FINGER8DIPX","FINGER8DIPY","FINGER8PIPX","FINGER8PIPY","FINGER8MCPX","FINGER8MCPY","FINGER8CARPX","FINGER8CARPY","FINGER9TIPX","FINGER9TIPY","FINGER9DIPX","FINGER9DIPY","FINGER9PIPX","FINGER9PIPY","FINGER9MCPX","FINGER9MCPY","FINGER9CARPX","FINGER9CARPY"]));
return r.isStreaming=!1,r.controller=new Leap.Controller({enableGestures:!0}),r}return n(o,i),r(o,[{key:"E",value:function(e,t){t?this.controller.on(e,t):this.controller.on(e,console.log.bind(console,"Leap Motion Event: "+e))}},{key:"start",value:function(e){var t=this;if(this.isEnabled()){var n=null,r=null;if(e){var i=function t(n){requestAnimationFrame(t),e(n)};r=requestAnimationFrame.bind(window,i);var s=setTimeout(r,o.CONNECTION_TIMEOUT);n=function(){clearTimeout(s),t.isStreaming=!0},this.E("deviceStreaming",n),this.E("streamingStarted",n),this.E("streamingStopped",r)}this.E("connect"),this.E("deviceStopped"),this.E("disconnect"),this.E("frame",this.setState.bind(this,e)),this.controller.connect()}}},{key:"setState",value:function(e,t){var n,r,i=this.controller.history.get(1);if(!i||t.hands.length!==i.hands.length)for(n=0;n<this.commands.length;++n)this.enable(this.commands[n].name,t.hands.length>0);for(n=0;n<t.hands.length;++n){var s=t.hands[n].palmPosition,a="HAND"+n;for(r=0;r<o.COMPONENTS.length;++r)this.setAxis(a+o.COMPONENTS[r],s[r])}for(n=0;n<t.fingers.length;++n){var c=t.fingers[n],u="FINGER"+n;for(r=0;r<o.FINGER_PARTS.length;++r)for(var l=c[o.FINGER_PARTS[r]+"Position"],h=u+o.FINGER_PARTS[r].toUpperCase(),d=0;d<o.COMPONENTS.length;++d)this.setAxis(h+o.COMPONENTS[d],l[d])}e&&e(.001*t.timestamp),this.update()}}]),o}(Primrose.InputProcessor);i.COMPONENTS=["X","Y","Z"],i.NUM_HANDS=2,i.NUM_FINGERS=10,i.FINGER_PARTS=["tip","dip","pip","mcp","carp"],i.CONNECTION_TIMEOUT=5e3,"undefined"!=typeof window&&(window.Primrose.Input.LeapMotion=i)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Input",name:"Location",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var i=function(i){function o(n,r){e(this,o);var i=t(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,"Location",n,["LONGITUDE","LATITUDE","ALTITUDE","HEADING","SPEED"]));return i.options=patch(r,o.DEFAULTS),i.available=!!navigator.geolocation,i.available&&navigator.geolocation.watchPosition(i.setState.bind(i),function(){return i.available=!1},i.options),i}return n(o,i),r(o,[{key:"setState",value:function(e){for(var t in e.coords){var n=t.toUpperCase();this.axisNames.indexOf(n)>-1&&this.setAxis(n,e.coords[t])}this.update()}}]),o}(Primrose.InputProcessor);i.DEFAULTS={enableHighAccuracy:!0,maximumAge:3e4,timeout:25e3},"undefined"!=typeof window&&(window.Primrose.Input.Location=i)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}pliny.class({parent:"Primrose.Input",name:"Mouse",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var r=function(r){function i(n,r){e(this,i);var o=t(this,(i.__proto__||Object.getPrototypeOf(i)).call(this,"Mouse",r,["BUTTONS","X","Y","Z","W"]));o.timer=null,n=n||window;var s=function(e,t){for(var n=t.buttons,r=0;n>0;){var i=n&!0;(i&&e||!i&&!e)&&o.setButton(r,e),n>>=1,++r}o.setAxis("BUTTONS",t.buttons<<10),t.preventDefault()};return n.addEventListener("mousedown",s.bind(o,!0),!1),n.addEventListener("mouseup",s.bind(o,!1),!1),n.addEventListener("mousemove",function(e){if(s(!0,e),PointerLock.isActive){var t=e.movementX,n=e.movementY;void 0===t&&(t=e.webkitMovementX||e.mozMovementX||0,n=e.webkitMovementY||e.mozMovementY||0),o.setAxis("X",o.getAxis("X")+t),o.setAxis("Y",o.getAxis("Y")+n)}else o.setAxis("X",e.layerX),o.setAxis("Y",e.layerY)},!1),n.addEventListener("wheel",function(e){isChrome?(o.W+=e.deltaX,o.Z+=e.deltaY):e.shiftKey?o.W+=e.deltaY:o.Z+=e.deltaY,e.preventDefault()},!1),o}return n(i,r),i}(Primrose.InputProcessor);"undefined"!=typeof window&&(window.Primrose.Input.Mouse=r)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)};pliny.class({parent:"Primrose.Input",name:"Speech",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var o=function(o){function s(n){function r(){var e="Failed to initialize speech engine. Reason: "+l.message;return console.error(e),!1}function i(){return available?!c&&(c=!0,u.start(),!0):r()}function o(){return available?!!c&&(u.stop(),!0):r()}e(this,s);var a=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,"Speech",n)),c=!1,u=null,l=null;a.check=function(){this.enabled&&!c?i():!this.enabled&&c&&o()},a.getErrorMessage=function(){return l};try{u=window.SpeechRecognition?new SpeechRecognition:new webkitSpeechRecognition,u.continuous=!0,u.interimResults=!0,u.lang="en-US";var h=!1;u.addEventListener("start",function(){console.log("speech started"),command=""}.bind(a),!0),u.addEventListener("error",function(e){h=!0,console.log("speech error",e),c=!1,command="speech error"}.bind(a),!0),u.addEventListener("end",function(e){console.log("speech ended",e),c=!1,command="speech ended",h&&(h=!1,this.enable(!0))}.bind(a),!0),u.addEventListener("result",function(e){var t=[],n=e.results[e.resultIndex],r=0,i=-1;if(n&&n.isFinal)for(var o=0;o<n.length;++o){var s=n[o];s.confidence>r&&(r=s.confidence,i=o)}r>.85&&t.push(n[i].transcript.trim()),t=t.join(" "),t!==this.inputState&&(this.inputState.text=t),this.update()}.bind(a),!0),available=!0}catch(e){console.error(e),l=e,available=!1}return a}return n(s,o),r(s,[{key:"cloneCommand",value:function(e){return{name:e.name,preamble:e.preamble,keywords:s.maybeClone(e.keywords),commandUp:e.commandUp,disabled:e.disabled}}},{key:"evalCommand",value:function(e,t,n,r){if(n&&this.inputState.text)for(var i=0;i<e.keywords.length;++i)0!==this.inputState.text.indexOf(e.keywords[i])||!e.preamble&&e.keywords[i].length!==this.inputState.text.length||(t.pressed=!0,t.value=this.inputState.text.substring(e.keywords[i].length).trim(),this.inputState.text=null)}},{key:"enable",value:function(e,t){i(s.prototype.__proto__||Object.getPrototypeOf(s.prototype),"enable",this).call(this,e,t),this.check()}},{key:"transmit",value:function(e){i(s.prototype.__proto__||Object.getPrototypeOf(s.prototype),"transmit",this).call(this,e),this.check()}}],[{key:"maybeClone",value:function(e){return e&&e.slice()||[]}}]),s}(Primrose.InputProcessor);"undefined"!=typeof window&&(window.Primrose.Input.Speech=o)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}pliny.class({parent:"Primrose.Input",name:"Touch",baseClass:"Primrose.InputProcessor",description:"| [under construction]"});var r=function(r){function i(n,r){e(this,i);for(var o=["FINGERS"],s=0;s<10;++s)o.push("X"+s),o.push("Y"+s),o.push("LX"+s),o.push("LY"+s);var a=t(this,(i.__proto__||Object.getPrototypeOf(i)).call(this,"Touch",r,o));n=n||window;var c=function(e,t,n){var r=n.changedTouches,i=0,o=null;for(i=0;i<r.length;++i)o=r[i],t?(a.setAxis("X"+o.identifier,o.pageX),a.setAxis("Y"+o.identifier,o.pageY)):(a.setAxis("LX"+o.identifier,o.pageX),a.setAxis("LY"+o.identifier,o.pageY)),a.setButton("FINGER"+o.identifier,e);r=n.touches;var s=0;a.getAxis("FINGERS");for(i=0;i<r.length;++i)o=r[i],s|=1<<o.identifier;a.setAxis("FINGERS",s),n.preventDefault()};return n.addEventListener("touchstart",c.bind(a,!0,!1),!1),n.addEventListener("touchend",c.bind(a,!1,!0),!1),n.addEventListener("touchmove",c.bind(a,!0,!0),!1),a}return n(i,r),i}(Primrose.InputProcessor);"undefined"!=typeof window&&(window.Primrose.Input.Touch=r)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e},i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},s=3e3;pliny.class({parent:"Primrose.Input",name:"VR",baseClass:"Primrose.PoseInputProcessor",parameters:[{name:"avatarHeight",type:"Number",description:"The default height to use for the user, if the HMD doesn't provide a stage transform."}],description:"An input manager for gamepad devices."});var a=function(a){function c(n){e(this,c);var r=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,"VR"));return r.displays=[],r._transformers=[],r.currentDeviceIndex=-1,r.movePlayer=new THREE.Matrix4,r.defaultAvatarHeight=n,r.stage=null,r.lastStageWidth=null,r.lastStageDepth=null,console.info("Checking for displays..."),r.ready=navigator.getVRDisplays().then(function(e){return console.log("Displays found:",e.length),r.displays.push.apply(r.displays,e),r.displays}),r}return n(c,a),i(c,[{key:"connect",value:function(e){if(this.currentDevice=null,this.currentDeviceIndex=e,this.currentPose=null,0<=e&&e<=this.displays.length){this.currentDevice=this.displays[e],this.currentPose=this.currentDevice.getPose();var t=this.currentDevice.getEyeParameters("left"),n=t.fieldOfView;this.rotationAngle=Math.PI*(n.leftDegrees+n.rightDegrees)/360}}},{key:"requestPresent",value:function(e){var t=this;if(!this.currentDevice)return Promise.reject("No display");var n=function(){var n=e,r=e[0].source,i=void 0;return n instanceof Array||(n=[n]),t.isNativeMobileWebVR&&(n=n[0]),t.currentDevice.isPolyfilled&&isMobile?i=t.currentDevice.requestPresent(n):(i=FullScreen.request(r).catch(function(e){return console.warn("FullScreen",e)}),i=isMobile?i.then(Orientation.lock).catch(function(e){return console.warn("OrientationLock",e)}):i.then(function(){return PointerLock.request(r)}).catch(function(e){return console.warn("PointerLock",e)}),i=i.then(function(){return t.currentDevice.requestPresent(n)}).catch(function(e){return console.warn("requstPresent",e)})),{v:i}}();return"object"===("undefined"==typeof n?"undefined":r(n))?n.v:void 0}},{key:"cancel",value:function(){var e=this,t=null;return this.isPresenting?(t=this.currentDevice.exitPresent(),this.currentDevice=null,this.currentDeviceIndex=-1,this.currentPose=null):t=Promise.resolve(),this.isNativeMobileWebVR&&(t=t.then(Orientation.unlock)),t.then(PointerLock.exit).then(function(){return e.connect(0)})}},{key:"zero",value:function(){o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"zero",this).call(this),this.currentDevice&&this.currentDevice.resetPose()}},{key:"update",value:function(e){o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"update",this).call(this,e);var t,n,r;this.currentDevice?(this.currentPose=this.currentDevice.getPose(),r=this.currentDevice.stageParameters):r=null,r?(this.movePlayer.fromArray(r.sittingToStandingTransform),t=r.sizeX,n=r.sizeZ):(this.movePlayer.makeTranslation(0,this.defaultAvatarHeight,0),t=0,n=0);var i={matrix:this.movePlayer,sizeX:t,sizeZ:n};this.stage&&i.sizeX===this.stage.sizeX&&i.sizeZ===this.stage.sizeZ||(this.stage=i)}},{key:"submitFrame",value:function(){this.currentDevice&&this.currentDevice.submitFrame(this.currentPose)}},{key:"resolvePicking",value:function(e,t,n){o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"resolvePicking",this).call(this,e,t,n);var r,i,a=e.VR,u=t&&t.VR;u&&a&&u.objectID===a.objectID?(a.startTime=u.startTime,a.gazeFired=u.gazeFired,r=i-a.startTime,r>=s&&!a.gazeFired&&(a.gazeFired=!0,emit.call(this,"gazecomplete",a),emit.call(this.pickableObjects[a.objectID],"click","Gaze"))):(u&&(r=i-u.startTime,r<s&&emit.call(this,"gazecancel",u)),a&&(a.startTime=i,a.gazeFired=!1,emit.call(this,"gazestart",a)))}},{key:"getTransforms",value:function(e,t){if(this.currentDevice)return this._transformers[this.currentDeviceIndex]||(this._transformers[this.currentDeviceIndex]=new ViewCameraTransform(this.currentDevice)),this._transformers[this.currentDeviceIndex].getTransforms(e,t)}},{key:"isNativeMobileWebVR",get:function(){return!(this.currentDevice&&this.currentDevice.isPolyfilled)&&isChrome&&isMobile}},{key:"hasStage",get:function(){return this.stage&&this.stage.sizeX*this.stage.sizeZ>0}},{key:"canMirror",get:function(){return this.currentDevice&&this.currentDevice.capabilities.hasExternalDisplay}},{key:"isPolyfilled",get:function(){return this.currentDevice&&this.currentDevice.isPolyfilled}},{key:"isPresenting",get:function(){return this.currentDevice&&this.currentDevice.isPresenting}},{key:"hasOrientation",get:function(){return this.currentDevice&&this.currentDevice.capabilities.hasOrientation}},{key:"currentCanvas",get:function(){if(this.isPresenting){var e=this.currentDevice.getLayers();if(e.length>0)return e[0].source}return null}}]),c}(Primrose.PoseInputProcessor);"undefined"!=typeof window&&(window.Primrose.Input.VR=a)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},o=!1;navigator.mediaDevices||(navigator.mediaDevices={}),navigator.mediaDevices.getUserMedia||(navigator.getUserMedia=navigator.getUserMedia||navigator.webkitGetUserMedia||navigator.mozGetUserMedia||navigator.msGetUserMedia||navigator.oGetUserMedia,navigator.mediaDevices.getUserMedia=function(e){return new Promise(function(t,n){return navigator.getUserMedia(e,t,n)})});var s=function(){function e(e){if(o){for(var i=e.sdp,s=i.split("\r\n"),a=null,c=0;c<s.length;c++)if(s[c].search("m=audio")!==-1){a=c;break}if(null===a)return i;for(var u=0;u<s.length;u++)if(s[u].search("opus/48000")!==-1){var l=t(s[u],/:(\d+) opus\/48000/i);l&&(s[a]=n(s[a],l));break}s=r(s,a),e.sdp=s.join("\r\n")}return e}function t(e,t){var n=e.match(t);return n&&2==n.length?n[1]:null}function n(e,t){for(var n=e.split(" "),r=[],i=0,o=0;o<n.length;o++)3===i&&(r[i++]=t),n[o]!==t&&(r[i++]=n[o]);return r.join(" ")}function r(e,n){for(var r=e[n].split(" "),i=e.length-1;i>=0;i--){var o=t(e[i],/a=rtpmap:(\d+) CN\/\d+/i);if(o){var s=r.indexOf(o);s!==-1&&r.splice(s,1),e.splice(i,1)}}return e[n]=r.join(" "),e}return e}();pliny.class({parent:"Primrose.Network",name:"AudioChannel",baseClass:"Primrose.WebRTCSocket",description:"Manages the negotiation between peer users to set up bidirectional audio between the two.",parameters:[{name:"extraIceServers",type:"Array",description:"A collection of ICE servers to use on top of the default Google STUN servers."},{name:"proxyServer",type:"WebSocket",description:"A connection over which to negotiate the peering."},{name:"fromUserName",type:"String",description:"The name of the local user, from which the peering is being initiated."},{name:"toUserName",type:"String",description:"The name of the remote user, to which the peering is being requested."},{name:"outAudio",type:"MediaStream",description:"An audio stream from the local user to send to the remote user."}]});var a=function(o){function a(n,r,i,o,s,c){e(this,a),console.log("attempting to peer audio from %s to %s. %s goes first.",i,o,c?o:i);var u=t(this,(a.__proto__||Object.getPrototypeOf(a)).call(this,n,r,i,0,o,0,c));return pliny.property({parent:"Primrose.Network.AudioChannel",name:"outAudio",type:"MediaStream",description:"An audio channel from the local user to the remote user."}),Object.defineProperty(u,"outAudio",{get:function(){return s}}),pliny.property({parent:"Primrose.Network.AudioChannel",name:"inAudio",type:"MediaStream",description:"An audio channel from the remote user to the local user."}),u.inAudio=null,u.startTimeout(),u}return n(a,o),r(a,[{key:"issueRequest",value:function(){var e=this,t=function(){e._log(0,"adding stream",e.outAudio),e.outAudio&&(e.rtc.addTrack?e.outAudio.getAudioTracks().forEach(function(t){return e.rtc.addTrack(t,e.outAudio)}):e.rtc.addStream(e.outAudio))},n=function(n){e.inAudio=n,e.goFirst||(e._log(0,"Creating the second stream from %s to %s",e.fromUserName,e.toUserName),e.clearTimeout(),e._log(1,"Restarting timeout."),e.startTimeout(),t())};this.rtc.ontrack?this.rtc.ontrack=function(e){return n(e.streams[0])}:this.rtc.onaddstream=function(e){return n(e.stream)},this.goFirst&&(this._log(0,"Creating the first stream from %s to %s",this.fromUserName,this.toUserName),t())}},{key:"teardown",value:function(){this.rtc.ontrack&&(this.rtc.ontrack=null),this.rtc.onaddstream&&(this.rtc.onaddstream=null)}},{key:"createOffer",value:function(){return i(a.prototype.__proto__||Object.getPrototypeOf(a.prototype),"createOffer",this).call(this).then(s)}},{key:"complete",get:function(){return this.goFirst?this._log(1,"[First]: OC %s -> AR %s -> OR %s -> AC %s.",this.progress.offer.created,this.progress.answer.received,this.progress.offer.received,this.progress.answer.created):this._log(1,"[Second]: OR %s -> AC %s -> OC %s -> AR %s.",this.progress.offer.received,this.progress.answer.created,this.progress.offer.created,this.progress.answer.received),i(a.prototype.__proto__||Object.getPrototypeOf(a.prototype),"complete",this)||this.progress.offer.received&&this.progress.offer.created&&this.progress.answer.received&&this.progress.answer.created}}]),a}(Primrose.WebRTCSocket);"undefined"!=typeof window&&(window.Primrose.Network.AudioChannel=a)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)};pliny.class({parent:"Primrose.Network",name:"DataChannel",baseClass:"Primrose.WebRTCSocket",description:"Manages the negotiation between peer users to set up bidirectional audio between the two.",parameters:[{name:"extraIceServers",type:"Array",description:"A collection of ICE servers to use on top of the default Google STUN servers."},{name:"proxyServer",type:"WebSocket",description:"A connection over which to negotiate the peering."},{name:"fromUserName",type:"String",description:"The name of the local user, from which the peering is being initiated."},{name:"fromUserIndex",type:"Number",description:"For users with multiple devices logged in at one time, this is the index of the device that is performing the peering operation."},{name:"toUserName",type:"String",description:"The name of the remote user, to which the peering is being requested."},{name:"toUserIndex",type:"Number",description:"For users with multiple devices logged in at one time, this is the index of the device that is receiving the peering operation."}]});var o=function(o){function s(n,r,i,o,a,c,u){e(this,s);var l=t(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n,r,i,o,a,c,u));return pliny.property({parent:"Primrose.Network.DataChannel",name:"dataChannel",type:"RTCDataChannel",description:"A bidirectional data channel from the remote user to the local user."}),l.dataChannel=null,l}return n(s,o),r(s,[{key:"issueRequest",value:function(){var e=this;goFirst?(this._log(0,"Creating data channel"),this.dataChannel=this.rtc.createDataChannel()):this.ondatachannel=function(t){e._log(0,"Receving data channel"),e.dataChannel=t.channel}}},{key:"teardown",value:function(){this.rtc.ondatachannel=null}},{key:"complete",get:function(){return this.goFirst?this._log(1,"[First]: OC %s -> AR %s.",this.progress.offer.created,this.progress.answer.received):this._log(1,"[Second]: OC %s -> AR %s.",this.progress.offer.created,this.progress.answer.received),i(s.prototype.__proto__||Object.getPrototypeOf(s.prototype),"complete",this)||this.goFirst&&this.progress.offer.created&&this.progress.answer.received||!this.goFirst&&this.progress.offer.recieved&&this.progress.answer.created}}]),s}(Primrose.WebRTCSocket);"undefined"!=typeof window&&(window.Primrose.Network.DataChannel=o)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Network",name:"Manager",parameters:[{name:"localUser",type:"Primrose.Input.FPSInput",description:"The object that represents the player's location in the scene."},{name:"audio",type:"Primrose.Output.Audio3D",description:"The audio manager being used in the current Environment."},{name:"factories",type:"Primrose.ModelLoader",description:"Model factory for creating avatars for new remote users."}]});var i=function(i){function o(n,r,i,s){e(this,o);var a=t(this,(o.__proto__||Object.getPrototypeOf(o)).call(this));return a.localUser=n,a.audio=r,a.factories=i,a.options=s,a.lastNetworkUpdate=0,a.oldState=[],a.users={},a.extraIceServers=[],s.webRTC?a.waitForLastUser=s.webRTC.then(function(e){e&&a.extraIceServers.push.apply(a.extraIceServers,e.iceServers)}):a.waitForLastUser=Promise.resolve(),a._socket=null,a.userName=null,a.microphone=null,a}return n(o,i),r(o,[{key:"update",value:function(e){if(this._socket&&0===this.deviceIndex&&(this.lastNetworkUpdate+=e,this.lastNetworkUpdate>=Primrose.Network.RemoteUser.NETWORK_DT)){this.lastNetworkUpdate-=Primrose.Network.RemoteUser.NETWORK_DT;for(var t=0;t<this.localUser.newState.length;++t)if(this.oldState[t]!==this.localUser.newState[t]){this._socket.emit("userState",this.localUser.newState),this.oldState=this.localUser.newState;break}}for(var n in this.users){var r=this.users[n];r.update(e)}}},{key:"updateUser",value:function(e){var t=e[0];if(t!==this.userName){var n=this.users[t];n?n.setState(e):console.error("Unknown user",t)}else this.deviceIndex>0&&(this.localUser.stage.mesh.position.fromArray(e,1),this.localUser.stage.mesh.quaternion.fromArray(e,4),this.localUser.head.mesh.position.fromArray(e,8),this.localUser.head.mesh.quaternion.fromArray(e,11))}},{key:"connect",value:function(e,t){this.userName=t.toLocaleUpperCase(),this.microphone||(this.microphone=navigator.mediaDevices.getUserMedia({audio:!0,video:!1}).then(Primrose.Output.Audio3D.setAudioStream).catch(console.warn.bind(console,"Can't get audio"))),this._socket||(this._socket=e,this._socket.on("userList",this.listUsers.bind(this)),this._socket.on("userJoin",this.addUser.bind(this)),this._socket.on("deviceAdded",this.addDevice.bind(this)),this._socket.on("deviceIndex",this.setDeviceIndex.bind(this)),this._socket.on("chat",this.receiveChat.bind(this)),this._socket.on("userState",this.updateUser.bind(this)),this._socket.on("userLeft",this.removeUser.bind(this)),this._socket.on("connection_lost",this.lostConnection.bind(this)),this._socket.emit("listUsers"),this._socket.emit("getDeviceIndex"))}},{key:"disconnect",value:function(){this.userName=null,this._socket.close(),this._socket=null}},{key:"addUser",value:function(e,t){var n=this;console.log("User %s logging on.",e[0]);var r=e[0],i=new Primrose.Network.RemoteUser(r,this.factories.avatar,this.options.foregroundColor);this.users[r]=i,this.updateUser(e),this.emit("addavatar",i),this.waitForLastUser=this.waitForLastUser.then(function(){return i.peer(n.extraIceServers,n._socket,n.microphone,n.userName,n.audio,t)}).then(function(){return console.log("%s is peered with %s",n.userName,r)}).catch(function(e){return console.error("Couldn't load user: "+name,e)})}},{key:"removeUser",value:function(e){console.log("User %s logging off.",e);var t=this.users[e];t&&(t.unpeer(),delete this.users[e],this.emit("removeavatar",t))}},{key:"listUsers",value:function(e){for(Object.keys(this.users).forEach(this.removeUser.bind(this));e.length>0;)this.addUser(e.shift(),!0);this.emit("authorizationsucceeded")}},{key:"receiveChat",value:function(e){console.log("chat",e)}},{key:"lostConnection",value:function(){this.deviceIndex=null}},{key:"addDevice",value:function(e){console.log("addDevice",e)}},{key:"setDeviceIndex",value:function(e){this.deviceIndex=e}}]),o}(Primrose.AbstractEventEmitter);"undefined"!=typeof window&&(window.Primrose.Network.Manager=i)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Network",name:"RemoteUser",description:"A networked user.",parameters:[{name:"userName",type:"String",description:"The name of the user."},{name:"modelFactory",type:"Primrose.ModelLoader",description:"The factory for creating avatars for the user."},{name:"nameMaterial",type:"Number",description:"The color to use with `textured()` to set as the material for the NAME object that will float above the user's avatar."}]});var n=function(){function n(t,r,i){var o=this;e(this,n),this.time=0,this.userName=t,this.stage=r.clone(),this.stage.traverse(function(e){"AvatarBelt"===e.name?textured(e,Primrose.Random.color()):"AvatarHead"===e.name&&(o.head=e)}),this.nameObject=textured(text3D(.1,t),i);var s=this.nameObject.geometry.boundingBox.max;this.nameObject.rotation.set(0,Math.PI,0),this.nameObject.position.set(s.x/2,s.y,0),this.head.add(this.nameObject),this.dStageQuaternion=new THREE.Quaternion,this.dHeadPosition=new THREE.Vector3,this.dHeadQuaternion=new THREE.Quaternion,this.lastStageQuaternion=new THREE.Quaternion,this.lastHeadPosition=new THREE.Vector3,this.lastHeadQuaternion=new THREE.Quaternion,this.stageQuaternion={arr1:[],arr2:[],last:this.lastStageQuaternion,delta:this.dStageQuaternion,curr:this.stage.quaternion},this.headPosition={arr1:[],arr2:[],last:this.lastHeadPosition,delta:this.dHeadPosition,curr:this.head.position},this.headQuaternion={arr1:[],arr2:[],last:this.lastHeadQuaternion,delta:this.dHeadQuaternion,curr:this.head.quaternion},this.audioChannel=null,this.audioElement=null,this.audioStream=null,this.gain=null,this.panner=null,this.analyzer=null}return t(n,[{key:"peer",value:function(e,t,n,r,i,o){var s=this;return pliny.method({parent:"Pliny.RemoteUser",name:"peer",returns:"Promise",description:"Makes a WebRTCPeerConnection between the local user and this remote user and wires up the audio channel.",parameters:[{name:"extraIceServers",type:"Array",description:"A collection of ICE servers to use on top of the default Google STUN servers."},{name:"peeringSocket",type:"WebSocket",description:"A WebSocket over which the peer connection will be negotiated."},{name:"microphone",type:"Promise",description:"A promise that resolves with an audio stream that can be sent to the remote user, representing the local user's voice chat."
},{name:"localUserName",type:"String",description:"The name of the user initiating the peer connection."},{name:"audio",type:"Primrose.Output.Audio3D",description:"The audio context form which audio spatialization objects will be created, and to which the remote user's voice chat will be piped."}]}),n.then(function(n){return s.audioChannel=new Primrose.Network.AudioChannel(e,t,r,s.userName,n,o),s.audioChannel.ready.then(function(){if(!s.audioChannel.inAudio)throw new Error("Didn't get an audio channel for "+s.userName);s.audioElement=new Audio,Primrose.Output.Audio3D.setAudioStream(s.audioChannel.inAudio),s.audioElement.controls=!1,s.audioElement.autoplay=!0,s.audioElement.crossOrigin="anonymous",document.body.appendChild(s.audioElement),s.audioStream=i.context.createMediaStreamSource(s.audioChannel.inAudio),s.gain=i.context.createGain(),s.panner=i.context.createPanner(),s.audioStream.connect(s.gain),s.gain.connect(s.panner),s.panner.connect(i.mainVolume),s.panner.coneInnerAngle=180,s.panner.coneOuterAngle=360,s.panner.coneOuterGain=.1,s.panner.panningModel="HRTF",s.panner.distanceModel="exponential"})})}},{key:"unpeer",value:function(){pliny.method({parent:"Pliny.RemoteUser",name:"unpeer",description:"Cleans up after a user has left the room, removing the audio channels that were created for the user."}),this.audioChannel&&(this.audioChannel.close(),this.audioElement&&(document.body.removeChild(this.audioElement),this.panner&&(this.panner.disconnect(),this.gain.disconnect(),this.audioStream.disconnect())))}},{key:"_updateV",value:function(e,t,r){e.curr.toArray(e.arr1),e.delta.toArray(e.arr2);for(var i=0;i<e.arr1.length;++i)r&&(e.arr2[i]*=n.FADE_FACTOR),e.arr1[i]+=e.arr2[i]*t;e.curr.fromArray(e.arr1),e.delta.fromArray(e.arr2)}},{key:"_predict",value:function(e,t,r){e.delta.fromArray(t,r),e.delta.toArray(e.arr1),e.curr.toArray(e.arr2);for(var i=0;i<e.arr1.length;++i)e.arr1[i]=(e.arr1[i]-e.arr2[i])*n.NETWORK_DT_INV;e.delta.fromArray(e.arr1)}},{key:"update",value:function(e){pliny.method({parent:"Pliny.RemoteUser",name:"update",description:"Moves the avatar by its velocity for a set amount of time. Updates the audio panner information.",parameters:[{name:"dt",type:"Number",description:"The amount of time since the last update to the user."}]}),this.time+=e;var t=this.time>=n.NETWORK_DT;this._updateV(this.headPosition,e,t),this._updateV(this.stageQuaternion,e,t),this._updateV(this.headQuaternion,e,t),this.stage.position.copy(this.headPosition.curr),this.stage.position.y=0,this.panner&&(this.panner.setPosition(this.stage.position.x,this.stage.position.y,this.stage.position.z),this.panner.setOrientation(Math.sin(this.stage.rotation.y),0,Math.cos(this.stage.rotation.y)))}},{key:"setState",value:function(e){pliny.property({parent:"Pliny.RemoteUser",name:"state",description:"After receiving a network update, sets the current state of the remote user so that, by the time the next network update comes around, the user will be where it is predicted to be.",parameters:[{name:"v",type:"Array",description:"The raw state array from the network (includes the un-read first username field)."}]}),this.time=0,this._predict(this.headPosition,e,1),this._predict(this.stageQuaternion,e,4),this._predict(this.headQuaternion,e,8)}},{key:"toString",value:function(e){return this.stage.position.curr.toString(e)+" "+this.headPosition.curr.toString(e)}}]),n}();n.FADE_FACTOR=.5,n.NETWORK_DT=.1,n.NETWORK_DT_INV=1/n.NETWORK_DT,"undefined"!=typeof window&&(window.Primrose.Network.RemoteUser=n)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();Window.prototype.AudioContext=Window.prototype.AudioContext||Window.prototype.webkitAudioContext||function(){},pliny.class({parent:"Primrose.Output",name:"Audio3D",description:"| [under construction]"});var n=function(){function n(){var t=this;e(this,n);try{this.context=new AudioContext,this.sampleRate=this.context.sampleRate,this.mainVolume=this.context.createGain();var r=new THREE.Vector3,i=new THREE.Vector3,o=(new THREE.Matrix4).identity(),s=(new THREE.Matrix4).identity(),a=null;this.setVelocity=this.context.listener.setVelocity.bind(this.context.listener),this.setPlayer=function(e){var n=e;for(o.identity(),s.identity();null!==n;)o.fromArray(n.matrix.elements),o.multiply(s),a=o,o=s,s=a,n=n.parent;a=o;var c=a.elements[12],u=a.elements[13],l=a.elements[14];a.elements[12]=a.elements[13]=a.elements[14]=0,t.context.listener.setPosition(c,u,l),r.set(0,0,1),r.applyProjection(s),r.normalize(),i.set(0,-1,0),i.applyProjection(s),i.normalize(),t.context.listener.setOrientation(r.x,r.y,r.z,i.x,i.y,i.z),s.elements[12]=c,s.elements[13]=u,s.elements[14]=l},this.isAvailable=!0,this.start()}catch(e){console.error(e),console.error("AudioContext not available."),this.isAvailable=!1,this.setPlayer=function(){},this.setVelocity=function(){},this.start=function(){},this.stop=function(){},this.error=e}}return t(n,[{key:"start",value:function(){this.mainVolume.connect(this.context.destination)}},{key:"stop",value:function(){this.mainVolume.disconnect()}},{key:"loadURL",value:function(e){var t=this;return Primrose.HTTP.getBuffer(e).then(function(e){return new Promise(function(n,r){return t.context.decodeAudioData(e,n,r)})})}},{key:"loadURLCascadeSrcList",value:function(e,t){var n=this;return t=t||0,t>=e.length?Promise.reject("Failed to load a file from "+e.length+" files."):this.loadURL(e[t]).catch(function(r){return console.error(r),n.loadURLCascadeSrcList(e,t+1)})}},{key:"createRawSound",value:function(e){if(1!==e.length&&2!==e.length)throw new Error("Incorrect number of channels. Expected 1 or 2, got "+e.length);var t=e[0].length;if(e.length>1&&e[1].length!==t)throw new Error("Second channel is not the same length as the first channel. Expected "+t+", but was "+e[1].length);for(var n=this.context.createBuffer(e.length,t,this.sampleRate),r=0;r<e.length;++r)for(var i=n.getChannelData(r),o=0;o<t;++o)i[o]=e[r][o];return n}},{key:"createSound",value:function(e,t){var n={volume:this.context.createGain(),source:this.context.createBufferSource()};return n.source.buffer=t,n.source.loop=e,n.source.connect(n.volume),n}},{key:"create3DMediaStream",value:function(e,t,n,r){console.log(r);var i=document.createElement("audio"),o={audio:i,source:this.context.createMediaElementSource(i)};return isChrome?i.src=URL.createObjectURL(r):i.srcObject=r,i.autoplay=!0,i.controls=!0,i.muted=!0,o.source.connect(this.mainVolume),o}},{key:"create3DSound",value:function(e,t,n,r){return r.panner=this.context.createPanner(),r.panner.setPosition(e,t,n),r.panner.connect(this.mainVolume),r.volume.connect(r.panner),r}},{key:"createFixedSound",value:function(e){return e.volume.connect(this.mainVolume),e}},{key:"loadSource",value:function(e,t){var n=this;return pliny.method({parent:"Primrose.Output.Audio3D",name:"loadSound",returns:"Promise<MediaElementAudioSourceNode>",parameters:[{name:"sources",type:"String|Array<String>",description:"A string URI to an audio source, or an array of string URIs to audio sources. Will be used as a collection of HTML5 &lt;source> tags as children of an HTML5 &lt;audio> tag."},{name:"loop",type:"Boolean",optional:!0,description:"indicate that the sound should be played on loop."}],description:"Loads the first element of the `sources` array for which the browser supports the file format as an HTML5 &lt;audio> tag to use as an `AudioSourceNode` attached to the current `AudioContext`. This does not load all of the audio files. It only loads the first one of a list of options that could work, because all browsers do not support the same audio formats.",examples:[{name:"Load a single audio file.",description:'There is no one, good, compressed audio format supported in all browsers, but they do all support uncompressed WAV. You shouldn\'t use this on the Internet, but it might be okay for a local solution.\n\n  grammar("JavaScript");\n  var audio = new Primrose.Output.Audio3D();\n  audio.loadSource("mySong.wav").then(function(node){\n    node.connect(audio.context.destination);\n  });'},{name:"Load a single audio file from a list of options.",description:'There is no one, good, compressed audio format supported in all browsers. As a hack around the problem, HTML5 media tags may include one or more &lt;source> tags as children to specify a cascading list of media sources. The browser will select the first one that it can successfully decode.\n\n  grammar("JavaScript");\n  var audio = new Primrose.Output.Audio3D();\n  audio.loadSource([\n    "mySong.mp3",\n    "mySong.aac",\n    "mySong.ogg"\n  ]).then(function(node){\n    node.connect(audio.context.destination);\n  });'},{name:"Load an ambient audio file that should be looped.",description:'The only audio option that is available is whether or not the audio file should be looped. You specify this with the second parameter to the `loadSource()` method, a `Boolean` value to indicate that looping is desired.\n\n  grammar("JavaScript");\n  var audio = new Primrose.Output.Audio3D();\n  audio.loadSource([\n    "mySong.mp3",\n    "mySong.aac",\n    "mySong.ogg"\n  ], true).then(function(node){\n    node.connect(audio.context.destination);\n  });'}]}),new Promise(function(r,i){e instanceof Array||(e=[e]);var o=document.createElement("audio");o.autoplay=!0,o.loop=t,e.map(function(e){var t=document.createElement("source");return t.src=e,t}).forEach(o.appendChild.bind(o)),o.oncanplay=function(){var e=null;n.context&&(o.oncanplay=null,e={volume:n.context.createGain(),source:n.context.createMediaElementSource(o)},e.source.connect(e.volume)),r(e)},o.onerror=i,document.body.appendChild(o)})}},{key:"load3DSound",value:function(e,t,n,r,i){return this.loadSource(e,t).then(this.create3DSound.bind(this,n,r,i))}},{key:"loadFixedSound",value:function(e,t){return this.loadSource(e,t).then(this.createFixedSound.bind(this))}},{key:"playBufferImmediate",value:function(e,t){var n=this,r=this.createSound(!1,e);return r=this.createFixedSound(r),r.volume.gain.value=t,r.source.addEventListener("ended",function(e){r.volume.disconnect(n.mainVolume)}),r.source.start(0),r}}],[{key:"setAudioStream",value:function(e){var t=document.querySelectorAll("audio").length,n=Primrose.DOM.cascadeElement("audioStream"+t,"audio",HTMLAudioElement,!0);return n.autoplay=!0,isFirefox?n.srcObject=e:n.src=URL.createObjectURL(e),n.setAttribute("muted",""),e}}]),n}();"undefined"!=typeof window&&(window.Primrose.Output.Audio3D=n)}(),function(){"use strict";function e(t){function n(e){if(e.valid){r=e.hands.length>0;for(var n=0;n<t.hands&&n<e.hands.length;++n)for(var i=e.hands[n],o=0;o<t.fingers;++o)for(var a=i.fingers[o],c=0;c<t.joints;++c){var u=n*t.fingers*t.joints+o*t.joints+c;if(u<this.tips.length){var l=a[s[c]],h=this.tips[u];h.position.set(l[0],l[1],l[2])}}}}t.port=t.port||e.DEFAULT_PORT,t.addr=t.addr||e.DEFAULT_HOST,this.tips=[],this.numJoints=t.hands*t.fingers*t.joints;var r=!1,i=!1;Leap.loop(),this.setEnvironment=function(e){t.world=e.world,t.scene=e.scene,t.camera=e.camera,Leap.loopController.on("frame",n.bind(this))};var o,s=["tipPosition","dipPosition","pipPosition","mcpPosition","carpPosition"],a=0;80!==t.port&&(t.addr+=":"+t.port),o=io.connect(t.addr,{reconnect:!0,"reconnection delay":1e3,"max reconnection attempts":5}),o.on("connect",function(){i=!0,console.log("Connected!")}),o.on("disconnect",function(){i=!1,console.log("Disconnected!")}),this.readContacts=function(e){for(var n=0,i=0;r&&n<2&&i<e.length;++i)for(var o=e[i],s=0;s<t.hands&&n<2;++s)for(var a=0;a<t.fingers;++a){var c=this.tips[a],u=!1;o.bi===c&&o.bj.graphics&&o.bj.graphics.isSolid&&(this.setFingerState(a,!0),u=!0,++n),u||this.setFingerState(a,!1)}},this.setFingerState=function(e,t){var n=1<<e;t?a|=n:a=a&~n&31,i&&o.emit("data",a)}}pliny.class({parent:"Primrose.Output",name:"HapticGlove",description:"| [under construction]"}),e.DEFAULT_PORT=8383,e.DEFAULT_HOST=document.location.hostname,"undefined"!=typeof window&&(window.Primrose.Output.HapticGlove=e)}(),function(){"use strict";function e(e){return 440*Math.pow(n,e-49)}function t(e,t,n){if(this.audio=e||new AudioContext,this.audio&&this.audio.createGain){void 0===n&&(n=r),void 0===t&&(t="sawtooth"),this.available=!0,this.mainVolume=this.audio.createGain(),this.mainVolume.connect(this.audio.destination),this.numNotes=n,this.oscillators=[];for(var i=0;i<this.numNotes;++i){var o=this.audio.createOscillator(),s=this.audio.createGain();o.type=t,o.frequency.value=0,o.connect(s),o.start(),s.connect(this.mainVolume),this.oscillators.push({osc:o,gn:s,timeout:null})}}else this.available=!1}Window.prototype.AudioContext=Window.prototype.AudioContext||Window.prototype.webkitAudioContext||function(){};var n=Math.pow(2,1/12),r=(navigator.maxTouchPoints||10)+1;pliny.class({parent:"Primrose.Output",name:"Music",description:"| [under construction]"}),t.prototype.noteOn=function(t,n,r){if(this.available){void 0===r&&(r=0);var i=this.oscillators[r%this.numNotes],o=e(parseFloat(n)+1);return i.gn.gain.value=t,i.osc.frequency.setValueAtTime(o,0),i}},t.prototype.noteOff=function(e){if(this.available){void 0===e&&(e=0);var t=this.oscillators[e%this.numNotes];t.osc.frequency.setValueAtTime(0,0)}},t.prototype.play=function(e,t,n,r){if(this.available){"number"!=typeof r&&(r=0);var i=this.noteOn(t,e,r);i.timeout&&(clearTimeout(i.timeout),i.timeout=null),i.timeout=setTimeout(function(e,t){this.noteOff(e),t.timeout=null}.bind(this,r,i),1e3*n)}},"undefined"!=typeof window&&(window.Primrose.Output.Music=t)}(),function(){"use strict";function e(e,t,n,r){return void 0===e[t]?e[t]=n+(r-n)*Math.random():e[t]=Math.min(r,Math.max(n,e[t])),e[t]}var t=null;try{pliny.class({parent:"Primrose.Output",name:"Speech",description:"| [under construction]"}),t=function(t){t=t||{};var n=speechSynthesis.getVoices().filter(function(e){return e.default||e.localService}.bind(this)),r=n[Math.floor(e(t,"voice",0,n.length))];this.speak=function(n,i){var o=new SpeechSynthesisUtterance;o.voice=r,o.volume=e(t,"volume",1,1),o.rate=e(t,"rate",.1,5),o.pitch=e(t,"pitch",0,2),o.text=n,o.onend=i,speechSynthesis.speak(o)}}}catch(e){console.error(e),pliny.class({parent:"Primrose.Output",name:"Speech",description:"| [under construction]"}),t=function(){this.speak=function(){}}}"undefined"!=typeof window&&(window.Primrose.Output.Speech=t)}(),function(){"use strict";function e(){var e=Primrose.Random.int(0,256),t=Primrose.Random.int(0,256),n=Primrose.Random.int(0,256);return e<<16|t<<8|n}pliny.function({parent:"Primrose.Random",name:"color",description:"Returns a random hex RGB number to be used as a color.",returns:"Number",examples:[{name:"Generate a random color.",description:'To generate colors at random, call the `Primrose.Random.color()` function:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.color().toString(16));\n  }\n\n## Result (note that this is just one possible outcome):\n> 351233\n> 3e8e9\n> 8a85a6\n> 5fad58\n> 17fe2b\n> d4b42b\n> e986bf\n> 38541a\n> 5a19db\n> 5f5c50'}]}),"undefined"!=typeof window&&(window.Primrose.Random.color=e)}(),function(){"use strict";function e(){return(Math.random()*Math.log(Number.MAX_VALUE)).toString(36).replace(".","")}pliny.function({parent:"Primrose.Random",name:"ID",description:"Returns a randomized string to be used as a general purpose identifier. Collisions are possible, but should be rare.",returns:"String",examples:[{name:"Generate 10 random identifiers.",description:'To generate a randomized identifier, call the `Primrose.Random.ID()` function as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.ID());\n  }\n\n## Result (note that this is just one possible outcome):\n> 25xzdqnhg1ma2qsb3k1n61or\n> 1hyajmimpyjb4chvge5ng66r\n> cq3dy9qnkwhneza3vr3haor\n> g3l5k2kfwmxjrxjwg0uj714i\n> 7qsta7cutxke8t88pahy3nmi\n> h75g0nj0d4gh7zsyowxko6r\n> 7pbej49fhhd5icimp3krzfr\n> 3vnlovkkvyvmetsjcyirizfr\n> icrehedvz97dpgkusfumzpvi\n> 9p06sytn6dfearuibsnn4s4i'}]}),"undefined"!=typeof window&&(window.Primrose.Random.ID=e)}(),function(){"use strict";function e(e,t,n){n=n||1,void 0===t&&(t=e,e=0);var r=t-e,i=Math.pow(Math.random(),n);return Math.floor(e+i*r)}pliny.function({parent:"Primrose.Random",name:"int",description:"Returns a random integer number on a given range [min, max), i.e. min is inclusive, max is exclusive. Includes a means to skew the results in one direction or another. The number is as good as your JavaScript engine supports with Math.random(), which is not good enough for crypto, but is certainly good enough for games.",parameters:[{name:"min",type:"Number",description:"The included minimum side of the range of numbers."},{name:"max",type:"Number",description:"The excluded maximum side of the range of numbers."},{name:"power",type:"Number",optional:!0,description:"The power to which to raise the random number before scaling and translating into the desired range. Values greater than 1 skew output values to the minimum of the range. Values less than 1 skew output values to the maximum of the range.",default:1}],returns:"Number",examples:[{name:"Generate a random integer numbers on the range [-10, 10).",description:'To generate a random integer on a closed range, call the `Primrose.Random.integer` function as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.int(-10, 10));\n  }\n\n## Result (note that this is just one possible outcome):\n> -3  \n> 1  \n> -2  \n> 8  \n> 7  \n> 4  \n> 5  \n> -9  \n> 4  \n> 0'},{name:"Generate skewed random integer numbers on the range [-100, 100).",description:'To generate a random integer skewed to one end of the range on a closed range, call the `Primrose.Random.integer` function with the `power` parameter as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.int(-100, 100, 5));\n  }\n\n## Result (note that this is just one possible outcome):\n> -100  \n> -100  \n> -78  \n> -81  \n> -99  \n> 18  \n> -100  \n> -100  \n> -100  \n> 52'}]}),"undefined"!=typeof window&&(window.Primrose.Random.int=e)}(),function(){"use strict";function e(e){return e[Primrose.Random.int(e.length)]}pliny.function({parent:"Primrose.Random",name:"item",description:"Returns a random element from an array.",parameters:[{name:"arr",type:"Array",description:"The array form which to pick items."}],returns:"Any",examples:[{name:"Select a random element from an array.",description:'To pick an item from an array at random, call the `Primrose.Random.item` function with the `power` parameter as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  var numbers = [\n    "one",\n    "two",\n    "three",\n    "four",\n    "five"\n  ];\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.item(numbers));\n  }\n\n## Result (note that this is just one possible outcome):\n> three  \n> four  \n> four  \n> two  \n> three  \n> two  \n> five  \n> four  \n> three  \n> two'}]}),"undefined"!=typeof window&&(window.Primrose.Random.item=e)}(),function(){"use strict";function e(e,t){return Math.random()*(t-e)+e}pliny.function({parent:"Primrose.Random",name:"number",description:"Returns a random floating-point number on a given range [min, max), i.e. min is inclusive, max is exclusive. As random as your JavaScript engine supports with Math.random(), which is not good enough for crypto, but is certainly good enough for games.",parameters:[{name:"min",type:"Number",description:"The included minimum side of the range of numbers."},{name:"max",type:"Number",description:"The excluded maximum side of the range of numbers."}],returns:"Number",examples:[{name:"Generate a random number on the range [-1, 1).",description:'To generate a random number on a closed range, call the `Primrose.Random.number` function as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.number(-1, 1));\n  }\n\n## Result (note that this is just one possible outcome):\n> -0.4869012129493058  \n> 0.5300767715089023  \n> 0.11962601682171226  \n> -0.22012147679924965  \n> 0.48508461797609925  \n> -0.8488651723600924  \n> 0.15711558377370238  \n> -0.3644236018881202  \n> 0.4486056035384536  \n> -0.9659552359953523'}]}),"undefined"!=typeof window&&(window.Primrose.Random.number=e)}(),function(){"use strict";function e(e,t,n){return e+Primrose.Random.int(0,(1+t-e)/n)*n}pliny.function({parent:"Primrose.Random",name:"steps",description:"Returns a random integer number on a given range [min, max), i.e. min is inclusive, max is exclusive, sticking to a number of steps in between. Useful for randomly generating music note values on pentatonic scales. As random as your JavaScript engine supports with Math.random(), which is not good enough for crypto, but is certainly good enough for games.",parameters:[{name:"min",type:"Number",description:"The included minimum side of the range of numbers."},{name:"max",type:"Number",description:"The excluded maximum side of the range of numbers."},{name:"steps",type:"Number",description:"The number of steps between individual integers, e.g. if min is even and step is even, then no odd numbers will be generated."}],returns:"Number",examples:[{name:"Generate random, even numbers.",description:'To generate numbers on a closed range with a constant step size between them, call the `Primrose.Random.step` function as shown:\n\n## Code:\n\n  grammar("JavaScript");\n  for(var i = 0; i < 10; ++i){\n    console.log(Primrose.Random.steps(0, 100, 2));\n  }\n\n## Result (note that this is just one possible outcome):\n> 86  \n> 32  \n> 86  \n> 56  \n> 4  \n> 96  \n> 68  \n> 92  \n> 4  \n> 36'}]}),"undefined"!=typeof window&&(window.Primrose.Random.steps=e)}(),function(){"use strict";function e(e,n,r){function i(e,t,n){t.selectedText=e}this.name=e,this.language=n;var o={NORMAL:{65:"a",66:"b",67:"c",68:"d",69:"e",70:"f",71:"g",72:"h",73:"i",74:"j",75:"k",76:"l",77:"m",78:"n",79:"o",80:"p",81:"q",82:"r",83:"s",84:"t",85:"u",86:"v",87:"w",88:"x",89:"y",90:"z"},SHIFT:{65:"A",66:"B",67:"C",68:"D",69:"E",70:"F",71:"G",72:"H",73:"I",74:"J",75:"K",76:"L",77:"M",78:"N",79:"O",80:"P",81:"Q",82:"R",83:"S",84:"T",85:"U",86:"V",87:"W",88:"X",89:"Y",90:"Z"}};copyObject(o,r);for(var s,a,c,u=0;u<=9;++u)a=Primrose.Keys["NUMPAD"+u],o.NORMAL[a]=u.toString();o.NORMAL[Primrose.Keys.MULTIPLY]="*",o.NORMAL[Primrose.Keys.ADD]="+",o.NORMAL[Primrose.Keys.SUBTRACT]="-",o.NORMAL[Primrose.Keys.DECIMALPOINT]=".",o.NORMAL[Primrose.Keys.DIVIDE]="/",this.keyNames={},this.commandNames=[];for(s in Primrose.Keys)a=Primrose.Keys[s],isNaN(a)||(this.keyNames[a]=s);for(var l in o){var h=o[l];if("object"===("undefined"==typeof h?"undefined":t(h)))for(a in h){if(a.indexOf("_")>-1){var d=a.split(" "),p=d[0];a=d[1],s=o.NORMAL[a],c=p+"_"+l+" "+s}else s=o.NORMAL[a],c=l+"_"+s;this.commandNames.push(c),this.keyNames[a]=s;var m=h[a];"function"!=typeof m&&(m=i.bind(null,m)),this[c]=m}}}var t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};pliny.class({parent:"Primrose.Text",name:"CodePage",description:"| [under construction]"}),e.DEAD=function(e){return function(t){t.setDeadKeyState("DEAD"+e)}},"undefined"!=typeof window&&(window.Primrose.Text.CodePage=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"CodePages",description:"The CodePages namespace contains international keyboard parameters."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.CodePages=e)}(),function(){"use strict";function e(e,t){this.name=e,copyObject(this,t)}pliny.class({parent:"Primrose.Text",name:"CommandPack",description:"| [under construction]"}),"undefined"!=typeof window&&(window.Primrose.Text.CommandPack=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"CommandPacks",description:"The CommandPacks namespace contains sets of keyboard shortcuts for different types of text-oriented controls."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.CommandPacks=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"Controls",description:"The Controls namespace contains different types of text-oriented controls."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.Controls=e)}(),function(){"use strict";function e(e,t,n){this.i=e||0,this.x=t||0,this.y=n||0,this.moved=!0}var t=function(){function e(r){r=r.replace(t,function(t,n,r){return e(r)+n}).replace(n,"$2$1");for(var i="",o=r.length-1;o>=0;--o)i+=r[o];return i}var t=/(<%= allExceptCombiningMarks %>)(<%= combiningMarks %>+)/g,n=/(<%= highSurrogates %>)(<%= lowSurrogates %>)/g;return e}();pliny.class({parent:"Primrose.Text",name:"Cursor",description:"| [under construction]"}),e.min=function(e,t){return e.i<=t.i?e:t},e.max=function(e,t){return e.i>t.i?e:t},e.prototype.clone=function(){return new e(this.i,this.x,this.y)},e.prototype.toString=function(){return"[i:"+this.i+" x:"+this.x+" y:"+this.y+"]"},e.prototype.copy=function(e){this.i=e.i,this.x=e.x,this.y=e.y,this.moved=!1},e.prototype.fullhome=function(){this.i=0,this.x=0,this.y=0,this.moved=!0},e.prototype.fullend=function(e){this.i=0;for(var t=0,n=0;n<e.length;++n){var r=e[n];t=r.length,this.i+=t}this.y=e.length-1,this.x=t,this.moved=!0},e.prototype.skipleft=function(e){if(0===this.x)this.left(e);else{var n=this.x-1,r=e[this.y],i=t(r.substring(0,n)),o=i.match(/(\s|\W)+/),s=o?o.index+o[0].length+1:i.length;this.i-=s,this.x-=s}this.moved=!0},e.prototype.left=function(e){if(this.i>0){if(--this.i,--this.x,this.x<0){--this.y;var t=e[this.y];this.x=t.length}this.reverseFromNewline(e)&&++this.i}this.moved=!0},e.prototype.skipright=function(e){var t=e[this.y];if(this.x===t.length||"\n"===t[this.x])this.right(e);else{var n=this.x+1;t=t.substring(n);var r=t.match(/(\s|\W)+/),i=r?r.index+r[0].length+1:t.length-this.x;this.i+=i,this.x+=i,this.reverseFromNewline(e)}this.moved=!0},e.prototype.fixCursor=function(e){this.x=this.i,this.y=0;for(var t=0,n=e[this.y];this.x>n.length;){if(this.x-=n.length,t+=n.length,this.y>=e.length-1){this.i=t,this.x=n.length,this.moved=!0;break}++this.y,n=e[this.y]}return this.moved},e.prototype.right=function(e){this.advanceN(e,1)},e.prototype.advanceN=function(e,t){var n=e[this.y];(this.y<e.length-1||this.x<n.length)&&(this.i+=t,this.fixCursor(e),n=e[this.y],this.x>0&&"\n"===n[this.x-1]&&(++this.y,this.x=0)),this.moved=!0},e.prototype.home=function(){this.i-=this.x,this.x=0,this.moved=!0},e.prototype.end=function(e){var t=e[this.y],n=t.length-this.x;this.i+=n,this.x+=n,this.reverseFromNewline(e),this.moved=!0},e.prototype.up=function(e){if(this.y>0){--this.y;var t=e[this.y],n=Math.min(0,t.length-this.x);this.x+=n,this.i-=t.length-n,this.reverseFromNewline(e)}this.moved=!0},e.prototype.down=function(e){if(this.y<e.length-1){++this.y;var t=e[this.y],n=e[this.y-1],r=Math.min(0,t.length-this.x);this.x+=r,this.i+=n.length+r,this.reverseFromNewline(e)}this.moved=!0},e.prototype.incY=function(e,t){this.y=Math.max(0,Math.min(t.length-1,this.y+e));var n=t[this.y];this.x=Math.max(0,Math.min(n.length,this.x)),this.i=this.x;for(var r=0;r<this.y;++r)this.i+=t[r].length;this.reverseFromNewline(t),this.moved=!0},e.prototype.setXY=function(e,t,n){this.y=Math.max(0,Math.min(n.length-1,t));var r=n[this.y];this.x=Math.max(0,Math.min(r.length,e)),this.i=this.x;for(var i=0;i<this.y;++i)this.i+=n[i].length;this.reverseFromNewline(n),this.moved=!0},e.prototype.setI=function(e,t){this.i=e,this.fixCursor(t),this.moved=!0},e.prototype.reverseFromNewline=function(e){var t=e[this.y];return this.x>0&&"\n"===t[this.x-1]&&(--this.x,--this.i,!0)},"undefined"!=typeof window&&(window.Primrose.Text.Cursor=e)}(),function(){"use strict";function e(t,n){function r(e){var t,n,r=null,i=null,o=0;for(t=0;t<e.length;++t)n=e[t],n.line=o,"newlines"===n.type&&++o,i?("stringDelim"!==n.type||n.value!==i||0!==t&&"\\"===e[t-1].value[e[t-1].value.length-1]||(i=null),"newlines"!==n.type&&(n.type="strings")):r?(("startBlockComments"===r&&"endBlockComments"===n.type||"startLineComments"===r&&"newlines"===n.type)&&(r=null),"newlines"!==n.type&&(n.type="comments")):"stringDelim"===n.type?(i=n.value,n.type="strings"):"startBlockComments"!==n.type&&"startLineComments"!==n.type||(r=n.type,n.type="comments");for(t=e.length-1;t>0;--t){var s=e[t-1];n=e[t],s.type===n.type&&"newlines"!==s.type&&(s.value+=n.value,e.splice(t,1))}}pliny.property({parent:"Primrose.Text.Grammar",name:" name",type:"String",description:"A user-friendly name for the grammar, to be able to include it in an options listing."}),this.name=t,pliny.property({parent:"Primrose.Text.Grammar",name:"grammar",type:"Array",description:"A collection of rules to apply to tokenize text. The rules should be an array of two-element arrays. The first element should be a token name (see [`Primrose.Text.Rule`](#Primrose_Text_Rule) for a list of valid token names), followed by a regular expression that selects the token out of the source code."}),this.grammar=n.map(function(e){return new Primrose.Text.Rule(e[0],e[1])}),e.prototype.toHTML=function(e,t){t=t||Primrose.Text.Themes.Default;for(var n=this.tokenize(e),r=document.createElement("div"),i=0;i<n.length;++i){var o=n[i];if("newlines"===o.type)r.appendChild(document.createElement("br"));else{var s=t[o.type]||{},a=document.createElement("span");a.style.fontWeight=s.fontWeight||t.regular.fontWeight,a.style.fontStyle=s.fontStyle||t.regular.fontStyle||"",a.style.color=s.foreColor||t.regular.foreColor,a.style.backgroundColor=s.backColor||t.regular.backColor,a.style.fontFamily=s.fontFamily||t.fontFamily,a.appendChild(document.createTextNode(o.value)),r.appendChild(a)}}return r.innerHTML},pliny.method({parent:"Primrose.Text.Grammar",name:"tokenize",parameters:[{name:"text",type:"String",description:"The text to tokenize."}],returns:"An array of tokens, ammounting to drawing instructions to the renderer. However, they still need to be layed out to fit the bounds of the text area.",description:"Breaks plain text up into a list of tokens that can later be rendered with color.",examples:[{name:"Tokenize some JavaScript",description:'Primrose comes with a grammar for JavaScript built in.\n\n## Code:\n\n  grammar("JavaScript");\n  var tokens = new Primrose.Text.Grammars.JavaScript\n    .tokenize("var x = 3;\\n\\\n  var y = 2;\\n\\\n  console.log(x + y);");\n  console.log(JSON.stringify(tokens));\n\n## Result:\n\n  grammar("JavaScript");\n  [ \n    { "value": "var", "type": "keywords", "index": 0, "line": 0 },\n    { "value": " x = ", "type": "regular", "index": 3, "line": 0 },\n    { "value": "3", "type": "numbers", "index": 8, "line": 0 },\n    { "value": ";", "type": "regular", "index": 9, "line": 0 },\n    { "value": "\\n", "type": "newlines", "index": 10, "line": 0 },\n    { "value": " y = ", "type": "regular", "index": 11, "line": 1 },\n    { "value": "2", "type": "numbers", "index": 16, "line": 1 },\n    { "value": ";", "type": "regular", "index": 17, "line": 1 },\n    { "value": "\\n", "type": "newlines", "index": 18, "line": 1 },\n    { "value": "console", "type": "members", "index": 19, "line": 2 },\n    { "value": ".", "type": "regular", "index": 26, "line": 2 },\n    { "value": "log", "type": "functions", "index": 27, "line": 2 },\n    { "value": "(x + y);", "type": "regular", "index": 30, "line": 2 }\n  ]'}]}),this.tokenize=function(e){for(var t=[new Primrose.Text.Token(e,"regular",0)],n=0;n<this.grammar.length;++n)for(var i=this.grammar[n],o=0;o<t.length;++o)i.carveOutMatchedToken(t,o);return r(t),t}}pliny.class({parent:"Primrose.Text",name:"Grammar",parameters:[{name:"name",type:"String",description:"A user-friendly name for the grammar, to be able to include it in an options listing."
},{name:"rules",type:"Array",description:"A collection of rules to apply to tokenize text. The rules should be an array of two-element arrays. The first element should be a token name (see [`Primrose.Text.Rule`](#Primrose_Text_Rule) for a list of valid token names), followed by a regular expression that selects the token out of the source code."}],description:"A Grammar is a collection of rules for processing text into tokens. Tokens are special characters that tell us about the structure of the text, things like keywords, curly braces, numbers, etc. After the text is tokenized, the tokens get a rough processing pass that groups them into larger elements that can be rendered in color on the screen.\n\nAs tokens are discovered, they are removed from the text being processed, so order is important. Grammar rules are applied in the order they are specified, and more than one rule can produce the same token type.\n\nSee [`Primrose.Text.Rule`](#Primrose_Text_Rule) for a list of valid token names.",examples:[{name:'A plain-text "grammar".',description:'Plain text does not actually have a grammar that needs to be processed. However, to get the text to work with the rendering system, a basic grammar is necessary to be able to break the text up into lines and prepare it for rendering.\n\n## Code:\n\n  grammar("JavaScript");\n  var plainTextGrammar = new Primrose.Text.Grammar(\n    // The name is for displaying in options views.\n    "Plain-text", [\n    // Text needs at least the newlines token, or else every line will attempt to render as a single line and the line count won\'t work.\n    ["newlines", /(?:\\r\\n|\\r|\\n)/] \n  ] );'},{name:"A grammar for BASIC",description:'The BASIC programming language is now defunct, but a grammar for it to display in Primrose is quite easy to build.\n\n## Code:\n\n  grammar("JavaScript");\n  var basicGrammar = new Primrose.Text.Grammar( "BASIC",\n    // Grammar rules are applied in the order they are specified.\n    [\n      // Text needs at least the newlines token, or else every line will attempt to render as a single line and the line count won\'t work.\n      [ "newlines", /(?:\\r\\n|\\r|\\n)/ ],\n      // BASIC programs used to require the programmer type in her own line numbers. The start at the beginning of the line.\n      [ "lineNumbers", /^\\d+\\s+/ ],\n      // Comments were lines that started with the keyword "REM" (for REMARK) and ran to the end of the line. They did not have to be numbered, because they were not executable and were stripped out by the interpreter.\n      [ "startLineComments", /^REM\\s/ ],\n      // Both double-quoted and single-quoted strings were not always supported, but in this case, I\'m just demonstrating how it would be done for both.\n      [ "strings", /"(?:\\\\"|[^"])*"/ ],\n      [ "strings", /\'(?:\\\\\'|[^\'])*\'/ ],\n      // Numbers are an optional dash, followed by a optional digits, followed by optional period, followed by 1 or more required digits. This allows us to match both integers and decimal numbers, both positive and negative, with or without leading zeroes for decimal numbers between (-1, 1).\n      [ "numbers", /-?(?:(?:\\b\\d*)?\\.)?\\b\\d+\\b/ ],\n      // Keywords are really just a list of different words we want to match, surrounded by the "word boundary" selector "\\b".\n      [ "keywords",\n        /\\b(?:RESTORE|REPEAT|RETURN|LOAD|LABEL|DATA|READ|THEN|ELSE|FOR|DIM|LET|IF|TO|STEP|NEXT|WHILE|WEND|UNTIL|GOTO|GOSUB|ON|TAB|AT|END|STOP|PRINT|INPUT|RND|INT|CLS|CLK|LEN)\\b/\n      ],\n      // Sometimes things we want to treat as keywords have different meanings in different locations. We can specify rules for tokens more than once.\n      [ "keywords", /^DEF FN/ ],\n      // These are all treated as mathematical operations.\n      [ "operators",\n        /(?:\\+|;|,|-|\\*\\*|\\*|\\/|>=|<=|=|<>|<|>|OR|AND|NOT|MOD|\\(|\\)|\\[|\\])/\n      ],\n      // Once everything else has been matched, the left over blocks of words are treated as variable and function names.\n      [ "identifiers", /\\w+\\$?/ ]\n    ] );'}]}),"undefined"!=typeof window&&(window.Primrose.Text.Grammar=e)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"Grammars",description:"The Grammars namespace contains grammar parsers for different types of programming languages, to enable syntax highlighting."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.Grammars=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Text",name:"OperatingSystem",description:"| [under construction]"});var n=function(){function n(t,r,i,o,s,a,c,u,l,h){e(this,n);var d=s;s=s.length>0?s:"NORMAL",this[r+"_a"]="SELECT_ALL",this[r+"_c"]="COPY",this[r+"_x"]="CUT",this[r+"_v"]="PASTE",this[o]="REDO",this[r+"_z"]="UNDO",this[r+"_DOWNARROW"]="WINDOW_SCROLL_DOWN",this[r+"_UPARROW"]="WINDOW_SCROLL_UP",this[i+"_LEFTARROW"]="NORMAL_SKIPLEFT",this[i+"SHIFT_LEFTARROW"]="SHIFT_SKIPLEFT",this[i+"_RIGHTARROW"]="NORMAL_SKIPRIGHT",this[i+"SHIFT_RIGHTARROW"]="SHIFT_SKIPRIGHT",this[s+"_HOME"]="NORMAL_HOME",this[d+"SHIFT_HOME"]="SHIFT_HOME",this[s+"_END"]="NORMAL_END",this[d+"SHIFT_END"]="SHIFT_END",this[u+"_HOME"]="CTRL_HOME",this[u+"SHIFT_HOME"]="CTRLSHIFT_HOME",this[u+"_END"]="CTRL_END",this[u+"SHIFT_END"]="CTRLSHIFT_END",this._deadKeyState=""}return t(n,[{key:"makeCommandName",value:function(e,t){var n=e.keyCode;if(n!==Primrose.Keys.CTRL&&n!==Primrose.Keys.ALT&&n!==Primrose.Keys.META_L&&n!==Primrose.Keys.META_R&&n!==Primrose.Keys.SHIFT){var r=(this._deadKeyState,this._deadKeyState);return e.ctrlKey&&(r+="CTRL"),e.altKey&&(r+="ALT"),e.metaKey&&(r+="META"),e.shiftKey&&(r+="SHIFT"),r===this._deadKeyState&&(r+="NORMAL"),r+="_"+t.keyNames[n],this[r]||r}}}]),n}();"undefined"!=typeof window&&(window.Primrose.Text.OperatingSystem=n)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"OperatingSystems",description:"The OperatingSystems namespace contains sets of keyboard shortcuts for different operating systems."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.OperatingSystems=e)}(),function(){"use strict";function e(e,t){this.set(e||0,t||0)}pliny.class({parent:"Primrose.Text",name:"Point",description:"| [under construction]"}),e.prototype.set=function(e,t){this.x=e,this.y=t},e.prototype.copy=function(e){e&&(this.x=e.x,this.y=e.y)},e.prototype.clone=function(){return new e(this.x,this.y)},e.prototype.toString=function(){return"(x:"+this.x+", y:"+this.y+")"},"undefined"!=typeof window&&(window.Primrose.Text.Point=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}();pliny.class({parent:"Primrose.Text",name:"Rectangle",description:"| [under construction]"});var n=function(){function n(t,r,i,o){e(this,n),this.point=new Primrose.Text.Point(t,r),this.size=new Primrose.Text.Size(i,o)}return t(n,[{key:"set",value:function(e,t,n,r){this.point.set(e,t),this.size.set(n,r)}},{key:"copy",value:function(e){e&&(this.point.copy(e.point),this.size.copy(e.size))}},{key:"clone",value:function(){return new n(this.point.x,this.point.y,this.size.width,this.size.height)}},{key:"toString",value:function(){return"["+this.point.toString()+" x "+this.size.toString()+"]"}},{key:"overlap",value:function(e){var t=Math.max(this.left,e.left),r=Math.max(this.top,e.top),i=Math.min(this.right,e.right),o=Math.min(this.bottom,e.bottom);if(i>t&&o>r)return new n(t,r,i-t,o-r)}},{key:"x",get:function(){return this.point.x},set:function(e){this.point.x=e}},{key:"left",get:function(){return this.point.x},set:function(e){this.point.x=e}},{key:"width",get:function(){return this.size.width},set:function(e){this.size.width=e}},{key:"right",get:function(){return this.point.x+this.size.width},set:function(e){this.point.x=e-this.size.width}},{key:"y",get:function(){return this.point.y},set:function(e){this.point.y=e}},{key:"top",get:function(){return this.point.y},set:function(e){this.point.y=e}},{key:"height",get:function(){return this.size.height},set:function(e){this.size.height=e}},{key:"bottom",get:function(){return this.point.y+this.size.height},set:function(e){this.point.y=e-this.size.height}},{key:"area",get:function(){return this.width*this.height}}]),n}();"undefined"!=typeof window&&(window.Primrose.Text.Rectangle=n)}(),function(){"use strict";function e(e,t){this.name=e,this.test=t}pliny.class({parent:"Primrose.Text",name:"Rule",description:"| [under construction]"}),e.prototype.carveOutMatchedToken=function(e,t){var n=e[t];if("regular"===n.type){var r=this.test.exec(n.value);if(r){var i=r[r.length-1],o=r.input.indexOf(i),s=o+i.length;if(0===o){if(n.type=this.name,s<n.value.length){var a=n.splitAt(s);a.type="regular",e.splice(t+1,0,a)}}else{var c=n.splitAt(o);if(i.length<c.value.length){var u=c.splitAt(i.length);e.splice(t+1,0,u)}c.type=this.name,e.splice(t+1,0,c)}}}},"undefined"!=typeof window&&(window.Primrose.Text.Rule=e)}(),function(){"use strict";function e(e,t){this.set(e||0,t||0)}pliny.class({parent:"Primrose.Text",name:"Size",description:"| [under construction]"}),e.prototype.set=function(e,t){this.width=e,this.height=t},e.prototype.copy=function(e){e&&(this.width=e.width,this.height=e.height)},e.prototype.clone=function(){return new e(this.width,this.height)},e.prototype.toString=function(){return"<w:"+this.width+", h:"+this.height+">"},"undefined"!=typeof window&&(window.Primrose.Text.Size=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}pliny.class({parent:"Primrose.Text",name:"Terminal",description:"| [under construction]"});var t=function t(n,r){function i(e){e.selectionStart=e.selectionEnd=e.value.length,e.scrollIntoView(e.frontCursor)}function o(){v.running&&(a(),v.running=!1,g&&(n.tokenizer=d,n.value=h),i(n))}function s(){return r.selectionStart=r.selectionEnd=0,r.value="",!0}function a(){if(y.length>0){for(var e=y.split("\n"),t=0;t<m&&e.length>0;++t)f.push(e.shift());e.length>0&&f.push(" ----- more -----"),y=e.join("\n")}}function c(e){l=e,v.waitingForInput=!0,a()}function u(e){y+=e}e(this,t),r=r||n;var l=null,h=null,d=null,p=0,m=40,f=[],y="",g=n===r,v=this;this.running=!1,this.waitingForInput=!1,this.sendInput=function(e){if(y.length>0)a();else{r.keyDown(e);var t=r.value.substring(p);l(t.trim()),l=null,this.waitingForInput=!1}},this.execute=function(){if(m=10,d=n.tokenizer,d&&d.interpret){this.running=!0;var e,t=function(){v.running&&setTimeout(e,1)};h=n.value,e=d.interpret(h,c,u,u,t,s,this.loadFile.bind(this),o),r.tokenizer=Primrose.Text.Grammars.PlainText,s(),t()}},this.loadFile=function(e){return Primrose.HTTP.getText(e.toLowerCase()).then(function(e){return isOSX&&(e=e.replace("CTRL+SHIFT+SPACE","CMD+OPT+E")),n.value=h=e,e})},this.update=function(){f.length>0&&(r.value+=f.shift()+"\n",i(r),p=r.selectionStart)}};"undefined"!=typeof window&&(window.Primrose.Text.Terminal=t)}(),function(){"use strict";pliny.namespace({parent:"Primrose.Text",name:"Themes",description:"The Themes namespace contains color themes for text-oriented controls, for use when coupled with a parsing grammar."});var e={};"undefined"!=typeof window&&(window.Primrose.Text.Themes=e)}(),function(){"use strict";function e(e,t,n,r){this.value=e,this.type=t,this.index=n,this.line=r}pliny.class({parent:"Primrose.Text",name:"Token",description:"| [under construction]"}),e.prototype.clone=function(){return new e(this.value,this.type,this.index,this.line)},e.prototype.splitAt=function(t){var n=this.value.substring(t);return this.value=this.value.substring(0,t),new e(n,this.type,this.index+t,this.line)},e.prototype.toString=function(){return"["+this.type+": "+this.value+"]"},"undefined"!=typeof window&&(window.Primrose.Text.Token=e)}(),function(){"use strict";var e=Primrose.Text.CodePage;pliny.record({parent:"Primrose.Text.CodePages",name:"DE_QWERTZ",description:"| [under construction]"});var t=new e("Deutsch: QWERTZ","de",{deadKeys:[220,221,160,192],NORMAL:{32:" ",48:"0",49:"1",50:"2",51:"3",52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",60:"<",63:"ß",160:e.DEAD(3),163:"#",171:"+",173:"-",186:"ü",187:"+",188:",",189:"-",190:".",191:"#",192:e.DEAD(4),219:"ß",220:e.DEAD(1),221:e.DEAD(2),222:"ä",226:"<"},DEAD1NORMAL:{65:"â",69:"ê",73:"î",79:"ô",85:"û",190:"."},DEAD2NORMAL:{65:"á",69:"é",73:"í",79:"ó",83:"s",85:"ú",89:"ý"},SHIFT:{32:" ",48:"=",49:"!",50:'"',51:"§",52:"$",53:"%",54:"&",55:"/",56:"(",57:")",60:">",63:"?",163:"'",171:"*",173:"_",186:"Ü",187:"*",188:";",189:"_",190:":",191:"'",192:"Ö",219:"?",222:"Ä",226:">"},CTRLALT:{48:"}",50:"²",51:"³",55:"{",56:"[",57:"]",60:"|",63:"\\",69:"€",77:"µ",81:"@",171:"~",187:"~",219:"\\",226:"|"},CTRLALTSHIFT:{63:"ẞ",219:"ẞ"},DEAD3NORMAL:{65:"a",69:"e",73:"i",79:"o",85:"u",190:"."},DEAD4NORMAL:{65:"a",69:"e",73:"i",79:"o",83:"s",85:"u",89:"y"}});"undefined"!=typeof window&&(window.Primrose.Text.CodePages.DE_QWERTZ=t)}(),function(){"use strict";var e=Primrose.Text.CodePage;pliny.record({parent:"Primrose.Text.CodePages",name:"EN_UKX",description:"| [under construction]"});var t=new e("English: UK Extended","en-GB",{CTRLALT:{52:"€",65:"á",69:"é",73:"í",79:"ó",85:"ú",163:"\\",192:"¦",222:"\\",223:"¦"},CTRLALTSHIFT:{65:"Á",69:"É",73:"Í",79:"Ó",85:"Ú",222:"|"},NORMAL:{32:" ",48:"0",49:"1",50:"2",51:"3",52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",59:";",61:"=",163:"#",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"'",219:"[",220:"\\",221:"]",222:"#",223:"`"},SHIFT:{32:" ",48:")",49:"!",50:'"',51:"£",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",61:"+",163:"~",173:"_",186:":",187:"+",188:"<",189:"_",190:">",191:"?",192:"@",219:"{",220:"|",221:"}",222:"~",223:"¬"}});"undefined"!=typeof window&&(window.Primrose.Text.CodePages.EN_UKX=t)}(),function(){"use strict";var e=Primrose.Text.CodePage;pliny.record({parent:"Primrose.Text.CodePages",name:"EN_US",description:"| [under construction]"});var t=new e("English: USA","en-US",{NORMAL:{32:" ",48:"0",49:"1",50:"2",51:"3",52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",59:";",61:"=",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",219:"[",220:"\\",221:"]",222:"'"},SHIFT:{32:" ",48:")",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",61:"+",173:"_",186:":",187:"+",188:"<",189:"_",190:">",191:"?",219:"{",220:"|",221:"}",222:'"'}});"undefined"!=typeof window&&(window.Primrose.Text.CodePages.EN_US=t)}(),function(){"use strict";var e=Primrose.Text.CodePage;pliny.record({parent:"Primrose.Text.CodePages",name:"FR_AZERTY",description:"| [under construction]"});var t=new e("Français: AZERTY","fr",{deadKeys:[221,50,55],NORMAL:{32:" ",48:"à",49:"&",50:"é",51:'"',52:"'",53:"(",54:"-",55:"è",56:"_",57:"ç",186:"$",187:"=",188:",",190:";",191:":",192:"ù",219:")",220:"*",221:e.DEAD(1),222:"²",223:"!",226:"<"},SHIFT:{32:" ",48:"0",49:"1",50:"2",51:"3",52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",186:"£",187:"+",188:"?",190:".",191:"/",192:"%",219:"°",220:"µ",223:"§",226:">"},CTRLALT:{48:"@",50:e.DEAD(2),51:"#",52:"{",53:"[",54:"|",55:e.DEAD(3),56:"\\",57:"^",69:"€",186:"¤",187:"}",219:"]"},DEAD1NORMAL:{65:"â",69:"ê",73:"î",79:"ô",85:"û"},DEAD2NORMAL:{65:"ã",78:"ñ",79:"õ"},DEAD3NORMAL:{48:"à",50:"é",55:"è",65:"à",69:"è",73:"ì",79:"ò",85:"ù"}});"undefined"!=typeof window&&(window.Primrose.Text.CodePages.FR_AZERTY=t)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}pliny.record({parent:"Primrose.Text.CommandPacks",name:"TextInput",baseClass:"Primrose.Text.CommandPack",description:"| [under construction]"});var r=function(r){function i(n,r){e(this,i);var o={NORMAL_LEFTARROW:function(e,t){e.cursorLeft(t,e.frontCursor)},NORMAL_SKIPLEFT:function(e,t){e.cursorSkipLeft(t,e.frontCursor)},NORMAL_RIGHTARROW:function(e,t){e.cursorRight(t,e.frontCursor)},NORMAL_SKIPRIGHT:function(e,t){e.cursorSkipRight(t,e.frontCursor)},NORMAL_HOME:function(e,t){e.cursorHome(t,e.frontCursor)},NORMAL_END:function(e,t){e.cursorEnd(t,e.frontCursor)},NORMAL_BACKSPACE:function(e,t){e.frontCursor.i===e.backCursor.i&&e.frontCursor.left(t),e.selectedText="",e.scrollIntoView(e.frontCursor)},NORMAL_ENTER:function(e,t,n){emit.call(e,"change",{target:e})},NORMAL_DELETE:function(e,t){e.frontCursor.i===e.backCursor.i&&e.backCursor.right(t),e.selectedText="",e.scrollIntoView(e.frontCursor)},NORMAL_TAB:function(e,t){e.selectedText=e.tabString},SHIFT_LEFTARROW:function(e,t){e.cursorLeft(t,e.backCursor)},SHIFT_SKIPLEFT:function(e,t){e.cursorSkipLeft(t,e.backCursor)},SHIFT_RIGHTARROW:function(e,t){e.cursorRight(t,e.backCursor)},SHIFT_SKIPRIGHT:function(e,t){e.cursorSkipRight(t,e.backCursor)},SHIFT_HOME:function(e,t){e.cursorHome(t,e.backCursor)},SHIFT_END:function(e,t){e.cursorEnd(t,e.backCursor)},SHIFT_DELETE:function(e,t){e.frontCursor.i===e.backCursor.i&&(e.frontCursor.home(t),e.backCursor.end(t)),e.selectedText="",e.scrollIntoView(e.frontCursor)},CTRL_HOME:function(e,t){e.cursorFullHome(t,e.frontCursor)},CTRL_END:function(e,t){e.cursorFullEnd(t,e.frontCursor)},CTRLSHIFT_HOME:function(e,t){e.cursorFullHome(t,e.backCursor)},CTRLSHIFT_END:function(e,t){e.cursorFullEnd(t,e.backCursor)},SELECT_ALL:function(e,t){e.frontCursor.fullhome(t),e.backCursor.fullend(t)},REDO:function(e,t){e.redo(),e.scrollIntoView(e.frontCursor)},UNDO:function(e,t){e.undo(),e.scrollIntoView(e.frontCursor)}};if(r)for(var s in r)o[s]=r[s];return t(this,(i.__proto__||Object.getPrototypeOf(i)).call(this,n||"Text editor commands",o))}return n(i,r),i}(Primrose.Text.CommandPack);"undefined"!=typeof window&&(window.Primrose.Text.CommandPacks.BasicTextInput=r)}(),function(){"use strict";pliny.record({parent:"Primrose.Text.CommandPacks",name:"TextEditor",description:"| [under construction]"});var e=new Primrose.Text.CommandPacks.BasicTextInput("Text Area input commands",{NORMAL_UPARROW:function(e,t){e.cursorUp(t,e.frontCursor)},NORMAL_DOWNARROW:function(e,t){e.cursorDown(t,e.frontCursor)},NORMAL_PAGEUP:function(e,t){e.cursorPageUp(t,e.frontCursor)},NORMAL_PAGEDOWN:function(e,t){e.cursorPageDown(t,e.frontCursor)},NORMAL_ENTER:function(e,t,n){var r="",i=t[e.frontCursor.y];i.length>0&&"whitespace"===i[0].type&&(r=i[0].value),e.selectedText="\n"+r,e.scrollIntoView(e.frontCursor)},SHIFT_UPARROW:function(e,t){e.cursorUp(t,e.backCursor)},SHIFT_DOWNARROW:function(e,t){e.cursorDown(t,e.backCursor)},SHIFT_PAGEUP:function(e,t){e.cursorPageUp(t,e.backCursor)},SHIFT_PAGEDOWN:function(e,t){e.cursorPageDown(t,e.backCursor)},WINDOW_SCROLL_DOWN:function(e,t){e.scroll.y<t.length&&++e.scroll.y},WINDOW_SCROLL_UP:function(e,t){e.scroll.y>0&&--e.scroll.y}});"undefined"!=typeof window&&(window.Primrose.Text.CommandPacks.TextEditor=e)}(),function(){"use strict";pliny.record({parent:"Primrose.Text.CommandPacks",name:"TextInput",description:"| [under construction]"});var e=new Primrose.Text.CommandPacks.BasicTextInput("Text Line input commands");"undefined"!=typeof window&&(window.Primrose.Text.CommandPacks.TextInput=e)}(),function(){"use strict";function e(e,t,n,r,i,o,s,a){e=e.replace(/\r\n/g,"\n");var c=e.split("\n");a=a||"center";var u=1e3*t,l=u*c.length,h=document.createElement("canvas"),d=h.getContext("2d");d.font=u+"px Arial";var p=d.measureText(e).width;h.width=p,h.height=l,d.font=.8*u+"px Arial","transparent"!==r&&(d.fillStyle=r,d.fillRect(0,0,h.width,h.height)),d.fillStyle=n;for(var m=0;m<c.length;++m)d.fillText(c[m],0,m*u);var f=new THREE.Texture(h);f.needsUpdate=!0;var y=new THREE.MeshBasicMaterial({map:f,transparent:"transparent"===r,useScreenCoordinates:!1,color:16777215,shading:THREE.FlatShading}),g=new THREE.PlaneGeometry(t*p/u,t*c.length);g.computeBoundingBox(),g.computeVertexNormals();var v=new THREE.Mesh(g,y);return"left"===a?i-=g.boundingBox.min.x:"right"===a&&(i+=g.boundingBox.min.x),v.position.set(i,o,s),v}pliny.class({parent:"Primrose.Text.Controls",name:"PlainText",description:"| [under construction]"}),"undefined"!=typeof window&&(window.Primrose.Text.Controls.PlainText=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=isFirefox?3:100,s=0,a=5;pliny.class({parent:"Primrose.Text.Controls",name:"TextBox",description:"Syntax highlighting textbox control.",baseClass:"Primrose.Surface",parameters:[{name:"idOrCanvasOrContext",type:"String or HTMLCanvasElement or CanvasRenderingContext2D",description:"Either an ID of an element that exists, an element, or the ID to set on an element that is to be created."},{name:"options",type:"Object",description:"Named parameters for creating the TextBox."}]});var c=function(c){function u(n){e(this,u);var r=t(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,patch(n,{id:"Primrose.Text.Controls.TextBox["+s++ +"]"})));r.listeners.change=[],"string"==typeof n?r.options={value:r.options}:r.options=n||{},r.useCaching=!isFirefox||!isMobile;var i=function(e){var t=e.toLowerCase();this["cursor"+e]=function(e,n){n[t](e),this.scrollIntoView(n)}};["Left","Right","SkipLeft","SkipRight","Up","Down","Home","End","FullHome","FullEnd"].map(i.bind(r)),r.tokens=null,r.lines=null,r._commandPack=null,r._tokenRows=null,r._tokenHashes=null,r._tabString=null,r._currentTouchID=null,r._lineCountWidth=null,r._lastFont=null,r._lastText=null,r._lastCharacterWidth=null,r._lastCharacterHeight=null,r._lastGridBounds=null,r._lastPadding=null,r._lastFrontCursor=null,r._lastBackCursor=null,r._lastWidth=-1,r._lastHeight=-1,r._lastScrollX=-1,r._lastScrollY=-1,r._lastFocused=!1,r._lastThemeName=null,r._lastPointer=new Primrose.Text.Point,r._browser=isChrome?"CHROMIUM":isFirefox?"FIREFOX":isIE?"IE":isOpera?"OPERA":isSafari?"SAFARI":"UNKNOWN",r._pointer=new Primrose.Text.Point,r._deadKeyState="",r._history=[],r._historyFrame=-1,r._topLeftGutter=new Primrose.Text.Size,r._bottomRightGutter=new Primrose.Text.Size,r._dragging=!1,r._scrolling=!1,r._wheelScrollSpeed=4;var o=new Primrose.Text.Rectangle(0,0,r.bounds.width,r.bounds.height);return r._fg=new Primrose.Surface({id:r.id+"-fore",bounds:o}),r._fgCanvas=r._fg.canvas,r._fgfx=r._fg.context,r._bg=new Primrose.Surface({id:r.id+"-back",bounds:o}),r._bgCanvas=r._bg.canvas,r._bgfx=r._bg.context,r._trim=new Primrose.Surface({id:r.id+"-trim",bounds:o}),r._trimCanvas=r._trim.canvas,r._tgfx=r._trim.context,r._rowCache={},r._VSCROLL_WIDTH=2,r.tabWidth=r.options.tabWidth,r.showLineNumbers=!r.options.hideLineNumbers,r.showScrollBars=!r.options.hideScrollBars,r.wordWrap=!r.options.disableWordWrap,r.readOnly=!!r.options.readOnly,r.multiline=!r.options.singleLine,r.gridBounds=new Primrose.Text.Rectangle,r.frontCursor=new Primrose.Text.Cursor,r.backCursor=new Primrose.Text.Cursor,r.scroll=new Primrose.Text.Point,r.character=new Primrose.Text.Size,r.theme=r.options.theme,r.fontSize=r.options.fontSize,r.tokenizer=r.options.tokenizer,r.commandPack=r.options.commands||Primrose.Text.CommandPacks.TextEditor,r.value=r.options.value,r.padding=r.options.padding||1,r.addEventListener("focus",r.render.bind(r),!1),r.addEventListener("blur",r.render.bind(r),!1),r}return n(u,c),i(u,null,[{key:"create",value:function(){return new u}}]),i(u,[{key:"cursorPageUp",value:function(e,t){t.incY(-this.gridBounds.height,e),this.scrollIntoView(t)}},{key:"cursorPageDown",value:function(e,t){t.incY(this.gridBounds.height,e),this.scrollIntoView(t)}},{key:"setDeadKeyState",value:function(e){this._deadKeyState=e||""}},{key:"pushUndo",value:function(e){this._historyFrame<this._history.length-1&&this._history.splice(this._historyFrame+1),this._history.push(e),this._historyFrame=this._history.length-1,this.refreshTokens(),this.render()}},{key:"redo",value:function(){this._historyFrame<this._history.length-1&&++this._historyFrame,this.refreshTokens(),this.fixCursor(),this.render()}},{key:"undo",value:function(){this._historyFrame>0&&--this._historyFrame,this.refreshTokens(),this.fixCursor(),this.render()}},{key:"scrollIntoView",value:function(e){this.scroll.y+=this.minDelta(e.y,this.scroll.y,this.scroll.y+this.gridBounds.height),this.wordWrap||(this.scroll.x+=this.minDelta(e.x,this.scroll.x,this.scroll.x+this.gridBounds.width)),this.clampScroll()}},{key:"readWheel",value:function(e){this.focused&&((e.shiftKey||isChrome)&&(this.fontSize+=-e.deltaX/o),e.shiftKey&&!isChrome||(this.scroll.y+=Math.floor(e.deltaY*this._wheelScrollSpeed/o)),this.clampScroll(),this.render(),e.preventDefault())}},{key:"startPointer",value:function(e,t){r(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"startPointer",this).call(this,e,t)||(this._dragging=!0,this.setCursorXY(this.frontCursor,e,t))}},{key:"movePointer",value:function(e,t){this._dragging&&this.setCursorXY(this.backCursor,e,t)}},{key:"endPointer",value:function(){r(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"endPointer",this).call(this),this._dragging=!1,this._scrolling=!1}},{key:"copySelectedText",value:function(e){if(this.focused&&this.frontCursor.i!==this.backCursor.i){var t=e.clipboardData||window.clipboardData;t.setData(window.clipboardData?"Text":"text/plain",this.selectedText),e.returnValue=!1}}},{key:"cutSelectedText",value:function(e){this.focused&&(this.copySelectedText(e),this.readOnly||(this.selectedText=""))}},{key:"execCommand",value:function(e,t,n){if(n&&this.focused&&!this.readOnly){var r=e+"_"+n,i=this.commandPack[r]||this.commandPack[n]||t[r]||t[n];return(i instanceof String||"string"==typeof i)&&(console.log("okay"),i=this.commandPack[i]||this.commandPack[i]||i),void 0!==i&&(this.frontCursor.moved=!1,this.backCursor.moved=!1,i instanceof Function?i(this,this.lines):(i instanceof String||"string"==typeof i)&&(console.log(i),this.selectedText=i),this.frontCursor.moved&&!this.backCursor.moved&&this.backCursor.copy(this.frontCursor),this.clampScroll(),this.render(),!0)}}},{key:"readClipboard",value:function(e){if(this.focused&&!this.readOnly){e.returnValue=!1;var t=e.clipboardData||window.clipboardData,n=t.getData(window.clipboardData?"Text":"text/plain");n&&(this.selectedText=n)}}},{key:"resize",value:function(){r(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"resize",this).call(this),this._bg.setSize(this.surfaceWidth,this.surfaceHeight),this._fg.setSize(this.surfaceWidth,this.surfaceHeight),this._trim.setSize(this.surfaceWidth,this.surfaceHeight),this.theme&&(this.character.height=this.fontSize,this.context.font=this.character.height+"px "+this.theme.fontFamily,this.character.width=this.context.measureText("MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM").width/100),this.render()}},{key:"pixel2cell",value:function(e){e.x*this.imageWidth/this.surfaceWidth,e.y*this.imageHeight/this.surfaceHeight;e.set(Math.round(e.x/this.character.width)+this.scroll.x-this.gridBounds.x,Math.floor(e.y/this.character.height-.25)+this.scroll.y)}},{key:"clampScroll",value:function(){if(this.scroll.y<0)this.scroll.y=0;else for(;0<this.scroll.y&&this.scroll.y>this.lines.length-this.gridBounds.height;)--this.scroll.y}},{key:"refreshTokens",value:function(){this.tokens=this.tokenizer.tokenize(this.value)}},{key:"fixCursor",value:function(){var e=this.frontCursor.fixCursor(this.lines)||this.backCursor.fixCursor(this.lines);e&&this.render()}},{key:"setCursorXY",value:function(e,t,n){t=Math.round(t),n=Math.round(n),this._pointer.set(t,n),this.pixel2cell(this._pointer,this.scroll,this.gridBounds);var r=this._pointer.x-this.scroll.x,i=this._pointer.y-this.scroll.y,o=i>=this.gridBounds.height,s=r<0,a=this._pointer.x>=this.gridBounds.width;if(this._scrolling||o||s||a){if(this._scrolling||a&&!o){this._scrolling=!0;var c=this.lines.length-this.gridBounds.height;if(i>=0&&c>=0){var u=i*c/this.gridBounds.height;this.scroll.y=Math.floor(u)}}else if(o&&!s){for(var l=0,h=0;h<this.lines.length;++h)l=Math.max(l,this.lines[h].length);var d=l-this.gridBounds.width;if(r>=0&&d>=0){var p=r*d/this.gridBounds.width;this.scroll.x=Math.floor(p)}}}else e.setXY(this._pointer.x,this._pointer.y,this.lines),this.backCursor.copy(e);this._lastPointer.copy(this._pointer),this.render()}},{key:"mouseButtonDown",value:function(e){0===e.button&&(this.startDOMPointer(e),e.preventDefault())}},{key:"mouseMove",value:function(e){this.focused&&this.moveDOMPointer(e)}},{key:"mouseButtonUp",value:function(e){this.focused&&0===e.button&&this.endPointer()}},{key:"touchStart",value:function(e){if(this.focused&&e.touches.length>0&&!this._dragging){var t=e.touches[0];this.startDOMPointer(t),this._currentTouchID=t.identifier}}},{key:"touchMove",value:function(e){for(var t=0;t<e.changedTouches.length&&this._dragging;++t){var n=e.changedTouches[t];if(n.identifier===this._currentTouchID){this.moveDOMPointer(n);break}}}},{key:"touchEnd",value:function(e){for(var t=0;t<e.changedTouches.length&&this._dragging;++t){var n=e.changedTouches[t];n.identifier===this._currentTouchID&&this.endPointer()}}},{key:"setGutter",value:function(){this.showLineNumbers?this._topLeftGutter.width=1:this._topLeftGutter.width=0,this.showScrollBars?this.wordWrap?this._bottomRightGutter.set(this._VSCROLL_WIDTH,0):this._bottomRightGutter.set(this._VSCROLL_WIDTH,1):this._bottomRightGutter.set(0,0)}},{key:"refreshGridBounds",value:function(){this._lineCountWidth=0,this.showLineNumbers&&(this._lineCountWidth=Math.max(1,Math.ceil(Math.log(this._history[this._historyFrame].length)/Math.LN10)));var e=Math.floor(this._topLeftGutter.width+this._lineCountWidth+this.padding/this.character.width),t=Math.floor(this.padding/this.character.height),n=Math.floor((this.imageWidth-2*this.padding)/this.character.width)-e-this._bottomRightGutter.width,r=Math.floor((this.imageHeight-2*this.padding)/this.character.height)-t-this._bottomRightGutter.height;this.gridBounds.set(e,t,n,r)}},{key:"performLayout",value:function(){this._tokenRows=[[]],this._tokenHashes=[""],this.lines=[""];for(var e=0,t=this.tokens.slice(),n=0;n<t.length;++n){var r=t[n].clone(),i=this.gridBounds.width-e,o=this.wordWrap&&"newlines"!==r.type&&r.value.length>i,s="newlines"===r.type||o;if(o){var a=r.value.length>this.gridBounds.width?i:0;t.splice(n+1,0,r.splitAt(a))}r.value.length>0&&(this._tokenRows[this._tokenRows.length-1].push(r),
this._tokenHashes[this._tokenHashes.length-1]+=JSON.stringify(r),this.lines[this.lines.length-1]+=r.value,e+=r.value.length),s&&(this._tokenRows.push([]),this._tokenHashes.push(""),this.lines.push(""),e=0)}}},{key:"minDelta",value:function(e,t,n){var r=e-t,i=e-n+5,o=0;return(r<0||i>=0)&&(o=Math.abs(r)<Math.abs(i)?r:i),o}},{key:"fillRect",value:function(e,t,n,r,i,o){e.fillStyle=t,e.fillRect(n*this.character.width,r*this.character.height,i*this.character.width+1,o*this.character.height+1)}},{key:"strokeRect",value:function(e,t,n,r,i,o){e.strokeStyle=t,e.strokeRect(n*this.character.width,r*this.character.height,i*this.character.width+1,o*this.character.height+1)}},{key:"renderCanvasBackground",value:function(){var e=Primrose.Text.Cursor.min(this.frontCursor,this.backCursor),t=Primrose.Text.Cursor.max(this.frontCursor,this.backCursor),n=new Primrose.Text.Cursor,r=new Primrose.Text.Cursor,i=this.theme.regular.backColor?"fillRect":"clearRect",o=a/this.character.height;this.theme.regular.backColor&&(this._bgfx.fillStyle=this.theme.regular.backColor),this._bgfx[i](0,0,this.imageWidth,this.imageHeight),this._bgfx.save(),this._bgfx.translate((this.gridBounds.x-this.scroll.x)*this.character.width+this.padding,-this.scroll.y*this.character.height+this.padding),this.focused&&this.fillRect(this._bgfx,this.theme.regular.currentRowBackColor||Primrose.Text.Themes.Default.regular.currentRowBackColor,0,e.y+o,this.gridBounds.width,t.y-e.y+1);for(var s=0;s<this._tokenRows.length;++s){for(var c=this._tokenRows[s],u=0;u<c.length;++u){var l=c[u];if(r.x+=l.value.length,r.i+=l.value.length,this.scroll.y<=s&&s<this.scroll.y+this.gridBounds.height&&this.scroll.x<=r.x&&n.x<this.scroll.x+this.gridBounds.width){var h=e.i<=r.i&&n.i<t.i;if(h){var d=Primrose.Text.Cursor.max(e,n),p=Primrose.Text.Cursor.min(t,r),m=p.i-d.i;this.fillRect(this._bgfx,this.theme.regular.selectedBackColor||Primrose.Text.Themes.Default.regular.selectedBackColor,d.x,d.y+o,m,1)}}n.copy(r)}n.x=0,++n.y,r.copy(n)}if(this.focused){var f=this.theme.cursorColor||"black",y=1/this.character.width;this.fillRect(this._bgfx,f,e.x,e.y+o,y,1),this.fillRect(this._bgfx,f,t.x,t.y+o,y,1)}this._bgfx.restore()}},{key:"renderCanvasForeground",value:function(){var e=new Primrose.Text.Cursor,t=new Primrose.Text.Cursor;this._fgfx.clearRect(0,0,this.imageWidth,this.imageHeight),this._fgfx.save(),this._fgfx.translate((this.gridBounds.x-this.scroll.x)*this.character.width+this.padding,this.padding);for(var n=0;n<this._tokenRows.length;++n){for(var r=this.lines[n]+this.padding,i=this._tokenRows[n],o=!1,s=(n-this.scroll.y)*this.character.height,c=0;c<i.length;++c){var u=i[c];if(t.x+=u.value.length,t.i+=u.value.length,this.scroll.y<=n&&n<this.scroll.y+this.gridBounds.height&&this.scroll.x<=t.x&&e.x<this.scroll.x+this.gridBounds.width)if(this.useCaching&&void 0!==this._rowCache[r])0===c&&this._fgfx.putImageData(this._rowCache[r],this.padding,s+this.padding+a);else{var l=this.theme[u.type]||{},h=(l.fontWeight||this.theme.regular.fontWeight||"")+" "+(l.fontStyle||this.theme.regular.fontStyle||"")+" "+this.character.height+"px "+this.theme.fontFamily;this._fgfx.font=h.trim(),this._fgfx.fillStyle=l.foreColor||this.theme.regular.foreColor,this.drawText(this._fgfx,u.value,e.x*this.character.width,s),o=!0}e.copy(t)}e.x=0,++e.y,t.copy(e),this.useCaching&&o&&void 0===this._rowCache[r]&&(this._rowCache[r]=this._fgfx.getImageData(this.padding,s+this.padding+a,this.imageWidth-2*this.padding,this.character.height))}this._fgfx.restore()}},{key:"drawText",value:function(e,t,n,r){e.fillText(t,n,r)}},{key:"renderCanvasTrim",value:function(){var e=new Primrose.Text.Cursor,t=new Primrose.Text.Cursor,n=0;this._tgfx.clearRect(0,0,this.imageWidth,this.imageHeight),this._tgfx.save(),this._tgfx.translate(this.padding,this.padding),this._tgfx.save(),this._tgfx.lineWidth=2,this._tgfx.translate(0,-this.scroll.y*this.character.height);for(var r=0,i=-1;r<this._tokenRows.length;++r){for(var o=this._tokenRows[r],s=0;s<o.length;++s){var a=o[s];t.x+=a.value.length,t.i+=a.value.length,e.copy(t)}if(n=Math.max(n,t.x),e.x=0,++e.y,t.copy(e),this.showLineNumbers&&this.scroll.y<=r&&r<this.scroll.y+this.gridBounds.height){for(var c=o.length>0?o[0].line:i+1,u=c.toString();u.length<this._lineCountWidth;)u=" "+u;this.fillRect(this._tgfx,this.theme.regular.selectedBackColor||Primrose.Text.Themes.Default.regular.selectedBackColor,0,r,this.gridBounds.x,1),this._tgfx.font="bold "+this.character.height+"px "+this.theme.fontFamily,c>i&&(this._tgfx.fillStyle=this.theme.regular.foreColor,this._tgfx.fillText(u,0,r*this.character.height)),i=c}}if(this._tgfx.restore(),this.showLineNumbers&&this.strokeRect(this._tgfx,this.theme.regular.foreColor||Primrose.Text.Themes.Default.regular.foreColor,0,0,this.gridBounds.x,this.gridBounds.height),this.showScrollBars){var l=this.gridBounds.width*this.character.width-this.padding,h=this.gridBounds.height*this.character.height,d=this.scroll.x*l/n+this.gridBounds.x*this.character.width,p=this.scroll.y*h/this._tokenRows.length;this._tgfx.fillStyle=this.theme.regular.selectedBackColor||Primrose.Text.Themes.Default.regular.selectedBackColor;var m;if(!this.wordWrap&&n>this.gridBounds.width){var f=l*(this.gridBounds.width/n),y=this.gridBounds.height*this.character.height;m=Math.max(this.character.width,f),this._tgfx.fillRect(d,y,m,this.character.height),this._tgfx.strokeRect(d,y,m,this.character.height)}if(this._tokenRows.length>this.gridBounds.height){var g=h*(this.gridBounds.height/this._tokenRows.length),v=this.image-this._VSCROLL_WIDTH*this.character.width-2*this.padding,w=Math.max(this.character.height,g);m=this._VSCROLL_WIDTH*this.character.width,this._tgfx.fillRect(v,p,m,w),this._tgfx.strokeRect(v,p,m,w)}}this._tgfx.lineWidth=2,this._tgfx.restore(),this._tgfx.strokeRect(1,1,this.imageWidth-2,this.imageHeight-2),this.focused||(this._tgfx.fillStyle=this.theme.regular.unfocused||Primrose.Text.Themes.Default.regular.unfocused,this._tgfx.fillRect(0,0,this.imageWidth,this.imageHeight))}},{key:"render",value:function(){if(this.tokens&&this.theme){this.refreshGridBounds();var e=this.gridBounds.toString()!==this._lastGridBounds,t=this._lastText!==this.value,n=this.character.width!==this._lastCharacterWidth,r=this.character.height!==this._lastCharacterHeight,i=this.padding!==this._lastPadding,o=!this._lastFrontCursor||!this._lastBackCursor||this.frontCursor.i!==this._lastFrontCursor.i||this._lastBackCursor.i!==this.backCursor.i,s=this.scroll.x!==this._lastScrollX||this.scroll.y!==this._lastScrollY,a=(this.context.font!==this._lastFont,this.theme.name!==this._lastThemeName),c=this.focused!==this._lastFocused,u=null,l=this.resized||e||t||n||r||i,h=l||o||s||a,d=h||t,p=h||c,m=d||h||p;if(l&&(this.performLayout(this.gridBounds),this._rowCache={}),m){if(o&&!(l||s||a||c)){var f=Math.min(this.frontCursor.y,this._lastFrontCursor.y,this.backCursor.y,this._lastBackCursor.y)-this.scroll.y+this.gridBounds.y,y=Math.max(this.frontCursor.y,this._lastFrontCursor.y,this.backCursor.y,this._lastBackCursor.y)-this.scroll.y+1;u=new Primrose.Text.Rectangle(0,f*this.character.height,this.bounds.width,(y-f)*this.character.height+2)}h&&this.renderCanvasBackground(),d&&this.renderCanvasForeground(),p&&this.renderCanvasTrim(),this.context.clearRect(0,0,this.imageWidth,this.imageHeight),this.context.drawImage(this._bgCanvas,0,0),this.context.drawImage(this._fgCanvas,0,0),this.context.drawImage(this._trimCanvas,0,0),this.invalidate(u)}this._lastGridBounds=this.gridBounds.toString(),this._lastText=this.value,this._lastCharacterWidth=this.character.width,this._lastCharacterHeight=this.character.height,this._lastWidth=this.imageWidth,this._lastHeight=this.imageHeight,this._lastPadding=this.padding,this._lastFrontCursor=this.frontCursor.clone(),this._lastBackCursor=this.backCursor.clone(),this._lastFocused=this.focused,this._lastFont=this.context.font,this._lastThemeName=this.theme.name,this._lastScrollX=this.scroll.x,this._lastScrollY=this.scroll.y}}},{key:"value",get:function(){return this._history[this._historyFrame].join("\n")},set:function(e){e=e||"",e=e.replace(/\r\n/g,"\n"),this.multiline||(e=e.replace(/\n/g,""));var t=e.split("\n");this.pushUndo(t),this.render(),emit.call(this,"change",{target:this})}},{key:"selectedText",get:function(){var e=Primrose.Text.Cursor.min(this.frontCursor,this.backCursor),t=Primrose.Text.Cursor.max(this.frontCursor,this.backCursor);return this.value.substring(e.i,t.i)},set:function(e){if(e=e||"",e=e.replace(/\r\n/g,"\n"),this.frontCursor.i!==this.backCursor.i||e.length>0){var t=Primrose.Text.Cursor.min(this.frontCursor,this.backCursor),n=Primrose.Text.Cursor.max(this.frontCursor,this.backCursor),r=this.value,i=r.substring(0,t.i),o=r.substring(n.i),s=i+e+o;this.value=s,this.refreshGridBounds(),this.performLayout(),t.advanceN(this.lines,Math.max(0,e.length)),this.scrollIntoView(n),this.clampScroll(),n.copy(t),this.render()}}},{key:"padding",get:function(){return this._padding},set:function(e){this._padding=e,this.render()}},{key:"wordWrap",get:function(){return this._wordWrap},set:function(e){this._wordWrap=e||!1,this.setGutter()}},{key:"showLineNumbers",get:function(){return this._showLineNumbers},set:function(e){this._showLineNumbers=e,this.setGutter()}},{key:"showScrollBars",get:function(){return this._showScrollBars},set:function(e){this._showScrollBars=e,this.setGutter()}},{key:"theme",get:function(){return this._theme},set:function(e){this._theme=clone(e||Primrose.Text.Themes.Default),this._theme.fontSize=this.fontSize,this._rowCache={},this.render()}},{key:"commandPack",get:function(){return this._commandPack},set:function(e){this._commandPack=e}},{key:"selectionStart",get:function(){return this.frontCursor.i},set:function(e){this.frontCursor.setI(e,this.lines)}},{key:"selectionEnd",get:function(){return this.backCursor.i},set:function(e){this.backCursor.setI(e,this.lines)}},{key:"selectionDirection",get:function(){return this.frontCursor.i<=this.backCursor.i?"forward":"backward"}},{key:"tokenizer",get:function(){return this._tokenizer},set:function(e){this._tokenizer=e||Primrose.Text.Grammars.JavaScript,this._history&&this._history.length>0&&(this.refreshTokens(),this.render())}},{key:"tabWidth",get:function(){return this._tabWidth},set:function(e){this._tabWidth=e||2,this._tabString="";for(var t=0;t<this._tabWidth;++t)this._tabString+=" "}},{key:"tabString",get:function(){return this._tabString}},{key:"fontSize",get:function(){return this._fontSize||16},set:function(e){e=e||16,this._fontSize=e,this.theme&&(this.theme.fontSize=this._fontSize,this.resize(),this.render())}},{key:"lockMovement",get:function(){return this.focused&&!this.readOnly}}]),u}(Primrose.Surface);"undefined"!=typeof window&&(window.Primrose.Text.Controls.TextBox=c)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function e(t,n,r,i){var o=Object.getOwnPropertyDescriptor(t,n);if(void 0===o){var s=Object.getPrototypeOf(t);null!==s&&e(s,n,r,i)}else if("value"in o&&o.writable)o.value=r;else{var a=o.set;void 0!==a&&a.call(i,r)}return r},o=function e(t,n,r){null===t&&(t=Function.prototype);var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i)return i.value;var s=i.get;if(void 0!==s)return s.call(r)},s=0;pliny.class({parent:"Primrose.Text.Controls",name:"TextInput",description:"plain text input box.",baseClass:"Primrose.Text.Controls.TextBox",parameters:[{name:"idOrCanvasOrContext",type:"String or HTMLCanvasElement or CanvasRenderingContext2D",description:"Either an ID of an element that exists, an element, or the ID to set on an element that is to be created."},{name:"options",type:"Object",description:"Named parameters for creating the TextInput."}]});var a=function(a){function c(n){e(this,c);var r=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,copyObject(patch(n,{id:"Primrose.Text.Controls.TextInput["+s++ +"]",padding:5}),{singleLine:!0,disableWordWrap:!0,hideLineNumbers:!0,hideScrollBars:!0,tabWidth:1,tokenizer:Primrose.Text.Grammars.PlainText,commands:Primrose.Text.CommandPacks.TextInput},!0)));return r.passwordCharacter=r.options.passwordCharacter,r}return n(c,a),r(c,[{key:"drawText",value:function(e,t,n,r){if(this.passwordCharacter){for(var i="",s=0;s<t.length;++s)i+=this.passwordCharacter;t=i}o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"drawText",this).call(this,e,t,n,r)}},{key:"value",get:function(){return o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"value",this)},set:function(e){e=e||"",e=e.replace(/\r?\n/g,""),i(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"value",e,this)}},{key:"selectedText",get:function(){return o(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"selectedText",this)},set:function(e){e=e||"",e=e.replace(/\r?\n/g,""),i(c.prototype.__proto__||Object.getPrototypeOf(c.prototype),"selectedText",e,this)}}]),c}(Primrose.Text.Controls.TextBox);"undefined"!=typeof window&&(window.Primrose.Text.Controls.TextInput=a)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.Grammars",name:"Basic",description:"| [under construction]"});var Basic=new Primrose.Text.Grammar("BASIC",[["newlines",/(?:\r\n|\r|\n)/],["lineNumbers",/^\d+\s+/],["startLineComments",/^REM\s/],["strings",/"(?:\\"|[^"])*"/],["strings",/'(?:\\'|[^'])*'/],["numbers",/-?(?:(?:\b\d*)?\.)?\b\d+\b/],["keywords",/\b(?:RESTORE|REPEAT|RETURN|LOAD|LABEL|DATA|READ|THEN|ELSE|FOR|DIM|LET|IF|TO|STEP|NEXT|WHILE|WEND|UNTIL|GOTO|GOSUB|ON|TAB|AT|END|STOP|PRINT|INPUT|RND|INT|CLS|CLK|LEN)\b/],["keywords",/^DEF FN/],["operators",/(?:\+|;|,|-|\*\*|\*|\/|>=|<=|=|<>|<|>|OR|AND|NOT|MOD|\(|\)|\[|\])/],["identifiers",/\w+\$?/]]),oldTokenize=Basic.tokenize;Basic.tokenize=function(e){return oldTokenize.call(this,e.toUpperCase())},Basic.interpret=function(sourceCode,input,output,errorOut,next,clearScreen,loadFile,done){function toNum(e){return new Primrose.Text.Token(e.toString(),"numbers")}function toStr(e){return new Primrose.Text.Token('"'+e.replace("\n","\\n").replace('"','\\"')+'"',"strings")}function process(e){if(e&&e.length>0){var t=e.shift();if(t){if(commands.hasOwnProperty(t.value))return commands[t.value](e);if(!isNaN(t.value))return setProgramCounter([t]);if(state[t.value]||e.length>0&&"operators"===e[0].type&&"="===e[0].value)return e.unshift(t),translate(e);error("Unknown command. >>> "+t.value)}}return pauseBeforeComplete()}function error(e){errorOut("At line "+lineNumbers[counter]+": "+e)}function getLine(e){var t=lineNumbers[e],n=program[t];return n&&n.slice()}function evaluate(line){for(var script="",i=0;i<line.length;++i){var t=line[i],nest=0;if("identifiers"===t.type&&"function"!=typeof state[t.value]&&i<line.length-1&&"("===line[i+1].value)for(var j=i+1;j<line.length;++j){var t2=line[j];if("("===t2.value?(0===nest&&(t2.value="["),++nest):")"===t2.value?(--nest,0===nest&&(t2.value="]")):","===t2.value&&1===nest&&(t2.value="]["),0===nest)break}script+=t.value}try{return eval(script)}catch(e){console.error(e),console.debug(line.join(", ")),console.error(script),error(e.message+": "+script)}}function declareVariable(e){var t,n=[],r=[n],i=0;for(t=0;t<e.length;++t){var o=e[t];"("===o.value?++i:")"===o.value&&--i,0===i&&","===o.value?(n=[],r.push(n)):n.push(o)}for(t=0;t<r.length;++t){n=r[t];var s=n.shift();if("identifiers"===s.type){var a,c=null;if(s=s.value,"("===n[0].value&&")"===n[n.length-1].value){var u=[];for(a=1;a<n.length-1;++a)"numbers"===n[a].type&&u.push(0|n[a].value);if(0===u.length)c=[];else{c=new Array(u[0]);var l=[c];for(a=1;a<u.length;++a)for(var h=u[a],d=0,p=l.length;d<p;++d)for(var m=l.shift(),f=0;f<m.length;++f)m[f]=new Array(h),a<u.length-1&&l.push(m[f])}}return state[s]=c,!0}error("Identifier expected: "+s.value)}}function print(e){var t="\n",n=0;e=e.map(function(r,i){return r=r.clone(),"operators"===r.type&&(","===r.value?0===n&&(r.value='+ ", " + '):";"===r.value?(r.value='+ " "',i<e.length-1?r.value+=" + ":t=""):"("===r.value?++n:")"===r.value&&--n),r});var r=evaluate(e);return void 0===r&&(r=""),output(r+t),!0}function setProgramCounter(e){var t=parseFloat(evaluate(e));for(counter=-1;counter<lineNumbers.length-1&&lineNumbers[counter+1]<t;)++counter;return!0}function checkConditional(e){var t,n=-1,r=-1;for(t=0;t<e.length;++t)"keywords"===e[t].type&&"THEN"===e[t].value?n=t:"keywords"===e[t].type&&"ELSE"===e[t].value&&(r=t);if(n===-1)error("Expected THEN clause.");else{var i=e.slice(0,n);for(t=0;t<i.length;++t){var o=i[t];"operators"===o.type&&"="===o.value&&(o.value="==")}var s,a;if(r===-1?s=e.slice(n+1):(s=e.slice(n+1,r),a=e.slice(r+1)),evaluate(i))return process(s);if(a)return process(a)}return!0}function pauseBeforeComplete(){return output("PROGRAM COMPLETE - PRESS RETURN TO FINISH."),input(function(){isDone=!0,done&&done()}),!1}function labelLine(e){return e.push(EQUAL_SIGN),e.push(toNum(lineNumbers[counter])),translate(e)}function waitForInput(e){var t=e.pop();return e.length>0&&print(e),input(function(e){e=e.toUpperCase();var n=null;n=isNaN(e)?toStr(e):toNum(e),evaluate([t,EQUAL_SIGN,n]),next&&next()}),!1}function onStatement(e){var t=[],n=null,r=[];try{for(;e.length>0&&("keywords"!==e[0].type||"GOTO"!==e[0].value);)t.push(e.shift());if(e.length>0){e.shift();for(var i=0;i<e.length;++i){var o=e[i];"operators"===o.type&&","===o.value||r.push(o)}if(n=evaluate(t)-1,0<=n&&n<r.length)return setProgramCounter([r[n]])}}catch(e){console.error(e)}return!0}function gotoSubroutine(e){return returnStack.push(toNum(lineNumbers[counter+1])),setProgramCounter(e)}function setRepeat(){return returnStack.push(toNum(lineNumbers[counter])),!0}function conditionalReturn(e){var t=!0,n=returnStack.pop();return n&&e&&(t=setProgramCounter([n])),t}function untilLoop(e){var t=!evaluate(e);return conditionalReturn(t)}function findNext(e){for(i=counter+1;i<lineNumbers.length;++i){var t=getLine(i);if(t[0].value===e)return i}return lineNumbers.length}function whileLoop(e){var t=evaluate(e);return t?returnStack.push(toNum(lineNumbers[counter])):counter=findNext("WEND"),!0}function forLoop(e){var t=lineNumbers[counter],n=[],r=[],i=[],o=[],s=[n,r,i,o],a=0,c=0;for(c=0;c<e.length;++c){var u=e[c];u.value===FOR_LOOP_DELIMS[a]?(0===a&&n.push(u),++a):s[a].push(u)}var l=1;o.length>0&&(l=evaluate(o)),void 0===forLoopCounters[t]&&(forLoopCounters[t]=evaluate(r));var h=evaluate(i),d=forLoopCounters[t]<=h;return d?(n.push(toNum(forLoopCounters[t])),process(n),forLoopCounters[t]+=l,returnStack.push(toNum(lineNumbers[counter]))):(delete forLoopCounters[t],counter=findNext("NEXT")),!0}function stackReturn(){return conditionalReturn(!0)}function loadCodeFile(e){return loadFile(evaluate(e)).then(next),!1}function noop(){return!0}function loadData(e){for(;e.length>0;){var t=e.shift();"operators"!==t.type&&data.push(t.value)}return!0}function readData(e){if(0===data.length){var t=findNext("DATA");process(getLine(t))}var n=data[dataCounter];return++dataCounter,e.push(EQUAL_SIGN),e.push(toNum(n)),translate(e)}function restoreData(){return dataCounter=0,!0}function defineFunction(line){for(var name=line.shift().value,signature="",body="",fillSig=!0,i=0;i<line.length;++i){var t=line[i];"operators"===t.type&&"="===t.value?fillSig=!1:fillSig?signature+=t.value:body+=t.value}name="FN"+name;var script="(function "+name+signature+"{ return "+body+"; })";return state[name]=eval(script),!0}function translate(e){return evaluate(e),!0}for(var tokens=this.tokenize(sourceCode),EQUAL_SIGN=new Primrose.Text.Token("=","operators"),counter=0,isDone=!1,program={},lineNumbers=[],currentLine=[],lines=[currentLine],data=[],returnStack=[],forLoopCounters={},dataCounter=0,state={INT:function(e){return 0|e},RND:function(){return Math.random()},CLK:function(){return Date.now()/36e5},LEN:function(e){return e.length},LINE:function(){return lineNumbers[counter]},TAB:function(e){for(var t="",n=0;n<e;++n)t+=" ";return t},POW:function(e,t){return Math.pow(e,t)}},tokenMap={OR:"||",AND:"&&",NOT:"!",MOD:"%","<>":"!="};tokens.length>0;){var token=tokens.shift();"newlines"===token.type?(currentLine=[],lines.push(currentLine)):"regular"!==token.type&&"comments"!==token.type&&(token.value=tokenMap[token.value]||token.value,currentLine.push(token))}for(var i=0;i<lines.length;++i){var line=lines[i];if(line.length>0){var lastLine=lineNumbers[lineNumbers.length-1],lineNumber=line.shift();if("lineNumbers"!==lineNumber.type&&(line.unshift(lineNumber),void 0===lastLine&&(lastLine=-1),lineNumber=toNum(lastLine+1)),lineNumber=parseFloat(lineNumber.value),lastLine&&lineNumber<=lastLine)throw new Error("expected line number greater than "+lastLine+", but received "+lineNumber+".");line.length>0&&(lineNumbers.push(lineNumber),program[lineNumber]=line)}}var FOR_LOOP_DELIMS=["=","TO","STEP"],commands={DIM:declareVariable,LET:translate,PRINT:print,GOTO:setProgramCounter,IF:checkConditional,INPUT:waitForInput,END:pauseBeforeComplete,STOP:pauseBeforeComplete,REM:noop,"'":noop,CLS:clearScreen,ON:onStatement,GOSUB:gotoSubroutine,RETURN:stackReturn,LOAD:loadCodeFile,DATA:loadData,READ:readData,RESTORE:restoreData,REPEAT:setRepeat,UNTIL:untilLoop,"DEF FN":defineFunction,WHILE:whileLoop,WEND:stackReturn,FOR:forLoop,NEXT:stackReturn,LABEL:labelLine};return function(){if(!isDone)for(var e=!0;e;){var t=getLine(counter);e=process(t),++counter}}},"undefined"!=typeof window&&(window.Primrose.Text.Grammars.Basic=Basic)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.Grammars",name:"JavaScript",description:"| [under construction]"});var e=new Primrose.Text.Grammar("JavaScript",[["newlines",/(?:\r\n|\r|\n)/],["startBlockComments",/\/\*/],["endBlockComments",/\*\//],["regexes",/(?:^|,|;|\(|\[|\{)(?:\s*)(\/(?:\\\/|[^\n\/])+\/)/],["stringDelim",/("|')/],["startLineComments",/\/\/.*$/m],["numbers",/-?(?:(?:\b\d*)?\.)?\b\d+\b/],["keywords",/\b(?:break|case|catch|const|continue|debugger|default|delete|do|else|export|finally|for|function|if|import|in|instanceof|let|new|return|super|switch|this|throw|try|typeof|var|void|while|with)\b/],["functions",/(\w+)(?:\s*\()/],["members",/(\w+)\./],["members",/((\w+\.)+)(\w+)/]]);"undefined"!=typeof window&&(window.Primrose.Text.Grammars.JavaScript=e)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.Grammars",name:"PlainText",description:"| [under construction]"});var e=new Primrose.Text.Grammar("PlainText",[["newlines",/(?:\r\n|\r|\n)/]]);"undefined"!=typeof window&&(window.Primrose.Text.Grammars.PlainText=e)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.Grammars",name:"TestResults",description:"| [under construction]"});var e=new Primrose.Text.Grammar("TestResults",[["newlines",/(?:\r\n|\r|\n)/,!0],["numbers",/(\[)(o+)/,!0],["numbers",/(\d+ succeeded), 0 failed/,!0],["numbers",/^    Successes:/,!0],["functions",/(x+)\]/,!0],["functions",/[1-9]\d* failed/,!0],["functions",/^    Failures:/,!0],["comments",/(\d+ms:)(.*)/,!0],["keywords",/(Test results for )(\w+):/,!0],["strings",/        \w+/,!0]]);"undefined"!=typeof window&&(window.Primrose.Text.Grammars.TestResults=e)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.OperatingSystems",name:"OSX",description:"| [under construction]"});var e=new Primrose.Text.OperatingSystem("OS X","META","ALT","METASHIFT_z","META","LEFTARROW","RIGHTARROW","META","UPARROW","DOWNARROW");"undefined"!=typeof window&&(window.Primrose.Text.OperatingSystems.OSX=e)}(),function(){"use strict";pliny.value({parent:"Primrose.Text.OperatingSystems",name:"OSX",description:"| [under construction]"});var e=new Primrose.Text.OperatingSystem("Windows","CTRL","CTRL","CTRL_y","","HOME","END","CTRL","HOME","END");"undefined"!=typeof window&&(window.Primrose.Text.OperatingSystems.Windows=e)}(),function(){"use strict";pliny.record({parent:"Primrose.Text.Themes",name:"Dark",description:"| [under construction]"});var e={name:"Dark",fontFamily:"'Droid Sans Mono', 'Consolas', 'Lucida Console', 'Courier New', 'Courier', monospace",cursorColor:"white",fontSize:16,lineNumbers:{foreColor:"white"},regular:{backColor:"black",foreColor:"#c0c0c0",currentRowBackColor:"#202020",selectedBackColor:"#404040",unfocused:"rgba(0, 0, 255, 0.25)"},strings:{foreColor:"#aa9900",fontStyle:"italic"},regexes:{foreColor:"#aa0099",fontStyle:"italic"},numbers:{foreColor:"green"},comments:{foreColor:"yellow",fontStyle:"italic"},keywords:{foreColor:"cyan"},functions:{foreColor:"brown",fontWeight:"bold"},members:{foreColor:"green"},error:{foreColor:"red",fontStyle:"underline italic"}};"undefined"!=typeof window&&(window.Primrose.Text.Themes.Dark=e)}(),function(){"use strict";pliny.record({parent:"Primrose.Text.Themes",name:"Default",description:"| [under construction]"});var e={name:"Light",fontFamily:"'Droid Sans Mono', 'Consolas', 'Lucida Console', 'Courier New', 'Courier', monospace",cursorColor:"black",fontSize:16,lineNumbers:{foreColor:"black"},regular:{backColor:"white",foreColor:"black",currentRowBackColor:"#f0f0f0",selectedBackColor:"#c0c0c0",unfocused:"rgba(0, 0, 255, 0.25)"},strings:{foreColor:"#aa9900",fontStyle:"italic"},regexes:{foreColor:"#aa0099",fontStyle:"italic"},numbers:{foreColor:"green"},comments:{foreColor:"grey",fontStyle:"italic"},keywords:{foreColor:"blue"},functions:{foreColor:"brown",fontWeight:"bold"},members:{foreColor:"green"},error:{foreColor:"red",fontStyle:"underline italic"}};"undefined"!=typeof window&&(window.Primrose.Text.Themes.Default=e)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=0,o=512,s=150;pliny.class({parent:"Primrose.X",name:"LoginForm",baseClass:"Primrose.Controls.Form",description:"A basic authentication form."});var a=function(a){function c(){e(this,c);var n=t(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,{id:"Primrose.X.LoginForm["+i++ +"]",bounds:new Primrose.Text.Rectangle(0,0,o,s)}));return n.listeners.login=[],n.listeners.signup=[],n.labelUserName=new Primrose.Controls.AbstractLabel({id:n.id+"-labelUserName",bounds:new Primrose.Text.Rectangle(0,0,o/2,s/3),fontSize:32,value:"User name:",textAlign:"right"}),n.userName=new Primrose.Text.Controls.TextInput({id:n.id+"-userName",bounds:new Primrose.Text.Rectangle(o/2,0,o/2,s/3),fontSize:32}),n.labelPassword=new Primrose.Controls.AbstractLabel({id:n.id+"-labelPassword",bounds:new Primrose.Text.Rectangle(0,s/3,o/2,s/3),fontSize:32,value:"Password:",textAlign:"right"}),n.password=new Primrose.Text.Controls.TextInput({id:n.id+"-password",bounds:new Primrose.Text.Rectangle(o/2,s/3,o/2,s/3),fontSize:32,passwordCharacter:"*"}),n.signupButton=new Primrose.Controls.Button2D({id:n.id+"-signupButton",bounds:new Primrose.Text.Rectangle(0,2*s/3,o/2,s/3),fontSize:32,value:"Sign up"}),n.loginButton=new Primrose.Controls.Button2D({id:n.id+"-loginButton",bounds:new Primrose.Text.Rectangle(o/2,2*s/3,o/2,s/3),fontSize:32,value:"Login"}),n.loginButton.addEventListener("click",function(e){return emit.call(n,"login",{target:n})},!1),n.signupButton.addEventListener("click",function(e){return emit.call(n,"signup",{target:n})},!1),n.appendChild(n.labelUserName),n.appendChild(n.userName),n.appendChild(n.labelPassword),n.appendChild(n.password),n.appendChild(n.signupButton),n.appendChild(n.loginButton),n}return n(c,a),r(c,null,[{key:"create",value:function(){return new c}}]),c}(Primrose.Controls.Form);"undefined"!=typeof window&&(window.Primrose.X.LoginForm=a)}(),function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}var r=512,i=200,o=0;pliny.class({parent:"Primrose.X",name:"SignupForm",baseClass:"Primrose.Controls.Form",description:"A basic registration form."});var s=function(s){function a(){e(this,a);var n=t(this,(a.__proto__||Object.getPrototypeOf(a)).call(this,{id:"Primrose.X.SignupForm["+o++ +"]",bounds:new Primrose.Text.Rectangle(0,0,r,i)}));return n.listeners.login=[],n.listeners.signup=[],n.labelEmail=new Primrose.Controls.AbstractLabel({id:n.id+"-labelEmail",bounds:new Primrose.Text.Rectangle(0,0,r/2,i/4),fontSize:32,value:"Email:",textAlign:"right"}),n.email=new Primrose.Text.Controls.TextInput({id:n.id+"-email",bounds:new Primrose.Text.Rectangle(r/2,0,r/2,i/4),fontSize:32}),n.labelUserName=new Primrose.Controls.AbstractLabel({id:n.id+"-labelUserName",bounds:new Primrose.Text.Rectangle(0,i/4,r/2,i/4),fontSize:32,value:"User name:",textAlign:"right"}),n.userName=new Primrose.Text.Controls.TextInput({id:n.id+"-userName",bounds:new Primrose.Text.Rectangle(r/2,i/4,r/2,i/4),fontSize:32}),n.labelPassword=new Primrose.Controls.AbstractLabel({id:n.id+"-labelPassword",bounds:new Primrose.Text.Rectangle(0,i/2,r/2,i/4),fontSize:32,value:"Password:",textAlign:"right"}),n.password=new Primrose.Text.Controls.TextInput({id:n.id+"-password",bounds:new Primrose.Text.Rectangle(r/2,i/2,r/2,i/4),fontSize:32,passwordCharacter:"*"}),n.loginButton=new Primrose.Controls.Button2D({id:n.id+"-loginButton",bounds:new Primrose.Text.Rectangle(0,3*i/4,r/2,i/4),fontSize:32,value:"Log in"}),n.signupButton=new Primrose.Controls.Button2D({id:n.id+"-signupButton",bounds:new Primrose.Text.Rectangle(r/2,3*i/4,r/2,i/4),fontSize:32,value:"Sign up"}),n.loginButton.addEventListener("click",function(e){return emit.call(n,"login",{target:n})},!1),n.signupButton.addEventListener("click",function(e){return emit.call(n,"signup",{target:n})},!1),n.appendChild(n.labelUserName),n.appendChild(n.userName),n.appendChild(n.labelEmail),n.appendChild(n.email),n.appendChild(n.labelPassword),n.appendChild(n.password),n.appendChild(n.loginButton),n.appendChild(n.signupButton),n}return n(a,s),a}(Primrose.Controls.Form);"undefined"!=typeof window&&(window.Primrose.X.SignupForm=s)}(),function(){"use strict";function e(e,t){var n=this.toString(t);n!==this.lastVal&&(this.lastVal=n,console.log(e+"\n"+n))}"undefined"!=typeof window&&(window.THREE.Matrix4.prototype.debug=e)}(),function(){"use strict";function e(e){this.transpose();var t=this.toArray();void 0!==e&&(t=t.map(function(t){return t.toFixed(e)}));for(var n="",r=0;r<t.length;++r)r%4===0&&(n+="| "),n+=t[r],n+=r%4===3?" |\n":", ";return this.transpose(),
n}pliny.method({parent:"THREE.Matrix4",name:"toString ",description:"A polyfill method for printing objects.",parameters:[{name:"digits",type:"Number",description:"the number of significant figures to print."}]}),"undefined"!=typeof window&&(window.THREE.Matrix4.prototype.toString=e)}(),function(){"use strict";function e(e,t){var n=this;t.add(this),pliny.method({parent:"THREE.Object3D",name:"appendChild",description:"A polyfill method for being able to add the object to a `Primrose.BrowserEnvironment` using `appendChild()` and to add other elements to the Object3D using `appendChild()` such that they may be pickable in the scene.",parameters:[{name:"child",type:"Object",description:"Any Primrose.Entity or THREE.Object3D to add to this object."}]}),this.appendChild=function(t){return t.addToBrowserEnvironment?t.addToBrowserEnvironment(e,n):(n.add(t),e.registerPickableObject(t),t)}}pliny.method({parent:"THREE.Object3D",name:"addToBrowserEnvironment",description:"A polyfill method for being able to add the object to a `Primrose.BrowserEnvironment` using `appendChild()` and to add other elements to the Object3D using `appendChild()` such that they may be pickable in the scene. This half of the polyfill implements the visitor pattern, so that individual objects can define their own processing for this action.",parameters:[{name:"env",type:"Primrose.BrowserEnvironment",description:"The environment (with collision detection and ray-picking capability) to which to register objects"},{name:"scene",type:"THREE.Object3D",description:"The true parent element for `this` object"}]}),"undefined"!=typeof window&&(window.THREE.Object3D.prototype.addToBrowserEnvironment=e)}(),function(){"use strict";function e(e,t){var n=this.toString(t);n!==this.lastVal&&(this.lastVal=n,console.log(e,n))}"undefined"!=typeof window&&(window.THREE.Quaternion.prototype.debug=e)}(),function(){"use strict";function e(e){var t=this.toArray();if(void 0!==e)for(var n=0;n<t.length;++n)null!==t[n]&&void 0!==t[n]?t[n]=t[n].toFixed(e):t[n]="undefined";return"{"+t.join(", ")+"}"}pliny.method({parent:"THREE.Quaternion",name:"toString ",description:"A polyfill method for printing objects.",parameters:[{name:"digits",type:"Number",description:"the number of significant figures to print."}]}),"undefined"!=typeof window&&(window.THREE.Quaternion.prototype.toString=e)}(),function(){"use strict";function e(e,t){var n=this.toString(t);n!==this.lastVal&&(this.lastVal=n,console.log(e,n))}"undefined"!=typeof window&&(window.THREE.Vector3.prototype.debug=e)}(),function(){"use strict";function e(e){var t=this.toArray();return void 0!==e&&(t=t.map(function(t){return t.toFixed(e)})),"<"+t.join(", ")+">"}pliny.method({parent:"THREE.Vector3",name:"toString ",description:"A polyfill method for printing objects.",parameters:[{name:"digits",type:"Number",description:"the number of significant figures to print."}]}),"undefined"!=typeof window&&(window.THREE.Vector3.prototype.toString=e)}();